#include "../../proj/tl_common.h"
#include "../../proj_lib/rf_drv.h"
#include "../../proj_lib/pm.h"
#include "../../proj_lib/ble/ll/ll.h"
#include "../../proj_lib/ble/ll/ll_whitelist.h"
#include "../../proj/drivers/keyboard.h"
#include "../common/tl_audio.h"
#include "../common/blt_led.h"
#include "../../proj_lib/ble/trace.h"
#include "../../proj/mcu/pwm.h"
#include "../../proj_lib/ble/service/ble_ll_ota.h"
#include "../../proj/drivers/audio.h"
#include "../../proj/drivers/adc.h"
#include "../../proj_lib/ble/blt_config.h"
#include "../common/blt_soft_timer.h"
#include "../../proj_lib/ble/ble_smp.h"

#include "../../proj/drivers/uart.h"
#include "../../proj/mcu/putchar.h"
#include "../../proj/common/printf.h"

#include "app_config.h"



//#include "mouse_button.h"


/*******  Add mouse module ********/


#include "mouse.h"
#include "mouse_button.h"
#include "mouse_wheel.h"
#include "mouse_sensor_pix.h"
#include "mouse_sensor.h"

#include "mouse_custom.h"
#include "mouse_emi.h"
#include "drv_mouse_pmw3610.h"


#if ( __PROJECT_8261_MULTI_MOUSE__ )


#define  USER_TEST_BLT_SOFT_TIMER					1 //test soft timer

#define  AdvType_RX_RANDOM			0x80
#define  AdvType_TX_RANDOM			0x40


//MYFIFO_INIT(hci_rx_fifo, 72, 2);
//MYFIFO_INIT(hci_tx_fifo, 72, 4);

MYFIFO_INIT(blt_rxfifo, 64, 8);
MYFIFO_INIT(blt_txfifo, 40, 16);

/**    define variable param    **/


u8 signal_battery = 0;

extern blt_soft_timer_t	blt_timer;
//extern u32 smp_seq_req_tick;

//u8 SysMode = RF_2M_2P4G_MODE; 			//default mode is ble mode

extern mouse_status_t mouse_status;
extern mouse_sleep_t  mouse_sleep;
extern mouse_hw_t     mouse_hw;

u8 adv_direct_ind_flg;
u8 conn_deep_cnt;
u32 conn_deep_tick;

//addr_info_t master_per_info;

//device_scan_info_t device_scan_info;

#if (ADV_AUTO_SWITCH_FROM_DIR_TO_NODIR)
u8 direct_adv_info[2] = {BLT_ENABLE_ADV_ALL, 3};
#else
u8 direct_adv_info[2] = {BLT_ENABLE_ADV_ALL, 61};
#endif

extern st_ll_conn_slave_t		bltc;
smp_param_save_t  bondInfo;



////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////

#if(HID_MOUSE_ATT_ENABLE)

#if(MI_MOUSE_EN || 1)
#define			HID_HANDLE_MOUSE_REPORT				19     //24
#else
#define			HID_HANDLE_MOUSE_REPORT				24     //24
#endif
#define			HID_HANDLE_CONSUME_REPORT			28
#define			HID_HANDLE_KEYBOARD_REPORT			32
#define			AUDIO_HANDLE_MIC					50

#else
//		handle 0x0e: consumper report
#define			HID_HANDLE_CONSUME_REPORT			21
#define			HID_HANDLE_KEYBOARD_REPORT			25
#define			AUDIO_HANDLE_MIC					43

#endif



#if(MOUSE_REPORT_RATE_89)
#define REQ_INTER_MIN		9
#define REQ_INTER_MAX		9

#define REQ_LATENCY			99
#define BLE_LATENCY_ALLOW	0

#define VALID_INTER_MIN		9
#define VALID_INTER_MAX		9

#define MOUSE_TIMER_SHORT_T			11255
#define MOUSE_TIMER_LONG_T			300000
#else

#define REQ_INTER_MIN		6
#define REQ_INTER_MAX		6
//from yangkeqi
#if (DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V1P0)
#define REQ_LATENCY			99

#elif((DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_PUBLIC_BOARD)&&(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0))

#define REQ_LATENCY			19


#elif((DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_NEWMAN_BOARD)&&(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0))

#define REQ_LATENCY			19


#elif((DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_THREE_BUTTON_BOARD)&&(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0))

#define REQ_LATENCY			99


#elif((DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_NEWMAN_V3_BOARD)&&(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0))

#define REQ_LATENCY			19


#elif((DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_YJX_V4_BOARD)&&(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0))

#define REQ_LATENCY			19

#elif((DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_BingShou_V5_BOARD)&&(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0))

#define REQ_LATENCY			19

#elif((DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_BingShou_V6_BOARD)&&(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0))

#define REQ_LATENCY			19

#elif((DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_BingShou_V7_BOARD)&&(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0))

#define REQ_LATENCY			19

#elif((DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_wulian_V8_BOARD)&&(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0))

#define REQ_LATENCY			99

#elif((DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_wulian_V9_BOARD)&&(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0))

#define REQ_LATENCY			19

#elif((DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_wulian_V10_BOARD)&&(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0))

#define REQ_LATENCY			19

#elif((DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_wulian_V11_BOARD)&&(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0))

#define REQ_LATENCY			19

#elif((DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_wulian_V12_BOARD)&&(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0))

#define REQ_LATENCY			19

#else

#define REQ_LATENCY			19

#endif


#define BLE_LATENCY_ALLOW	0

#define VALID_INTER_MIN		6
#define VALID_INTER_MAX		6

#define MOUSE_TIMER_SHORT_T			7520
//#define MOUSE_TIMER_SHORT_T			11270
#define MOUSE_TIMER_LONG_T			120000
#endif

u16 min_interval_vaild = 6;
u16 max_interval_vaild = 6;

#define MOUSE_PROC_TIME_EXCEED		6200

extern u32 att_service_discover_tick;

#define IS_INTER_VALID(interval)  ( (interval)>=VALID_INTER_MIN && (interval)<= VALID_INTER_MAX)


int mouse_update_suspend_proc(void);

unsigned short alarm_thresh;
unsigned short battValue[10] = {2376, 2897, 2678,2579, 2533, 2899, 2756, 2734, 2890, 2609};

//////////////////////////////////////////////////////////////////////////////
//	Initialization: MAC address, Adv Packet, Response Packet
//////////////////////////////////////////////////////////////////////////////
u8	tbl_advData[] = {
	 0x02, 0x01, 0x05, 							// BLE limited discoverable mode and BR/EDR not supported
	 0x03, 0x19, 0xc2, 0x03, 					//  Generic Mouse, Generic category
	 0x03, 0x03, 0x12, 0x18,					// UUID (0x1812 HID Service)
	 19, 0x09, 0, 0, 0, 0, 0, 0,0,0,0,0, 0, 0, 0, 0, 0,0,0,0,
};


u8	tbl_scanRsp [] = {
#if 0
	 0x08, 0x09, 'T', '.', 'm', 'o', 'u', 's', 'e',
#else
	 19, 0x09, 0, 0, 0, 0, 0, 0,0,0,0,0, 0, 0, 0, 0, 0,0,0,0,
#endif
	};


const led_cfg_t led_cfg[] = {

		{250,	250, 	1,	0x02,  },	// CPI 0
		{250, 	250, 	2, 	0x02,  },	// CPI 1
		{250, 	250, 	3, 	0x02,  },	// CPI 2

	    {250,   250,   	1,  0x04,  },    // 1Hz, switch mode
#if(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0)
		#if((DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_wulian_V11_BOARD) || (DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_wulian_V12_BOARD))
	    {250,   250,    2,  0x04,  },
	    #else
		{250,   250,    1,  0x04,  },
		#endif
#else
	    {250,   250,    2,  0x04,  },
#endif
	    {500,	500 ,   2,	0x02,  },    // 1Hz for 2 seconds, back to non-direct adv
	    {125,	125 ,   3,	0x08,  },    // 4Hz for 3 seconds
	    {500,   500,    1,  0x04,  },	 // ota start
	    {125,   125,    5,  0x04,  },	 // ota end
	    {250, 	250, 	4, 	0x02,  },	// CPI 3
};


u32	advertise_begin_tick;
u32 latest_user_event_tick;
u32 mouse_event_flg;
u8  user_task_flg;
u8  sendTerminate_before_enterDeep = 0;

u8  low_batt_enter_deep_dirtectly = 0;

static u8 ota_is_working = 0;

#if (STUCK_KEY_PROCESS_ENABLE)
u32 stuckKey_keyPressTime;
#endif


u8 conn_para_updata_success = 0;
u32 conn_para_tick;
u8 conn_para_updata_cnt;

u8 	start_updata_para_flg = 0;
u8  app_ll_conn_update_pending = 0;


u32 ble_encry_done_flg = 0;
extern u32 att_service_discover_tick;

//u8 binding_master_addr[8] = {0};
//int binding_master_addr_idx;

u8 binding_mode_addr[4] = {0};			//if default mode is ble mode, the value should be set as 01
int binding_mode_addr_idx;

u8 last_mouse_id[8] = {0x5a, 0xff, 0xe5, 0xe4, 0xe3, 0xe2, 0xe1, 0xe0};
int last_mouse_id_idx;

extern ll_mac_t  bltMac;

#define MAINLOOP_TIME_FOLLOW_AS_INTERVAL		0			//follow ble interval
#define MAINLOOP_TIME_FOLLOW_AS_TIMER			1			//follow timer


mainloop_status_t mainloop_status = {
		MAINLOOP_TIME_FOLLOW_AS_INTERVAL,
		0,
		0,
};
void set_advData_ykq()
{
	u8 len;
	len=sizeof(DEVICE_NAME_AAA)-1+13;
	tbl_advData[11]=sizeof(DEVICE_NAME_AAA);
	
    memcpy(&tbl_advData[13],DEVICE_NAME_AAA,sizeof(DEVICE_NAME_AAA)-1);
	
	bls_ll_setAdvData( tbl_advData, len );
}

void mouse_callback_writecmd(void)
{
	att_service_discover_tick = clock_time() | 1;
	start_updata_para_flg = 1;
	if(!conn_para_updata_success){
		bls_l2cap_requestConnParamUpdate (min_interval_vaild, max_interval_vaild, REQ_LATENCY, 400);   //10ms *(99+1) = 1000 ms
	}
}


#if (BLE_MOUSE_OTA_ENABLE)

void entry_ota_mode(void)
{
	ota_is_working = 1;
#if(!LED_SHOW_DEBUG_INFO)
	device_led_setup(led_cfg[LED_SHINE_OTA_START]);
#endif
	bls_ota_setTimeout(15 * 1000 * 1000); //set OTA timeout  15 seconds
}



void LED_show_ota_result(int result)
{

	irq_disable();
	WATCHDOG_DISABLE;

	gpio_set_output_en(GPIO_LED_BLE, 1);
	if(result == OTA_SUCCESS){  //OTA success
		gpio_write(GPIO_LED_BLE, 1);
		sleep_us(2000000);  //led on for 2 second
		gpio_write(GPIO_LED_BLE, 0);
	}
	else{  //OTA fail
		for(int i=0; i<4; i++){
			gpio_write(GPIO_LED_BLE, 1);
			sleep_us(250000);
			gpio_write(GPIO_LED_BLE, 0);
			sleep_us(250000);
		}

	}

}
#endif



void conn_para_updata_retry(void)
{
	u32 conn_para_wait_time = (conn_para_updata_cnt == 3) ? 1000000 : 300000;
	if( start_updata_para_flg && conn_para_updata_cnt && !app_ll_conn_update_pending \
			&& conn_para_tick && clock_time_exceed(conn_para_tick, conn_para_wait_time)){
		if(--conn_para_updata_cnt == 0){
			mainloop_status.mode_switch = 1;
			//bls_ll_terminateConnection(HCI_ERR_REMOTE_USER_TERM_CONN);
		}
		else if(conn_para_updata_cnt == 1){
			min_interval_vaild = 6;
			max_interval_vaild = 9;
			bls_l2cap_requestConnParamUpdate (min_interval_vaild, max_interval_vaild, REQ_LATENCY, 400);   //10ms *(99+1) = 1000 ms
		}
		else{
			min_interval_vaild = 6;
			max_interval_vaild = 6;
			bls_l2cap_requestConnParamUpdate (min_interval_vaild, max_interval_vaild, REQ_LATENCY, 400);   //10ms *(99+1) = 1000 ms
		}
		conn_para_tick = clock_time() | 1;
	}
}

#if(USER_TEST_BLT_SOFT_TIMER)

void mouse_task_run_in_timer_add( void )
{
	if(mainloop_status.mode == MAINLOOP_TIME_FOLLOW_AS_INTERVAL){
		if(blt_timer.currentNum == 0){
			blt_soft_timer_add(&mouse_update_suspend_proc, MOUSE_TIMER_SHORT_T);
		}
		mainloop_status.mode = MAINLOOP_TIME_FOLLOW_AS_TIMER;
	}
}

void mouse_task_run_in_timer_delete( void )
{
	if(mainloop_status.mode == MAINLOOP_TIME_FOLLOW_AS_TIMER){ // ֮ǰ timerʱʵ
		if( blt_timer.currentNum ){
			blt_soft_timer_delete(&mouse_update_suspend_proc);
		}
		mainloop_status.mode = MAINLOOP_TIME_FOLLOW_AS_INTERVAL;
	}
}

#endif

void mouse_task_loop_switch (void)
{
	if(!app_ll_conn_update_pending){


		u16 interval = bls_ll_getConnectionInterval();
		u16 latency =  bls_ll_getConnectionLatency();

		write_reg16(0x8002, interval);
		write_reg16(0x8004, latency);

		if(( interval >= min_interval_vaild && interval<= max_interval_vaild)){  //interval
			mainloop_status.mode_switch_cnt ++;
#if(USER_TEST_BLT_SOFT_TIMER)
			mouse_task_run_in_timer_delete();
#endif
		}
		else{ 							//timerʱ
#if(USER_TEST_BLT_SOFT_TIMER)
			mouse_task_run_in_timer_add();
#endif
		}

		mainloop_status.mode_switch = 0;

	}
}



#if(MOUSE_BATT_MOUDULE_EN)
/***********************************	ϣ           ***********************************
 *
 * 㷨ʵ֣Ҫ鰴d(n/2, n/4, n/8)зֱdΪ1൱ִһֱӲ
 *
**************************************************************************************/
inline void ShellInsertSort(u16 *p, u8 len, int dt){
	for(int i= dt; i<len; i++){
		if(p[i] < p[i-dt]){
			int j = i-dt;
			int watcher = p[i];		//ڱΪiԪ
			while(watcher < p[j] && (j >= 0)){	//бȽϣѰʵĲλ
				p[j+dt] =  p[j];
				j -= dt;
			}
			p[j+dt] = watcher;		//뵽ȷλ
		}
	}
}

void ShellSort(u16 *p, u8 len){
	u8 dk = len >> 1;
		while(dk >= 1){
			ShellInsertSort(p, len, dk);
			dk = dk >> 1;
		}
 }


void mouse_battery_check(unsigned short *batt, u8 len)
{
	static u32 battCheckTick = 0;
	u16 batt_check;

	if(clock_time_exceed(battCheckTick, 3000000)){
		battCheckTick = clock_time();
		for(int i=0; i<len;i++){
			batt[i] = adc_SampleValueGet();
		}
		ShellSort(batt, len);//ϣ
		u8 midd = len >> 1;  //1/3ѹbatt[midd-1] + batt[midd] + batt[midd+1]

		if(signal_battery){
			batt_check = (batt[midd - 1] + batt[midd] + batt[midd+1] + batt[midd+2]) >> 2;
			//batt[0] =  (1428 * (((batt[midd] + batt[midd - 1] + batt[midd + 1]) / 3) - 128)/(16383-256));    //2^14 - 1 = 16383;
		}
		else{			//˫صѹ
			batt_check = (batt[midd] + batt[midd - 1] + batt[midd + 1]);
			//batt[0] =  (1428*((batt[midd] + batt[midd - 1] + batt[midd + 1])-128)/(16383-256));    //2^14 - 1 = 16383;
		}

		batt[0] =  (1428 * (batt_check - 128) / (16383-256));    	//2^14 - 1 = 16383;

		if(batt[0] < alarm_thresh){
#if(!LED_SHOW_DEBUG_INFO)
			device_led_setup(led_cfg[LED_BATTRY_ALARM]);			//4Hz, 3 seconds
			if((signal_battery && batt[0] < 1000) || (!signal_battery && batt[0] < 2000)) {
				low_batt_enter_deep_dirtectly = 1;
			}
			else{
				low_batt_enter_deep_dirtectly = 0;
			}
#endif
		}

	}
}


#endif


int sm_sum_x, sm_pre_x, sm_sum_y, sm_pre_y;
void iir_smoother(signed char *data_x, signed char *data_y){
	sm_sum_x = sm_sum_x - sm_pre_x + *data_x;
	sm_pre_x = sm_sum_x/2;
	*data_x = sm_pre_x;

    sm_sum_y = sm_sum_y - sm_pre_y + *data_y;
	sm_pre_y = sm_sum_y/2;
	*data_y = sm_pre_y;
}

static inline void iir_smoother_clear( void ){
	sm_sum_x = 0;
	sm_pre_x = 0;

    sm_sum_y = 0;
	sm_pre_y = 0;
}

const u8 sm_dyn_pth1 = 6;
const u8 sm_dyn_pth2 = 4;
u8 adaptive_smoother(signed char *data_x, signed char *data_y ){
    static u8 asm_flg = 0;
    static u32 sm_last_smoother_tick = 0;

    //auto clear asm sum when no data for a long time
    if ( asm_flg && clock_time_exceed(sm_last_smoother_tick, 100000) ){
        asm_flg = 0;
        iir_smoother_clear ( );
    }
    if ( !asm_flg ){
        if ( (abs(*data_x) > sm_dyn_pth1) || (abs(*data_y) > sm_dyn_pth1) ){
            asm_flg = 1;
            iir_smoother ( data_x, data_y );
        }
        else{
            asm_flg = 0;
            iir_smoother_clear ( );
        }
    }
    else{
        if ( (abs(*data_x) < sm_dyn_pth2) && (abs(*data_y) < sm_dyn_pth2) ){
           asm_flg = 0;
           iir_smoother_clear ( );
        }
        else{
           asm_flg = 1;
           iir_smoother ( data_x, data_y );
        }
    }

    if ( asm_flg ){
        sm_last_smoother_tick = clock_time();
    }

    return asm_flg;
}



//_attribute_ram_code_
void proc_mouse(u8 e, u8 *p, int n);


_attribute_ram_code_ int mouse_update_suspend_proc(void)
{
	proc_mouse(0,0,0);

	if( blc_ll_getCurrentState() == BLS_LINK_STATE_CONN ){

		if(mainloop_status.mode == MAINLOOP_TIME_FOLLOW_AS_TIMER){

			if(!clock_time_exceed(latest_user_event_tick, 3000000)){
				return MOUSE_TIMER_SHORT_T;
			}
			else if(!clock_time_exceed(latest_user_event_tick, 30000000)){
				return MOUSE_TIMER_LONG_T;
			}
			else{
				return 0;
			}

		}

	}

	return 0;

}




int dual_mouse_binding_info_load(u8 *s_addr, u8 *d_addr,  u8 len )
{
	volatile signed int idx = 0;
	for(idx = 0; idx < 4096; idx += len){

		if( *(volatile u32 *)(s_addr + idx) == U32_MAX){
			break;
		}
	}
	idx -= len;
	if(	idx < 0){		// no binding
		return idx;
	}

	memcpy(d_addr, (s_addr + idx), len);

	if(idx > ERASE_MASTER_ADDR_NUM){			//3k, erase flash
		flash_erase_sector((u32)s_addr);

		sleep_us(10);

		flash_write_page((u32)s_addr, len , d_addr);
		idx = 0;
	}

	return idx;

}



void 	ble_mouse_terminate(u8 e,u8 *p, int n) //*p is terminate reason
{
	if(*p == HCI_ERR_CONN_TIMEOUT){

	}
	else if(*p == HCI_ERR_REMOTE_USER_TERM_CONN){  //0x13

	}
	else{
	}

	 //user has push terminate pkt to ble TX buffer before deepsleep
	if(sendTerminate_before_enterDeep == 1){
		sendTerminate_before_enterDeep = 2;
	}

#if(USER_TEST_BLT_SOFT_TIMER)
	mouse_task_run_in_timer_delete();
#endif
	u8 bond_number = blc_smp_param_getCurrentBondingDeviceNumber();  //get bonded device number
	blc_smp_param_loadByIndex( bond_number - 1, &bondInfo);  	  //get the latest bonding device (index: bond_number-1 )

	if(!bond_number || (bondInfo.peer_addr_type & 0x01)){			//rx's address is random

		if(bondInfo.peer_addr_type & 0x01){
			 tbl_advData[2] = 0x04;
			 u8 status = bls_ll_setAdvParam(  ADV_INTERVAL_10MS, ADV_INTERVAL_10MS,
										      ADV_TYPE_CONNECTABLE_UNDIRECTED, OWN_ADDRESS_RANDOM,
										      0,  NULL,
										      BLT_ENABLE_ADV_ALL,
										      ADV_FP_NONE);
			 set_advData_ykq();		//reset adv type

		}
		else{
			 tbl_advData[2] = 0x05;
			 u8 status = bls_ll_setAdvParam(  ADV_INTERVAL_20MS, ADV_INTERVAL_30MS,
										      ADV_TYPE_CONNECTABLE_UNDIRECTED, OWN_ADDRESS_RANDOM,
										      0,  NULL,
										      BLT_ENABLE_ADV_ALL,
										      ADV_FP_NONE);
			set_advData_ykq();		//reset adv type

		}


	}
	else{

#if(ADV_AUTO_SWITCH_FROM_DIR_TO_NODIR)

		u8 status = bls_ll_setAdvParam( ADV_INTERVAL_3_75MS, ADV_INTERVAL_3_75MS,
										ADV_TYPE_CONNECTABLE_DIRECTED_LOW_DUTY, OWN_ADDRESS_RANDOM,
										bondInfo.peer_addr_type,  bondInfo.peer_addr,
										BLT_ENABLE_ADV_ALL,
										ADV_FP_NONE);

#else
		u8 status = bls_ll_setAdvParam( ADV_INTERVAL_10MS, ADV_INTERVAL_10MS,
									ADV_TYPE_CONNECTABLE_DIRECTED_LOW_DUTY, OWN_ADDRESS_RANDOM,
									bondInfo.peer_addr_type,  bondInfo.peer_addr,
									BLT_ENABLE_ADV_ALL,
									ADV_FP_NONE);

#endif
		bls_ll_setAdvDuration(direct_adv_info[1] * 1000000, 1);
		adv_direct_ind_flg = 1;
	}

	conn_para_updata_cnt = 0;
	conn_para_updata_success = 0;
	mainloop_status.mode_switch = 0;


	ble_encry_done_flg = 0;
	advertise_begin_tick = clock_time();
}




void 	ble_mouse_para_req_conf(u8 e,u8 *p, int n) //*p is terminate reason
{
	app_ll_conn_update_pending = 1;

	u16 interval = p[3] | p[4]<<8;
    u16 latency = p[5] | p[6]<<8;

    if(interval >= min_interval_vaild && interval <= max_interval_vaild  && latency >= BLE_LATENCY_ALLOW){
    	conn_para_updata_success = 1;
    	conn_para_updata_cnt = 0;

    	mainloop_status.mode_switch = 1;
    }
    else{
    	if(mainloop_status.mode_switch_cnt){
    		conn_para_updata_success = 0;
    		conn_para_updata_cnt = 2;
#if(USER_TEST_BLT_SOFT_TIMER)
    		mouse_task_run_in_timer_add();
#endif
    		conn_para_tick = clock_time() | 1;
    	}
    }

}

void 	ble_mouse_para_update_conf(u8 e,u8 *p, int n) //*p is terminate reason
{
	app_ll_conn_update_pending = 0;

}

void 	ble_encry_done(u8 e,u8 *p, int n) //*p is terminate reason
{
	//smp_seq_req_tick = 0;
	ble_encry_done_flg = 1;

	extern u8 reportmap_perm;
	reportmap_perm = ATT_PERMISSIONS_READ;
	start_updata_para_flg = 1;
	conn_para_tick = clock_time() | 1;
	bls_l2cap_requestConnParamUpdate (min_interval_vaild, min_interval_vaild, REQ_LATENCY, 400);
/* debug mac 10.13.2޷
	if(adv_direct_ind_flg){
	start_updata_para_flg = 1;
		bls_l2cap_requestConnParamUpdate (REQ_INTER_MIN, REQ_INTER_MAX, 0, 400);
	}
	else{
		bls_l2cap_requestConnParamUpdate (REQ_INTER_MIN, REQ_INTER_MAX, REQ_LATENCY, 400);
	}
*/
}


void smp_pair_failed(u8 e, u8 *p, int n)
{
	if(*p == PARING_FAIL_REASON_UNSPECIFIED_REASON)
		bls_ll_terminateConnection(HCI_ERR_REMOTE_USER_TERM_CONN); //push terminate cmd into ble TX buffer
}

void adv_duration_timeout (u8 e, u8 *p, int n)
{
	bls_ll_terminateConnection(HCI_ERR_REMOTE_USER_TERM_CONN);

	//bls_ll_setAdvDuration(0, 0);
	tbl_advData[2] = 0x05;

	generateRandomNum(4, (u8 *)&bltMac.macAddress_random[0]);
	generateRandomNum(2, (u8 *)&bltMac.macAddress_random[4]);

	bltMac.macAddress_random[5] |= 0xc0;	//specĹ涨typeΪstatic randomʱBIT(47)BIT(46)1 BIT(0)-BIT(45)01
	bltMac.macAddress_random[0] ^= 0x01;

	memcpy((last_mouse_id+2), bltMac.macAddress_random, 6);

	last_mouse_id[0] = 0x5a;
	last_mouse_id[1] = 0xff;

	flash_erase_sector((u32)CUST_MOUSE_ID_SAVE_ADDR);
	sleep_us(10);
	flash_write_page(CUST_MOUSE_ID_SAVE_ADDR, 8, last_mouse_id);
	sleep_us(10);


	u8 status = bls_ll_setAdvParam( ADV_INTERVAL_20MS, ADV_INTERVAL_30MS, \
								 	 ADV_TYPE_CONNECTABLE_UNDIRECTED, OWN_ADDRESS_RANDOM, \
								 	 0,  NULL,  BLT_ENABLE_ADV_ALL, ADV_FP_NONE);
	set_advData_ykq();

	bls_ll_setAdvEnable(1);  //adv enable
	advertise_begin_tick = clock_time();
}


extern u8 first_adv_switch;

void	task_connect (u8 e, u8 *p, int n)
{
	u8 bond_number = blc_smp_param_getCurrentBondingDeviceNumber();  //get bonded device number
	if(bond_number){
		if(!adv_direct_ind_flg){						//no adv_direct status, allow the connection
			 first_adv_switch = 0;
			 adv_direct_ind_flg = 1;

		}
//		else{
//			smp_param_save_t bondInfo;
//			blc_smp_param_loadByIndex( bond_number - 1, &bondInfo);  //get the latest bonding device (index: bond_number-1 )
//
//			if( memcmp(p, bondInfo.peer_addr, 6 ) ){
//				bls_ll_terminateConnection(HCI_ERR_REMOTE_USER_TERM_CONN); //push terminate cmd into ble TX buffer
//			}
//		}
	}
	extern u32 blc_rcvd_connReq_tick;
//	blc_rcvd_connReq_tick -= 400 * CLOCK_SYS_CLOCK_1MS;
	bltc.conn_start_tick -=  950 * CLOCK_SYS_CLOCK_1MS;

	u8 flag = 0x00;
	flash_write_page(CUST_MOUSE_ID_SAVE_ADDR, 1, (u8 *)&flag);

	conn_para_updata_cnt = 3;
	conn_para_updata_success = 0;
#if(USER_TEST_BLT_SOFT_TIMER & 0)
	if(blt_timer.currentNum == 0){
		blt_soft_timer_add(&mouse_update_suspend_proc, MOUSE_TIMER_SHORT_T);
	}
	mainloop_status.mode = MAINLOOP_TIME_FOLLOW_AS_TIMER;
#endif


}


void mouse_early_wakeup(u8 e, u8 *p, int n)
{

}

void clear_ble_fifo()
{
	if(blc_ll_getCurrentState() == BLS_LINK_STATE_CONN)
	{
		u8 mouse_relsease_buff[4] = {0};
		bls_att_pushNotifyData (HID_HANDLE_MOUSE_REPORT, mouse_relsease_buff, 4);
		//bls_ll_terminateConnection(HCI_ERR_REMOTE_USER_TERM_CONN);
	}
}
_attribute_ram_code_ void proc_mouse(u8 e, u8 *p, int n)
{

#if(USER_TEST_BLT_SOFT_TIMER)
	if(e == BLT_EV_FLAG_GPIO_EARLY_WAKEUP){

		if( (mainloop_status.mode == MAINLOOP_TIME_FOLLOW_AS_TIMER) && blt_timer.currentNum){

			if( blt_timer.currentNum == 1){
				blt_soft_timer_delete(&mouse_update_suspend_proc);		//delete successfully
			}

			blt_soft_timer_add(&mouse_update_suspend_proc, MOUSE_TIMER_SHORT_T);
		}
	}
#endif

	if( (blc_ll_getCurrentState() != BLS_LINK_STATE_CONN) || !ble_encry_done_flg ){
		att_service_discover_tick = clock_time() | 1;
	}



	/***************        *****************/

	*(u32 *)(mouse_status.data) = 0;

#if(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V1P0)
        mouse_button_detect(&mouse_status, MOUSE_BTN_LOW);		//Debug, no button

#elif(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0)

        mouse_button_pull(&mouse_status, MOUSE_BTN_LOW);
        mouse_button_detect(&mouse_status, MOUSE_BTN_HIGH);		//Debug, no button

#endif

	//cur_btn_value = mouse_button_detect(&mouse_status, MOUSE_BTN_LOW); // 0:release, 1:pressed, 2:hold on
#if(MOUSE_BTN_MODULE_EN)
	mouse_button_process(&mouse_status);
#endif

#if(MOUSE_WHEEL_MODULE_EN)
	u32 wheel_prepare_tick = mouse_wheel_prepare_tick();
#endif


#if(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V1P0 || DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0)

	mouse_sensor_data( &mouse_status );
#else
	drv_mouse_motion_report(&mouse_data.x, 0);
#endif

#if(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0)
        mouse_button_pull(&mouse_status, MOUSE_BTN_HIGH);
        mouse_button_detect(&mouse_status, MOUSE_BTN_LOW);		//Debug, no button
#endif

#if (HP_NOTE_BOOK_DEBUG)

	static u16 cnt;
	static u32 tick;
	static u8 flg;
	if((blc_ll_getCurrentState() == BLS_LINK_STATE_CONN)){

		if(!tick){
			tick = clock_time() | 1;
		}

		if(!flg && clock_time_exceed(tick, 2000000)){
			flg = 1;
			tick = clock_time();
		}

		if(flg){
			if(clock_time_exceed(tick, MOUSE_PROC_TIME_EXCEED)){
				tick = clock_time();

				u8 n = cnt >> 4;
				if(n == 0){
					mouse_data.x = 8;
					mouse_data.y = 0;
				}
				else if(n == 1){
					mouse_data.x = 0;
					mouse_data.y = 8;
				}
				else if(n == 2){
					mouse_data.x = -8;
					mouse_data.y = 0;
				}
				else if(n == 3){
					mouse_data.x = 0;
					mouse_data.y = -8;
				}
				cnt = (cnt + 1) & 63;
			}
		}

	}
#endif

#if(MOUSE_WHEEL_MODULE_EN)

	mouse_wheel_process(&mouse_status, wheel_prepare_tick);
#endif

	u8 mouse_relsease_buff[4] = {0};
	//start to switch mode to 2.4G, then release button
	if( button_func.start_switch_sys_mode){
		bls_att_pushNotifyData (HID_HANDLE_MOUSE_REPORT, mouse_relsease_buff, 4);

	}
	else{
		if(*(u32 *)(mouse_status.data)){				//when switch mode start, do not need to send data
			latest_user_event_tick = clock_time();
			conn_deep_cnt = 0;
			conn_deep_tick = clock_time();
			mouse_event_flg = clock_time() | 1;

			if((mouse_data.x != 0)|| (mouse_data.y != 0) ){
				adaptive_smoother(&mouse_data.x, &mouse_data.y);
			}



			bls_att_pushNotifyData (HID_HANDLE_MOUSE_REPORT, (u8 *)mouse_status.data, 4);

		}
		else if(button_func.btn_released){
			bls_att_pushNotifyData (HID_HANDLE_MOUSE_REPORT, mouse_relsease_buff, 4);
		}
	}

}


extern void device_info_save(mouse_status_t *mouse_status, u32 sleep_save);
extern u32 blc_tlkEvent_pending;
_attribute_ram_code_ void blt_pm_proc(void)
{
#if(BLE_MOUSE_PM_ENABLE)



	bls_pm_setSuspendMask (SUSPEND_ADV | SUSPEND_CONN);
	user_task_flg = DEVICE_LED_BUSY || mouse_event_flg || ota_is_working;
	if( user_task_flg ){
		bls_pm_setManualLatency(0);
	}

	if(mouse_event_flg && clock_time_exceed(mouse_event_flg, MOUSE_TIMER_SHORT_T * 100)){
		mouse_event_flg = 0;
	}

//	if(smp_seq_req_tick && clock_time_exceed(smp_seq_req_tick, DISCONN_LINK_WITHOUT_SMP_PAIR_TIMEOUT)){
//		smp_seq_req_tick = 0;
//		bls_ll_terminateConnection(HCI_ERR_REMOTE_USER_TERM_CONN); //push terminate cmd into ble TX buffer
//	}


#if 1 //deepsleep
	if(sendTerminate_before_enterDeep == 1){ //sending Terminate and wait for ack before enter deepsleep
		if(user_task_flg){  //detect key Press again,  can not enter deep now
			sendTerminate_before_enterDeep = 0;
			bls_ll_setAdvEnable(1);   //enable adv again
		}
	}
	else if(sendTerminate_before_enterDeep == 2){  //Terminate OK
		//bls_pm_setSuspendMask (DEEPSLEEP_ADV); //when terminate, link layer change back to adc state
		//bls_pm_setWakeupSource(PM_WAKEUP_PAD);  //gpio PAD wakeup deesleep
		cpu_sleep_wakeup(DEEPSLEEP_MODE, PM_WAKEUP_PAD, 0);  //deepsleep
	}

	//adv 60s, deepsleep
	if( blc_ll_getCurrentState() == BLS_LINK_STATE_ADV ) {

		if(!sendTerminate_before_enterDeep && clock_time_exceed(advertise_begin_tick , 60 * 1000000) && !blc_tlkEvent_pending \
				|| low_batt_enter_deep_dirtectly){		//No timeout task pending

//		bls_pm_setSuspendMask (DEEPSLEEP_ADV); //set deepsleep
//		bls_pm_setWakeupSource(PM_WAKEUP_PAD);  //gpio PAD wakeup deesleep



			mouse_sleep.sensor_sleep = 1;
			device_info_save (&mouse_status, 0);

			gpio_setup_up_down_resistor(mouse_status.hw_define->sensor_sclk, PM_PIN_PULLUP_1M );		//ֹ©
			gpio_setup_up_down_resistor(mouse_status.hw_define->sensor_data, PM_PIN_PULLUP_1M );		//ֹ©

			mouse_sensor_sleep_wakeup( &mouse_status.mouse_sensor, &mouse_sleep.sensor_sleep, 0 );

			cpu_sleep_wakeup(DEEPSLEEP_MODE, PM_WAKEUP_PAD, 0);  //deepsleep
		}

	}
	//conn 60s no event(key/voice/led), enter deepsleep
	else if( blc_ll_getCurrentState() == BLS_LINK_STATE_CONN){

		if(clock_time_exceed(conn_deep_tick, 6000000) ){
			conn_deep_cnt ++;
			conn_deep_tick = clock_time();
		}

		if( (conn_deep_cnt > BLE_MODE_ENTER_DEEP_CNT && !user_task_flg) || low_batt_enter_deep_dirtectly ) {		//10 min

			bls_ll_terminateConnection(HCI_ERR_REMOTE_USER_TERM_CONN); //push terminate cmd into ble TX buffer
			bls_ll_setAdvEnable(0);   //disable adv
			sendTerminate_before_enterDeep = 1;

			mouse_sleep.sensor_sleep = 1;
			device_info_save (&mouse_status, 0);


			gpio_setup_up_down_resistor(mouse_status.hw_define->sensor_sclk, PM_PIN_PULLUP_1M );		//ֹ©
			gpio_setup_up_down_resistor(mouse_status.hw_define->sensor_data, PM_PIN_PULLUP_1M );		//ֹ©


			mouse_sensor_sleep_wakeup( &mouse_status.mouse_sensor, &mouse_sleep.sensor_sleep, 0 );
		}
	}
#endif




#endif
}


void  ble_remote_set_sleep_wakeup (u8 e, u8 *p, int n)
{
	if( blc_ll_getCurrentState() == BLS_LINK_STATE_CONN && ((u32)(bls_pm_getSystemWakeupTick() - clock_time())) > 80 * CLOCK_SYS_CLOCK_1MS){  //suspend time > 30ms.add gpio wakeup
		bls_pm_setWakeupSource(PM_WAKEUP_CORE);  //gpio CORE wakeup suspend

		u32 debug_wheel0_wakeup_level = !gpio_read(mouse_hw.wheel[0]);
		gpio_set_wakeup(mouse_status.hw_define->wheel[0], debug_wheel0_wakeup_level, 1);	//CORE wakeup

		debug_wheel0_wakeup_level = !gpio_read(mouse_hw.wheel[1]);
		gpio_set_wakeup(mouse_status.hw_define->wheel[1], debug_wheel0_wakeup_level, 1);	//CORE wakeup
	}
}



void rf_customized_param_load(void)
{
	  //flash 0x77000 customize freq_offset adjust cap value, if not customized, default ana_81 is 0xd0
	 if( (*(unsigned char*) CUST_CAP_INFO_ADDR) != 0xff ){
		 //ana_81<4:0> is cap value(0x00 - 0x1f)
		 analog_write(0x81, (analog_read(0x81)&0xe0) | ((*(unsigned char*) CUST_CAP_INFO_ADDR)&0x1f) );
	 }

	 //flash 0x77040 customize TP0, flash 0x77041 customize TP1
	 if( ((*(unsigned char*) (CUST_TP_INFO_ADDR)) != 0xff) && ((*(unsigned char*) (CUST_TP_INFO_ADDR+1)) != 0xff) ){
		 rf_update_tp_value(*(unsigned char*) (CUST_TP_INFO_ADDR), *(unsigned char*) (CUST_TP_INFO_ADDR+1));
	 }

	 // customize 32k RC cap value, if not customized, default ana_32 is 0x80
	 if( (*(unsigned char*) CUST_RC32K_CAP_INFO_ADDR) != 0xff ){
		 //ana_81<4:0> is cap value(0x00 - 0x1f)
		 analog_write(0x32, *(unsigned char*) CUST_RC32K_CAP_INFO_ADDR );
	 }
}


/** BLe mode **/

void ble_user_init()
{
	blc_app_loadCustomizedParameters();  //load customized freq_offset cap value and tp value

////////////////// BLE stack initialization ////////////////////////////////////
	u8  tbl_mac [] = {0xe1, 0xb1, 0xb2, 0xe8, 0xa3, 0xc7};
	u32 *pmac = (u32 *) CFG_ADR_MAC;
	if (*pmac != 0xffffffff)
	{
		memcpy (tbl_mac, pmac, 6);
	}
	else{
		tbl_mac[0] = (u8)rand();
		flash_write_page (CFG_ADR_MAC, 6, tbl_mac);
	}
	
	if(last_mouse_id_idx < 0){

		last_mouse_id[0] = 0x5a;
		last_mouse_id[1] = 0xff;


		memcpy((u8 *)(last_mouse_id+2) , tbl_mac, 6);

		last_mouse_id[7] |= 0xc0;	//specĹ涨typeΪstatic randomʱBIT(47)BIT(46)1 BIT(0)-BIT(45)01
		last_mouse_id[2] ^= 0x01;

		flash_write_page(CUST_MOUSE_ID_SAVE_ADDR, 8, last_mouse_id);
		last_mouse_id_idx = 0;
		memcpy(tbl_mac, (last_mouse_id+2), 6);
	}
	else if(last_mouse_id_idx >= 0){
		memcpy(tbl_mac, (last_mouse_id+2), 6);				//cpoy the newest id

	}
	memcpy(bltMac.macAddress_random, tbl_mac, BLE_ADDR_LEN);

///////////// BLE stack Initialization ////////////////
////// Controller Initialization  //////////
	blc_ll_initBasicMCU(tbl_mac);   //mandatory

	blc_ll_initAdvertising_module(tbl_mac); 	//adv module: 		 mandatory for BLE slave,
	blc_ll_initSlaveRole_module();				//slave module: 	 mandatory for BLE slave,
	blc_ll_initPowerManagement_module();        //pm module:      	 optional



////// Host Initialization  //////////
	extern void my_att_init ();
	my_att_init (); //gatt initialization
	blc_l2cap_register_handler (blc_l2cap_packet_receive);  	//l2cap initialization

	blc_att_setServerDataPendingTime_upon_ClientCmd(50);		//500ms pending time
#if 1
	blc_smp_param_setBondingDeviceMaxNumber(1);  	//default is SMP_BONDING_DEVICE_MAX_NUM, can not bigger that this value
	bls_smp_enableParing (SMP_PARING_CONN_TRRIGER ); 	//smp initialization
#endif
	HID_service_on_android7p0_init();  //hid device on android 7.0

///////////////////// USER application initialization ///////////////////
	set_advData_ykq();

   	tbl_scanRsp[0]=sizeof(DEVICE_NAME_AAA);
    memcpy(&tbl_scanRsp[2],DEVICE_NAME_AAA,sizeof(DEVICE_NAME_AAA)-1);
	bls_ll_setScanRspData(tbl_scanRsp, sizeof(DEVICE_NAME_AAA)+1);

	u8 bond_number = blc_smp_param_getCurrentBondingDeviceNumber();  //get bonded device number

	if(bond_number ){
		blc_smp_param_loadByIndex( bond_number - 1, &bondInfo);  //get the latest bonding device (index: bond_number-1 )
	}

	if(bond_number && (last_mouse_id[0] == 0))   //set direct adv
	{
		//set direct adv

#if(ADV_AUTO_SWITCH_FROM_DIR_TO_NODIR)
		u8 status = bls_ll_setAdvParam( ADV_INTERVAL_3_75MS, ADV_INTERVAL_3_75MS,
										ADV_TYPE_CONNECTABLE_DIRECTED_LOW_DUTY, OWN_ADDRESS_RANDOM,
										bondInfo.peer_addr_type,  bondInfo.peer_addr,
										BLT_ENABLE_ADV_ALL,
										ADV_FP_NONE);

#else
		u8 status;
		if(bondInfo.peer_addr_type & 0x01){
			tbl_advData[2] = 0x04;			//No Limited discoverable
			status = bls_ll_setAdvParam(  ADV_INTERVAL_10MS, ADV_INTERVAL_10MS,
										  ADV_TYPE_CONNECTABLE_UNDIRECTED, OWN_ADDRESS_RANDOM,
										  0,  NULL,
										  BLT_ENABLE_ADV_ALL,
										  ADV_FP_NONE);
			set_advData_ykq();

		}
		else{
			status = bls_ll_setAdvParam( ADV_INTERVAL_10MS, ADV_INTERVAL_10MS,
					ADV_TYPE_CONNECTABLE_DIRECTED_LOW_DUTY, OWN_ADDRESS_RANDOM,
					bondInfo.peer_addr_type,  bondInfo.peer_addr,
					BLT_ENABLE_ADV_ALL,
					ADV_FP_NONE);
		}


#endif
		if(status != BLE_SUCCESS) { write_reg8(0x8000, 0x11); 	while(1); }  //debug: adv setting err
		//it is recommended that direct adv only last for several seconds, then switch to indirect adv
		bls_ll_setAdvDuration(direct_adv_info[1] * 1000000, 1);
		adv_direct_ind_flg = 1;
		//bls_app_registerEventCallback (BLT_EV_FLAG_ADV_DURATION_TIMEOUT, &app_switch_to_indirect_adv);

	}
	else   //set indirect adv
	{
		u8 status = bls_ll_setAdvParam(  ADV_INTERVAL_20MS, ADV_INTERVAL_30MS,
										 ADV_TYPE_CONNECTABLE_UNDIRECTED, OWN_ADDRESS_RANDOM,
										 0,  NULL,
										 BLT_ENABLE_ADV_ALL,
										 ADV_FP_NONE);
		if(status != BLE_SUCCESS) { write_reg8(0x8000, 0x11); 	while(1); }  //debug: adv setting err
		adv_direct_ind_flg = 0;
	}

	bls_ll_setAdvEnable(1);  //adv enable
	rf_set_power_level_index (RF_POWER_8dBm);

//ble event call back

	bls_app_registerEventCallback (BLT_EV_FLAG_CONNECT, &task_connect);

	bls_app_registerEventCallback (BLT_EV_FLAG_TERMINATE, &ble_mouse_terminate);
	bls_app_registerEventCallback (BLT_EV_FLAG_CONN_PARA_REQ, &ble_mouse_para_req_conf);
	bls_app_registerEventCallback (BLT_EV_FLAG_CONN_PARA_UPDATE, &ble_mouse_para_update_conf);
	bls_app_registerEventCallback (BLT_EV_FLAG_ENCRYPTION_CONN_DONE, &ble_encry_done);		//

	bls_app_registerEventCallback (BLT_EV_FLAG_GPIO_EARLY_WAKEUP, &proc_mouse);			//early wakeup
	bls_app_registerEventCallback (BLT_EV_FLAG_ADV_DURATION_TIMEOUT, &adv_duration_timeout);		//direct adv timeout
	bls_app_registerEventCallback (BLT_EV_FLAG_PAIRING_END, &smp_pair_failed);			//early wakeup

	///////////////////// Power Management initialization///////////////////
#if(BLE_MOUSE_PM_ENABLE)
	blc_ll_initPowerManagement_module();
	bls_pm_setSuspendMask (SUSPEND_ADV | SUSPEND_CONN);
	bls_app_registerEventCallback (BLT_EV_FLAG_SUSPEND_ENTER, &ble_remote_set_sleep_wakeup);
#else
	bls_pm_setSuspendMask (SUSPEND_DISABLE);
#endif


////////////////LED initialization /////////////////////////
#if(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V1P0 || DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0)

	device_led_init(GPIO_LED_BLE, 1);


#if(LED_SHOW_DEBUG_INFO)
	gpio_set_output_en(GPIO_LED_2P4, 1);
#endif

#else if(DUAL_MOUSE_BOARD == DUAL_MOUSE_MIMOUSE_BOARD)
	device_led_init(GPIO_LED_R, 0);
#endif


#if (BLE_MOUSE_OTA_ENABLE)
////////////////// OTA relative ////////////////////////
	bls_ota_clearNewFwDataArea(); //must
	bls_ota_registerStartCmdCb(entry_ota_mode);
	bls_ota_registerResultIndicateCb(LED_show_ota_result);
#endif



//////////////// TEST  /////////////////////////
#if (USER_TEST_BLT_SOFT_TIMER)
//	blt_soft_timer_init();
//	blt_soft_timer_add(&mouse_update_suspend_proc, MOUSE_TIMER_SHORT_T);   //11350
//	mouse_task_run_in_soft_timer = 1;
#endif

	advertise_begin_tick = clock_time();

}
void Mouse_rf_private_2M_init_user()
{
	analog_write(0xa3,0x10);
	write_reg8(0x401,0x00);//pn disable
	write_reg8(0x402,0x26);//pre-amble
	write_reg8(0x404,0xca);//
	write_reg8(0x405,0x05);//access code length
	write_reg8(0x408,0x71);//access code byte3
	write_reg8(0x409,0x76);//access code byte2
	write_reg8(0x40a,0x51);//access code byte1
	write_reg8(0x40b,0x39);//access code byte0
	write_reg8(0x420,0x26);//threshold
	write_reg8(0xf03,0x36);
}
void user_init()
{

	mouse_hw_init();
#if(MOUSE_BATT_MOUDULE_EN)

	if(signal_battery){
		adc_BatteryCheckInit(ADC_CLK_4M, 0, Battery_Chn_B7, B7, SINGLEEND, RV_1P428, RES14, S_3);		//no div
	}
	else{
		adc_BatteryCheckInit(ADC_CLK_4M, 1, Battery_Chn_B7, 0, SINGLEEND, RV_1P428, RES14, S_3);
	}

#endif
	if(button_func.system_mode == RF_2M_2P4G_MODE){
		normal_user_init();
		Mouse_rf_private_2M_init_user();// for stack sdk 3.3.0 above
	}
	else{
		ble_user_init();
	}
}


/////////////////////////////////////////////////////////////////////
// main loop flow
/////////////////////////////////////////////////////////////////////

void mouse_task_proc(void)
{

	static u32 mouseProcTick = 0;

	if(mainloop_status.mode == MAINLOOP_TIME_FOLLOW_AS_INTERVAL){
		if(clock_time_exceed(mouseProcTick, MOUSE_PROC_TIME_EXCEED)){
			mouseProcTick = clock_time();
			mouse_update_suspend_proc();
		}
	}


}

_attribute_ram_code_ void mouse_mainloop_task_proc(void)
{

	mouse_task_proc();

	if(!conn_para_updata_success && !ota_is_working){			//OTA
		conn_para_updata_retry();
	}

	if(mainloop_status.mode_switch){
		mouse_task_loop_switch();
	}

}


void main_loop ()
{
	if(button_func.system_mode == RF_1M_BLE_MODE ){


		////////////////////////////////////// BLE entry /////////////////////////////////

#if(BLT_SOFTWARE_TIMER_ENABLE)
		blt_soft_timer_process(MAINLOOP_ENTRY);
#endif
		blt_sdk_main_loop();
		////////////////////////////////////// UI entry /////////////////////////////////

		mouse_mainloop_task_proc();


		mouse_battery_check(battValue, sizeof(battValue)/sizeof(battValue[0]));

		device_led_process();  				//led management
#if(LED_SHOW_DEBUG_INFO)
		gpio_write(GPIO_LED_2P4, (blc_ll_getCurrentState() != BLS_LINK_STATE_CONN));
#endif

#if 1//ykq
		u32 wakeup_level=0;
		for( u8 i=0;i<MAX_MOUSE_BUTTON;i++)
		{
			wakeup_level = !gpio_read(mouse_status.hw_define->button[i]);
			gpio_set_wakeup(mouse_status.hw_define->button[i], wakeup_level, 1);
		}
        wakeup_level=!gpio_read(mouse_status.hw_define->sensor_int);
		gpio_set_wakeup(mouse_status.hw_define->sensor_int,wakeup_level,1);
			
#endif
		blt_pm_proc();						//power management

	}
	else{
		mouse_main_loop();
	}

}

#endif  //end of  (__PROJECT_8261_MULTI_MOUSE__)
