#pragma once

/* Enable C linkage for C++ Compilers: */
#if defined(__cplusplus)
extern "C" {
#endif

#include "mouse_emi.h"

#define DEVICE_NAME_AAA "Bluetooth Mouse"


#define SIMULATE_UART_FUNC_EN	0
#if(SIMULATE_UART_FUNC_EN)

#define 	UART_BAUD_RATE_9600 	9600
#define 	UART_BAUD_RATE_19200	19200
#define 	UART_BAUD_RATE_38400	38400
#define 	UART_BAUD_RATE_57600	57600


#define	BAUD_RATE			UART_BAUD_RATE_19200
#define BAUD_BIT_INTERVAL	( CLOCK_SYS_CLOCK_HZ/BAUD_RATE )
#define UART_TX_PIN_SIM		GPIO_PB7
#define	PB7_FUNC			AS_GPIO


#define SHOW_FUNC_IN(msg, arg...) printf("> %s(%d): " msg "\n", __FUNCTION__,__LINE__, ##arg)
#define SHOW_FUNC_OUT(msg, arg...) printf("< %s(%d): " msg "\n\n", __FUNCTION__,__LINE__, ##arg)
#define SHOW_DBG(msg, arg...) printf("%s:%s(%d): " msg "\n", __FILE__, __FUNCTION__,__LINE__, ##arg)
#endif


#if ( __PROJECT_8261_MULTI_MOUSE__ )
	#define CHIP_TYPE				CHIP_TYPE_8261
#else
	#define CHIP_TYPE				CHIP_TYPE_8267
#endif

enum{
	RF_1M_BLE_MODE = 0,
	RF_2M_2P4G_MODE = 1,
};


enum{
	LED_CPI_0 = 0,
	LED_CPI_1 = 1,
	LED_CPI_2 = 2,

	LED_2P4_SWITCH_MODE,
	LED_BLE_SWITCH_MODE,
	LED_NON_DIR_ADV,
	LED_BATTRY_ALARM,

	LED_SHINE_OTA_START,
	LED_SHINE_OTA_SUCCESS,
	LED_CPI_3,
};

#define 		HP_NOTE_BOOK_DEBUG				0

#define 		BLT_SOFTWARE_TIMER_ENABLE		1

/*************   CONFIG ADDRESS   ****************/

#define 		CFG_ADDR_MAC				0x1f000
#define			CFG_ADDR_ACCESS_CODE0		0x1f006

#define 		CUST_CAP_INFO_ADDR			0x1e000				//1M MODE
#define 		CUST_TP_INFO_ADDR			0x1e040
#define			CUST_RC32K_CAP_INFO_ADDR 	0x1e080

#define			CUST_CAP_INFO_ADDR_2M		0x1e020				//2M MODE
#define 		CUST_TP_INFO_ADDR_2M		0x1e060
//#define			MOUSE_DEVICE_ID_ADDRESS		0x1f100

#define			CUST_MOUSE_ID_SAVE_ADDR		0x19000
#define			CFG_DEVICE_MODE_ADDR		0x18000


#define			ERASE_MASTER_ADDR_NUM	3072

#define 		SIGNAL_BATT_CHECK_EN		1				//1.5V
#define			SIGNAL_BATT_THRESH			1200
#define 		DUAL_BATT_THRESH			2200

#define			DISCONN_LINK_WITHOUT_SMP_PAIR_TIMEOUT			5000000				// 5s timeout when link without smp pair

#define			BLE_MOUSE_OTA_ENABLE				1
#define			ADV_TYPE_SWITCH_BY_BUTTON			1
#define 		BLE_MODE_ENTER_DEEP_CNT				100		//6s * 100	00

#ifndef			ADV_AUTO_SWITCH_FROM_DIR_TO_NODIR
#define			ADV_AUTO_SWITCH_FROM_DIR_TO_NODIR	0	//㲥ԶлǶ
#endif


#define			LED_SHOW_DEBUG_INFO					0
#define			MOUSE_REPORT_RATE_89				0
#define 		MOUSE_ONLY_BLE_MODE					0

#define			MOUSE_OPTICAL_EN		1			//open mouse_sensor_pix.c
//Set up as 2.4G mouse

/*************   Mouse Module   ****************/
#define 		MOUSE_BTN_MODULE_EN		1
#define 		MOUSE_WHEEL_MODULE_EN	1
#define 		MOUSE_SENSOR_MODULE_EN	1
#define 		MOUSE_BATT_MOUDULE_EN	1					//battery check
#define 		MOUSE_SLEEP_MODULE_EN	1
#define			MOUSE_SENSOR_MOTION		1

#define			MOUSE_BUTTON_DEBOUNCE	3

/*************   Mouse RF Configuration   ****************/
#define RF_PROTOCOL						RF_PROTO_PROPRIETARY		//  RF_PROTO_PROPRIETARY / RF_PROTO_RF4CE / RF_PROTO_ZIGBEE
#define MOUSE_PIPE1_DATA_WITH_DID		0

#define DUAL_MOUSE_TELINK_BOARD_V1P0	1				// Six GPIOs be used as six buttons
#define DUAL_MOUSE_TELINK_BOARD_V2P0	2				// Three GPIOs be used as six buttons
#define DUAL_MOUSE_MIMOUSE_BOARD		3



#define DUAL_MOUSE_BOARD	DUAL_MOUSE_TELINK_BOARD_V2P0



#if (DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V1P0)

#define DUAL_MOUSE_TELINK_BOARD_DEBUG	1

#define DAUL_MOUSE_YJX_BOARD			0


#if(DUAL_MOUSE_TELINK_BOARD_DEBUG)

#define PA1_INPUT_ENABLE		1		//LEFT
#define PE2_INPUT_ENABLE		1		//RIGHT
#define PE3_INPUT_ENABLE		1		//MIDDLE

#define	GPIO_LED_2P4			0
#define GPIO_LED_BLE			0

#define PC2_INPUT_ENABLE		1		//MOTION
#define PE0_INPUT_ENABLE		1		//Wheel0 Input enable
#define PE1_INPUT_ENABLE		1		//Wheel1 Input enable

#define PB6_INPUT_ENABLE		1		//SDIO, MUST SET

#define PULL_WAKEUP_SRC_PA1		GPIO_PULL_UP_1M
#define PULL_WAKEUP_SRC_PE2		GPIO_PULL_UP_1M
#define PULL_WAKEUP_SRC_PE3		GPIO_PULL_UP_1M

#define PULL_WAKEUP_SRC_PB1		GPIO_PULL_UP_1M
#define PULL_WAKEUP_SRC_PB6		GPIO_PULL_UP_10K
#define PULL_WAKEUP_SRC_PC2		GPIO_PULL_UP_10K	//Motion Pin 1MPULL UP

#define PULL_WAKEUP_SRC_PE0		GPIO_PULL_UP_1M
#define PULL_WAKEUP_SRC_PE1		GPIO_PULL_UP_1M

#define PC3_FUNC	AS_GPIO
#define PC4_FUNC	AS_GPIO
#define PC5_FUNC	AS_GPIO
#define PA0_FUNC	AS_GPIO

#define PC4_OUTPUT_ENABLE		1		//FB
#define PC5_OUTPUT_ENABLE		1		//BB
#define PC3_OUTPUT_ENABLE		1		//CPI
#define	PA0_OUTPUT_ENABLE		1		//LED

#define DBG_CHN0_LOW		( *(unsigned char *)0x800583 &= (~BIT(0)) )		//PA0	CHN0    LED
#define DBG_CHN0_HIGH		( *(unsigned char *)0x800583 |= BIT(0) )
#define DBG_CHN0_TOGGLE		( *(unsigned char *)0x800583 ^= BIT(0) )
#define DBG_CHN1_LOW		( *(unsigned char *)0x800593 &= (~BIT(3)) )		//PC3	CHN1	CPI
#define DBG_CHN1_HIGH		( *(unsigned char *)0x800593 |= BIT(3) )
#define DBG_CHN1_TOGGLE		( *(unsigned char *)0x800593 ^= BIT(3) )
#define DBG_CHN2_LOW		( *(unsigned char *)0x800593 &= (~BIT(4)) )		//PC4	CHN2	FB
#define DBG_CHN2_HIGH		( *(unsigned char *)0x800593 |= BIT(4) )
#define DBG_CHN2_TOGGLE		( *(unsigned char *)0x800593 ^= BIT(4) )
#define DBG_CHN3_LOW		( *(unsigned char *)0x800593 &= (~BIT(5)) )		//PC5	CHN3    BB
#define DBG_CHN3_HIGH		( *(unsigned char *)0x800593 |= BIT(5) )
#define DBG_CHN3_TOGGLE		( *(unsigned char *)0x800593 ^= BIT(5) )

#else

#define PA1_INPUT_ENABLE		1		//LEFT
#define PE2_INPUT_ENABLE		1		//RIGHT
#define PE3_INPUT_ENABLE		1		//MIDDLE

#define PC4_INPUT_ENABLE		1		//FB
#define PC5_INPUT_ENABLE		1		//BB
#define PC2_INPUT_ENABLE		1		//MOTION
#define PC3_INPUT_ENABLE		1		//CPI

#if(DAUL_MOUSE_YJX_BOARD)
#define M_HW_BTN_MODE			GPIO_SWS
#define M_HW_GPIO_LEVEL_MODE	U8_MAX			//pull level, high
#endif

#define PE0_INPUT_ENABLE		1		//Wheel0 Input enable
#define PE1_INPUT_ENABLE		1		//Wheel1 Input enable

#define PB6_INPUT_ENABLE		1		//SDIO, MUST SET

#define PULL_WAKEUP_SRC_PA1		GPIO_PULL_UP_1M
#define PULL_WAKEUP_SRC_PE2		GPIO_PULL_UP_1M
#define PULL_WAKEUP_SRC_PE3		GPIO_PULL_UP_1M

//BUTTON FB BB CPI
#define PULL_WAKEUP_SRC_PC4		GPIO_PULL_UP_10K
#define PULL_WAKEUP_SRC_PC5		GPIO_PULL_UP_10K
#define PULL_WAKEUP_SRC_PC3		GPIO_PULL_UP_10K	//PC2 - PC5ʹ1Msuspendѹ


#define PULL_WAKEUP_SRC_PB1		GPIO_PULL_UP_1M	//SCLK
#define PULL_WAKEUP_SRC_PB6		GPIO_PULL_UP_10K
#define PULL_WAKEUP_SRC_PC2		GPIO_PULL_UP_10K	//Motion Pin 1MPULL UP

#define PULL_WAKEUP_SRC_PE0		GPIO_PULL_UP_1M
#define PULL_WAKEUP_SRC_PE1		GPIO_PULL_UP_1M

#define PE2_FUNC	AS_GPIO
#define PE3_FUNC	AS_GPIO

#define PC2_FUNC	AS_GPIO
#define PC3_FUNC	AS_GPIO

#define	GPIO_LED_2P4				GPIO_PA0
#define GPIO_LED_BLE				GPIO_PA0
#endif

#elif(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0)
#define DUAL_MOUSE_PUBLIC_BOARD 			0  //huaguan no k4 k5
#define DUAL_MOUSE_NEWMAN_BOARD				1 //no k4 k5
#define DUAL_MOUSE_THREE_BUTTON_BOARD		2
#define DUAL_MOUSE_NEWMAN_V3_BOARD		    3 
#define DUAL_MOUSE_YJX_V4_BOARD				4
#define DUAL_MOUSE_BingShou_V5_BOARD		5  //Three wave switch mode 
#define DUAL_MOUSE_BingShou_V6_BOARD		6  //Three wave switch mode 
#define DUAL_MOUSE_BingShou_V7_BOARD		7  //Three wave switch mode 
#define DUAL_MOUSE_wulian_V8_BOARD			8  //Three wave switch mode 
#define DUAL_MOUSE_wulian_V9_BOARD			9  //Three wave switch mode 
#define DUAL_MOUSE_wulian_V10_BOARD			10  //Three wave switch mode 
#define DUAL_MOUSE_wulian_V11_BOARD			11
#define DUAL_MOUSE_wulian_V12_BOARD			12


#define DM_BOARD_V2P0_BOARD_YKQ 			DUAL_MOUSE_PUBLIC_BOARD


#define MOUSE_SENSOR_WARKUP      1  //0ƶѣ 1رƶѡ

#define MOUSE_BUTTON_GPIO_REUSABILITY   	1 	//support gpio reusability

#if(MOUSE_BUTTON_GPIO_REUSABILITY)

	#define M_HW_BTN_LEFT	GPIO_PE3
	#define M_HW_BTN_RIGHT	GPIO_PA1
	#define M_HW_BTN_MIDL 	GPIO_PE2 
 
#if	(DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_BingShou_V5_BOARD)
	#define	M_HW_BTN_BB		GPIO_PE2 
	#define	M_HW_BTN_CPI	GPIO_PA1
	#define	M_HW_BTN_FB		GPIO_PE3
	
#else
	#define	M_HW_BTN_BB		GPIO_PE3    //ǰ
	#define	M_HW_BTN_CPI	GPIO_PA1
	#define	M_HW_BTN_FB		GPIO_PE2    //˼
#endif
	

	#define M_HW_BTN_MODE	GPIO_PC5

	#define M_HW_GPIO_LEVEL_LEFT		U8_MAX				//pull level , high
	#define M_HW_GPIO_LEVEL_RIGHT		U8_MAX				//pull level
	#define M_HW_GPIO_LEVEL_MIDL		U8_MAX				//pull level,  high
#if(DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_BingShou_V7_BOARD)
	#define M_HW_GPIO_LEVEL_HUOLI		U8_MAX
	#define M_HW_GPIO_LEVEL_CPI_JIAN	0
	#define PA0_INPUT_ENABLE		1		//RIGHT, BB
	#define PULL_WAKEUP_SRC_PA0		GPIO_PULL_UP_1M
	#define PA0_FUNC	AS_GPIO
#endif
	#define M_HW_GPIO_LEVEL_FB			0
	#define M_HW_GPIO_LEVEL_BB			0
	#define M_HW_GPIO_LEVEL_CPI			0

#endif

	#define PE2_INPUT_ENABLE		1		//LEFT, FB
	#define PA1_INPUT_ENABLE		1		//RIGHT, BB
	#define PE3_INPUT_ENABLE		1		//MIDDLE, CPI

	#define PC5_INPUT_ENABLE		1		//MODE

	#define PE0_INPUT_ENABLE		1		//Wheel0 Input enable
	#define PE1_INPUT_ENABLE		1		//Wheel1 Input enable

	#define PC2_INPUT_ENABLE		1		//MOTION
	#define PB6_INPUT_ENABLE		1		//SDIO, MUST SET

	#define PULL_WAKEUP_SRC_PA1		GPIO_PULL_UP_1M
	#define PULL_WAKEUP_SRC_PE2		GPIO_PULL_UP_1M
	#define PULL_WAKEUP_SRC_PE3		GPIO_PULL_UP_1M


	#define PULL_WAKEUP_SRC_PB1		GPIO_PULL_UP_1M		//SCLK
	#define PULL_WAKEUP_SRC_PB6		GPIO_PULL_UP_10K	//SDIO
	#define PULL_WAKEUP_SRC_PC2		GPIO_PULL_UP_10K	//Motion Pin
	#define PULL_WAKEUP_SRC_PC5		GPIO_PULL_UP_10K	//Mode Pin

	#define	GPIO_LED_2P4			GPIO_PC4
	#define GPIO_LED_BLE			GPIO_PC3

	#define PE2_FUNC	AS_GPIO
	#define PE3_FUNC	AS_GPIO

	#define PC2_FUNC	AS_GPIO
	#define PC3_FUNC	AS_GPIO


#elif(DUAL_MOUSE_BOARD == DUAL_MOUSE_MIMOUSE_BOARD)

#define PA1_INPUT_ENABLE		1		//LEFT
#define PE2_INPUT_ENABLE		1		//RIGHT
#define PE3_INPUT_ENABLE		1		//MIDDLE
#define PA0_INPUT_ENABLE		1		//BOUND

#define PE0_INPUT_ENABLE		1		//Wheel1 Input enable
#define PE1_INPUT_ENABLE		1		//Wheel0 Input enable
#define PA7_INPUT_ENABLE		1		//MOTION

#define PULL_WAKEUP_SRC_PA1		GPIO_PULL_UP_1M
#define PULL_WAKEUP_SRC_PE2		GPIO_PULL_UP_1M
#define PULL_WAKEUP_SRC_PE3		GPIO_PULL_UP_1M
#define PULL_WAKEUP_SRC_PA0		GPIO_PULL_UP_1M

#define PULL_WAKEUP_SRC_PA7		GPIO_PULL_UP_1M

#define PULL_WAKEUP_SRC_PD3		GPIO_PULL_DN_100K	//wheel3
#define PULL_WAKEUP_SRC_PA4		GPIO_PULL_UP_1M		//SCLK
#define PULL_WAKEUP_SRC_PB5		GPIO_PULL_UP_1M		//MISO
#define PULL_WAKEUP_SRC_PB6		GPIO_PULL_UP_1M		//MOSI


#define GPIO_LED_R		GPIO_PC4
#define GPIO_LED_G		GPIO_PC5
#define GPIO_LED_B		GPIO_PD2


#endif


/////////////////// MODULE /////////////////////////////////
#define BLE_MOUSE_PM_ENABLE					1
#define BLE_REMOTE_SECURITY_ENABLE      	1
#define SECURE_CONNECTION_ENABLE			0
#define BLE_CORE42_DATA_LENGTH_EXTENSION_ENABLE 	0


#ifndef MOUSE_GOLDEN_VPATTERN
#define MOUSE_GOLDEN_VPATTERN   0
#endif

#ifndef MOUSE_NO_HW_SIM
#define MOUSE_NO_HW_SIM         (MOUSE_GOLDEN_VPATTERN || MOUSE_EMI_4_FCC || 0)
#endif

#define	MOUSE_V_PATERN_MODE	    (MOUSE_NO_HW_SIM || 0)



#define HID_MOUSE_ATT_ENABLE				1
/////////////////// Clock  /////////////////////////////////
#define CLOCK_SYS_TYPE  		CLOCK_TYPE_PLL	//  one of the following:  CLOCK_TYPE_PLL, CLOCK_TYPE_OSC, CLOCK_TYPE_PAD, CLOCK_TYPE_ADC
#define CLOCK_SYS_CLOCK_HZ  	16000000

//////////////////Extern Crystal Type///////////////////////
#define CRYSTAL_TYPE			XTAL_12M		//  extern 12M crystal


/////////////////// watchdog  //////////////////////////////
#define MODULE_WATCHDOG_ENABLE		0
#define WATCHDOG_INIT_TIMEOUT		500  //ms


/////////////////// set default   ////////////////

#include "../common/default_config.h"

/* Disable C linkage for C++ Compilers: */
#if defined(__cplusplus)
}
#endif
