
#include "../../proj/tl_common.h"

#include "../../proj/mcu/watchdog_i.h"
#include "../../vendor/common/user_config.h"
#include "../../proj_lib/rf_drv.h"
#include "../../proj_lib/pm.h"
#include "../../proj_lib/ble/ll/ll.h"
#include "mouse.h"
#include "mouse_button.h"
#include "../common/blt_led.h"

#include "../link_layer/rf_ll.h"

#if (__PROJECT_8261_MULTI_MOUSE__ )
extern led_cfg_t led_cfg[];

extern int binding_mode_addr_idx;
extern u8 binding_mode_addr[4];

extern u8 last_mouse_id[8];
extern int last_mouse_id_idx;

extern void user_init();

extern int dual_mouse_binding_info_load();

_attribute_ram_code_ void irq_handler(void)
{
	static u16 src_rf;
#if(UART_INIT_EN)

	unsigned char irqS = reg_dma_rx_rdy0;
    if(irqS & FLD_DMA_UART_RX)	//rx
    {
    	reg_dma_rx_rdy0 = FLD_DMA_UART_RX;
    	u8* w = hci_rx_fifo.p + (hci_rx_fifo.wptr & (hci_rx_fifo.num-1)) * hci_rx_fifo.size;
    	if(w[0]!=0)
    	{
    		my_fifo_next(&hci_rx_fifo);
    		u8* p = hci_rx_fifo.p + (hci_rx_fifo.wptr & (hci_rx_fifo.num-1)) * hci_rx_fifo.size;
    		reg_dma0_addr = (u16)((u32)p);

    	}

    	rx_from_uart_cb();

    }
#endif
    if(button_func.system_mode == RF_2M_2P4G_MODE){

        src_rf = reg_rf_irq_status;
		if(src_rf & FLD_RF_IRQ_RX){
			irq_device_rx();
		}

		if(src_rf & FLD_RF_IRQ_TX){
			irq_device_tx();
		}

    }
    else{
    	irq_blt_sdk_handler ();
    }





}
void cpu_32k_rc_calibration(int xtal_type)
{
   u8 cap_32k;
   u8 cres_32k;
	analog_write(0x80, 0x61);  //16m digital clock on



	//32k rc calibration
	//ana_2e<0> 1 for 32k cal enable
	//ana_2e<7> 1 for cal clock ref 12M (0 for 16M)
	//ana_2f<5> 1 for cal from module
	//ana_2f<7> 1 for cal clock enable
	int i;

	analog_write (0x2f, 0xbc);	//
	if(IS_XTAL_12M(xtal_type)){
		analog_write (0x2e, 0xf6);	//ana_2e<7>
	}
	else{
		analog_write (0x2e, 0x76);	//ana_2e<7>
	}

	for (i=0; i<100; i++);

	if(IS_XTAL_12M(xtal_type)){
		analog_write (0x2e, 0xf7);	//ana_2e<7>
	}
	else{
		analog_write (0x2e, 0x77);	//ana_2e<7>
	}

	for (i=0; i<10000; i++) {
		if (analog_read (0x44) & 0x10) {
			cap_32k = analog_read (0x45);
			cres_32k = analog_read (0x46);
			analog_write (0x31, cres_32k);
			analog_write (0x32, cap_32k);
			//analog_write (0x2f, 0x8e);	//
			break;
		}
	}

	analog_write (0x2f, 0x8c);	//

}

#if 0

void PM_LowCurrentLDOPwrLvlSet(unsigned char level)
{
    if (LOW_CURRENT_LDO_PWR_LVL_1_25_V == level) {
     analog_write(0x01, analog_read(0x01) | 0x04); //set bit2 of ana_reg01
    }
    else if (LOW_CURRENT_LDO_PWR_LVL_1_4_V == level) {
     analog_write(0x01, analog_read(0x01) & 0xfb); //clear bit2 of ana_reg01
     analog_write(0x00, analog_read(0x00) & 0x7f); //clear bit7 of ana_reg00
    }
    else if (LOW_CURRENT_LDO_PWR_LVL_1_6_V == level) {
     analog_write(0x01, analog_read(0x01) & 0xf3); //clear bit2 and bit3 of ana_reg01
     analog_write(0x00, analog_read(0x00) | 0x80); //set bit7 of ana_reg00
    }
    else if (LOW_CURRENT_LDO_PWR_LVL_1_8_V == level) {
     analog_write(0x01, analog_read(0x01) & 0xfb); //clear bit2 of ana_reg01
     analog_write(0x01, analog_read(0x01) | 0x08); //set bit3 of ana_reg01
     analog_write(0x00, analog_read(0x00) | 0x80); //set bit7 of ana_reg00
    }
    else {
 
    }
}

#else

void PM_LowCurrentLDOPwrLvlSet()
{
    
    
     analog_write(0x01, analog_read(0x01) & 0xfb); //clear bit2 of ana_reg01
     analog_write(0x00, analog_read(0x00) & 0x7f); //clear bit7 of ana_reg00
   
    
}
#endif
#if((DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_BingShou_V5_BOARD)&&(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0))
#define GPIO_MODE_SWITCH   GPIO_PC3
void three_switch_mode_change()
{
	gpio_set_input_en(GPIO_MODE_SWITCH,1);
	gpio_setup_up_down_resistor(GPIO_MODE_SWITCH,PM_PIN_PULLUP_10K);
	sleep_us(20);
	if(gpio_read(GPIO_MODE_SWITCH)==0)
	{
		button_func.system_mode=RF_1M_BLE_MODE;
		//gpio_set_input_en(GPIO_MODE_SWITCH,0);
		
	}
	else
	{
		button_func.system_mode=RF_2M_2P4G_MODE;
	}
	gpio_setup_up_down_resistor(GPIO_MODE_SWITCH,PM_PIN_UP_DOWN_FLOAT);
}
void mode_led_display()
{
	u8 deep_flag=analog_read(DEEP_ANA_REG6);
	analog_write(DEEP_ANA_REG6,1);
    if(deep_flag)
    {
		return;
    }
	if(button_func.system_mode == RF_1M_BLE_MODE)
	{
		device_led_init(GPIO_LED_2P4, 1);
		device_led_setup(led_cfg[LED_2P4_SWITCH_MODE]);
		
	}
	else
	{
		device_led_init(GPIO_LED_BLE, 1);
		device_led_setup(led_cfg[LED_BLE_SWITCH_MODE]);
	}
}
#endif

#if((DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_BingShou_V7_BOARD)&&(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0))
#define GPIO_MODE_SWITCH   GPIO_PC3
void three_switch_mode_change()
{
	gpio_set_input_en(GPIO_MODE_SWITCH,1);
	gpio_setup_up_down_resistor(GPIO_MODE_SWITCH,PM_PIN_PULLUP_10K);
	sleep_us(20);
	if(gpio_read(GPIO_MODE_SWITCH)==0)
	{
		button_func.system_mode=RF_1M_BLE_MODE;
		//gpio_set_input_en(GPIO_MODE_SWITCH,0);
		
	}
	else
	{
		button_func.system_mode=RF_2M_2P4G_MODE;
	}
	gpio_setup_up_down_resistor(GPIO_MODE_SWITCH,PM_PIN_UP_DOWN_FLOAT);
}
void mode_led_display()
{
	u8 deep_flag=analog_read(DEEP_ANA_REG6);
	analog_write(DEEP_ANA_REG6,1);
    if(deep_flag)
    {
		return;
    }
	if(button_func.system_mode == RF_1M_BLE_MODE)
	{
		device_led_init(GPIO_LED_2P4, 1);
		device_led_setup(led_cfg[LED_2P4_SWITCH_MODE]);
		
	}
	else
	{
		device_led_init(GPIO_LED_BLE, 1);
		device_led_setup(led_cfg[LED_BLE_SWITCH_MODE]);
	}
}
#endif

#if((DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_BingShou_V6_BOARD)&&(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0))
#define GPIO_MODE_SWITCH   GPIO_PC3
void three_switch_mode_change()
{
	gpio_set_input_en(GPIO_MODE_SWITCH,1);
	gpio_setup_up_down_resistor(GPIO_MODE_SWITCH,PM_PIN_PULLUP_10K);
	sleep_us(20);
	if(gpio_read(GPIO_MODE_SWITCH)==0)
	{
		button_func.system_mode=RF_1M_BLE_MODE;
		//gpio_set_input_en(GPIO_MODE_SWITCH,0);
		
	}
	else
	{
		button_func.system_mode=RF_2M_2P4G_MODE;
	}
	gpio_setup_up_down_resistor(GPIO_MODE_SWITCH,PM_PIN_UP_DOWN_FLOAT);
}
void mode_led_display()
{
	u8 deep_flag=analog_read(DEEP_ANA_REG6);
	analog_write(DEEP_ANA_REG6,1);
    if(deep_flag)
    {
		return;
    }
	if(button_func.system_mode == RF_1M_BLE_MODE)
	{
		device_led_init(GPIO_LED_2P4, 1);
		device_led_setup(led_cfg[LED_2P4_SWITCH_MODE]);
		
	}
	else
	{
		device_led_init(GPIO_LED_BLE, 1);
		device_led_setup(led_cfg[LED_BLE_SWITCH_MODE]);
	}
}
#endif

u8 fun_mode;
int main (void) {

	bls_ota_setFirmwareSizeAndOffset(48, 0xc000);			//FW Size is 48K, and then next 48K (0xc000-0x18000) is used for new FW

	blc_pm_select_internal_32k_crystal();					//Select interal 32k crystal

	cpu_wakeup_init(CRYSTAL_TYPE);							//Select 12M

	clock_init();

	set_tick_per_us(CLOCK_SYS_CLOCK_HZ/1000000);
#if 1
	cpu_32k_rc_calibration(CRYSTAL_TYPE);
#endif
	gpio_init();

#if(MOUSE_ONLY_BLE_MODE)
	//binding_mode_addr_idx = dual_mouse_binding_info_load(CFG_DEVICE_MODE_ADDR, binding_mode_addr, 4);
	button_func.system_mode = RF_1M_BLE_MODE;
#else
	binding_mode_addr_idx = dual_mouse_binding_info_load(CFG_DEVICE_MODE_ADDR, binding_mode_addr, 4);
	button_func.system_mode = binding_mode_addr[0] ? RF_1M_BLE_MODE : RF_2M_2P4G_MODE;

	last_mouse_id_idx = dual_mouse_binding_info_load(CUST_MOUSE_ID_SAVE_ADDR, last_mouse_id, 8);
#if(((DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_YJX_V4_BOARD)	|| (DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_wulian_V9_BOARD) ||(DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_wulian_V10_BOARD))&&(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0))
	button_func.system_mode = RF_1M_BLE_MODE ;
#endif

#endif
#if((DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_BingShou_V5_BOARD)&&(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0))
	three_switch_mode_change();
#elif((DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_BingShou_V6_BOARD)&&(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0))
	three_switch_mode_change();
#elif((DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_BingShou_V7_BOARD)&&(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0))
	three_switch_mode_change();

#endif
	rf_drv_init( button_func.system_mode == RF_2M_2P4G_MODE ? XTAL_12M_RF_2m_MODE : XTAL_12M_RF_1m_MODE);

	user_init ();
    PM_LowCurrentLDOPwrLvlSet();
	fun_mode=button_func.system_mode;

    irq_enable();
#if((DM_BOARD_V2P0_BOARD_YKQ== DUAL_MOUSE_NEWMAN_BOARD)||(DM_BOARD_V2P0_BOARD_YKQ== DUAL_MOUSE_NEWMAN_V3_BOARD)||(DM_BOARD_V2P0_BOARD_YKQ== DUAL_MOUSE_wulian_V11_BOARD)||(DM_BOARD_V2P0_BOARD_YKQ== DUAL_MOUSE_wulian_V12_BOARD))

	mouse_button_power_dectect();

#endif
#if((DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_BingShou_V5_BOARD)&&(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0))
	mode_led_display();
#elif((DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_BingShou_V6_BOARD)&&(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0))
	mode_led_display();
#elif((DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_BingShou_V7_BOARD)&&(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0))
	mode_led_display();
#endif
	while (1) {
#if (MODULE_WATCHDOG_ENABLE)
		wd_clear(); //clear watch dog
#endif
		main_loop ();
	}
}


#endif
