/*
 * mouse_button.c
 *
 *  Created on: Feb 12, 2014
 *      Author: xuzhen
 */

#include "../../proj/tl_common.h"
#include "../common/rf_frame.h"
#include "../../proj_lib/pm.h"
#include "../common/blt_led.h"
#include "mouse.h"
#include "mouse_custom.h"
#include "mouse_rf.h"
#include "mouse_custom.h"
#include "mouse_button.h"
#include "trace.h"

#include "../../proj_lib/ble/ll/ll.h"

static u8 button_last;  //current button
static u8 button_pre;   //history button
#if((DM_BOARD_V2P0_BOARD_YKQ== DUAL_MOUSE_NEWMAN_BOARD)||(DM_BOARD_V2P0_BOARD_YKQ== DUAL_MOUSE_NEWMAN_V3_BOARD) ||(DM_BOARD_V2P0_BOARD_YKQ== DUAL_MOUSE_wulian_V11_BOARD)||(DM_BOARD_V2P0_BOARD_YKQ== DUAL_MOUSE_wulian_V12_BOARD))

u8 btn_power_value;
#endif
#if(!MOUSE_BUTTON_GPIO_REUSABILITY)
	static u32 gpio_btn_all;
	u32 gpio_btn_valid[MAX_MOUSE_BUTTON];
#endif

void mouse_button_init(mouse_hw_t *mouse_hw)
{
    u32 level;
    u32 spec_pin;

	for(int i=0;i<MAX_MOUSE_BUTTON;i++){
#if(!MOUSE_BUTTON_GPIO_REUSABILITY)
		spec_pin = mouse_hw->button[i];
		level = (mouse_hw->gpio_level_button[i] == U8_MAX);  //0xffpullup   others:pulldown
		gpio_btn_valid[i] =	level ? 0 : spec_pin;  //1:Ч  0:Ч
		gpio_btn_all |= spec_pin;

		gpio_set_input_en(spec_pin, 1);
#if(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0)
		if(i< MAX_MOUSE_BUTTON - 1)
			gpio_setup_up_down_resistor(spec_pin, level );
		else
			gpio_setup_up_down_resistor(spec_pin, PM_PIN_PULLUP_10K );	//PC5
#endif

#endif

#if MOUSE_GPIO_FULL_RE_DEF
		gpio_set_func(spec_pin,AS_GPIO);
		gpio_set_output_en(spec_pin, 0);
		gpio_set_input_en(spec_pin, 1);
#endif
	}
}

#if 0
const u32	button_seq_button_middle_click2 =	// LRM - LR - LRM - LR
		((FLAG_BUTTON_LEFT | FLAG_BUTTON_RIGHT | FLAG_BUTTON_MIDDLE) << 24) |
		((FLAG_BUTTON_LEFT | FLAG_BUTTON_RIGHT) << 16) |
		((FLAG_BUTTON_LEFT | FLAG_BUTTON_RIGHT | FLAG_BUTTON_MIDDLE) << 8) |
		((FLAG_BUTTON_LEFT | FLAG_BUTTON_RIGHT) << 0);

const u32	button_seq_paring =	                // LR - LRM - LR
		((FLAG_BUTTON_LEFT | FLAG_BUTTON_RIGHT | 0x80) << 16) |
		((FLAG_BUTTON_LEFT | FLAG_BUTTON_RIGHT | FLAG_BUTTON_MIDDLE) << 8) |
		((FLAG_BUTTON_LEFT | FLAG_BUTTON_RIGHT) << 0);

const u32	button_seq_emi =                    // LRM - LR - LRM - LR
		((FLAG_BUTTON_LEFT | FLAG_BUTTON_RIGHT | FLAG_BUTTON_MIDDLE | 0x80) << 24) |
		((FLAG_BUTTON_LEFT | FLAG_BUTTON_RIGHT) << 16) |
		((FLAG_BUTTON_LEFT | FLAG_BUTTON_RIGHT | FLAG_BUTTON_MIDDLE) << 8) |
		((FLAG_BUTTON_LEFT | FLAG_BUTTON_RIGHT) << 0);




static inline u32 mouse_button_special_seq( u32 button, u32 multi_seq, u32 power_on, u32 paring_anytime ){
    static u32  button_seq = 0;
    static u32  button_seq1 = 0;
    static u32  button_seq2 = 0;    
    u32 specail_seq;
    u32 seq = 0;
    u32  mouse_pairing_ui = mouse_btn_ui.mode_switch_ui;
    u32  mouse_emi_ui = mouse_btn_ui.emi_ui;



    if( multi_seq ){
        if( power_on )
            button |= 0x80;
        button_seq = (button_seq << 8) | (button_seq1>>24);
        button_seq1 = (button_seq1 << 8) | (button_seq2>>24);
        button_seq2 = (button_seq2 << 8) | button;
        specail_seq = (button_seq_button_middle_click2 == button_seq1)\
               && (button_seq_button_middle_click2 == button_seq2);
        mouse_pairing_ui = button_seq_paring;
        mouse_emi_ui = button_seq_emi;
    }
    else{
        button_seq = button;
        specail_seq = power_on;
    }

    if( specail_seq ){
        if( button_seq == mouse_pairing_ui ){
            seq = BTN_INTO_PAIRING;
    	}
    	else if (button_seq == mouse_emi_ui) {
           seq = BTN_INTO_EMI;
    	}
        else if ( button_seq == button_seq1 ){
            seq = BTN_INTO_SPECL_MODE;
            button_seq2 = 0xff;     //next spcail sequence must be the same with the last one
        }
    }
    else if ( paring_anytime && (button_seq == mouse_pairing_ui) ){
        seq = BTN_INTO_PAIRING;
    }
    
    return seq;
}
#endif
static inline void mouse_button_process_test_mode( u8 *mouse_mode, u8 *dbg_mode, u32 button, u32 test_mode ){
    if( (test_mode == BTN_INTO_PAIRING) && !button ) {
        *mouse_mode = STATE_PAIRING;
	}
    else if( (test_mode == BTN_INTO_EMI) && !button ) {            
       	*mouse_mode = STATE_EMI;
    }
#if MOUSE_BUTTON_FULL_FUNCTION    
    if( (test_mode == BTN_INTO_SPECL_MODE) && (button & FLAG_BUTTON_LEFT) && (button & FLAG_BUTTON_RIGHT) ){
        *dbg_mode |= STATE_TEST_0_BIT;
    }
    else if ( button == 0 )
        *dbg_mode &= ~STATE_TEST_0_BIT;
    
    if( (test_mode == BTN_INTO_SPECL_MODE)&& !(button & FLAG_BUTTON_LEFT) && (button & FLAG_BUTTON_RIGHT)  )
        *dbg_mode |= STATE_TEST_EMI_BIT;
    else
        *dbg_mode &= ~STATE_TEST_EMI_BIT;
    
    if( (test_mode == BTN_INTO_SPECL_MODE) && (button & FLAG_BUTTON_LEFT) && !(button & FLAG_BUTTON_RIGHT) ){
        *dbg_mode |= STATE_TEST_V_BIT;
    }
    else
        *dbg_mode &= ~STATE_TEST_V_BIT;
#endif
}

//extern u8 adv_type_switch;
extern u8 adv_direct_ind_flg;
//extern u8 SysMode;
//extern u16 BLE_MODE_SWITCH_THRESH;
//extern u16 switch_mode_start_flg;
extern led_cfg_t led_cfg[];
extern led_cfg_t led_cpi[];

button_func_t button_func;

extern int binding_mode_addr_idx;
extern void adv_duration_timeout (u8 e, u8 *p, int n);


u8 first_adv_switch;


#if((DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_NEWMAN_BOARD)&&(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0))				//for newman dual mode mouse

u32 mouse_button_process(mouse_status_t * mouse_status)
{
	static u8 mouse_button_dpi_pressed_flg = 0;

#if((DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V1P0) && !DAUL_MOUSE_YJX_BOARD)

    //button_last: current button
    //button_pre: previous button


    //switch mode, or switch adv type
#if(!MOUSE_ONLY_BLE_MODE)
	if( button_func.start_switch_sys_mode && !DEVICE_LED_BUSY){

    	if(button_func.start_switch_sys_mode){
    		u32 binding_mode_value = (button_func.system_mode == RF_1M_BLE_MODE) ? 0 : 0x1;
			binding_mode_addr_idx += 4;
			flash_write_page(CFG_DEVICE_MODE_ADDR + binding_mode_addr_idx, 4, &binding_mode_value);
    	}

		irq_disable();
		REG_ADDR8(0x6f) = 0x20;
		while(1);
	}
#endif

#if(ADV_TYPE_SWITCH_BY_BUTTON)
	if( button_func.system_mode == RF_1M_BLE_MODE){

		if (blc_ll_getCurrentState() != BLS_LINK_STATE_CONN){

			if(first_adv_switch == 1){
				first_adv_switch = 2;
				adv_direct_ind_flg = 0;
				adv_duration_timeout(0,0,0);
			}
			else if(first_adv_switch == 2){
				if(!DEVICE_LED_BUSY){
					device_led_setup(led_cfg[LED_NON_DIR_ADV]);		//Ƕ㲥,led blink slowly
				}
			}

			if( !first_adv_switch && button_func.start_switch_adv_type ){
				first_adv_switch = 1;
				button_func.start_switch_adv_type = 0;

				button_func.adv_type_switch_flg = 0;					//ǿrelease
				button_func.adv_type_switch_tick = clock_time();
			}
		}
	}


#endif
    if(button_func.btn_released){
#if(ADV_TYPE_SWITCH_BY_BUTTON)
    	button_func.adv_type_switch_flg = 0;
#endif
    	button_func.sys_mode_switch_flg = 0;	//once the button be changed,  all flags be released
    	button_func.emi_mode_switch_flg = 0;
    	button_func.start_maual_pair = 0;


    	if( !button_last ){			//button -> no button
    		button_pre = button_last;
    		return 0;
    	}
#if(ADV_TYPE_SWITCH_BY_BUTTON)
    	if(button_func.system_mode == RF_1M_BLE_MODE && (blc_ll_getCurrentState() != BLS_LINK_STATE_CONN )&& button_last == mouse_btn_ui.ble_pair_mode_ui){
    		button_func.adv_type_switch_flg = 1;
    		button_func.adv_type_switch_tick = clock_time();
    	}
#endif
    	if(button_func.system_mode == RF_2M_2P4G_MODE){
    		//if(button_last == (FLAG_BUTTON_LEFT | FLAG_BUTTON_RIGHT |  FLAG_BUTTON_MIDDLE)){
    		if(button_last == mouse_btn_ui.emi_ui){
    			button_func.emi_mode_switch_flg = 1;
    			button_func.emi_mode_switch_tick = clock_time();
    		}
    		else if(button_last == mouse_btn_ui.manual_pair_ui){
    			button_func.start_maual_pair = 1;
    			button_func.start_manual_pair_tick = clock_time();
    		}
    	}

    	if(button_last == mouse_btn_ui.mode_switch_ui){
    		button_func.sys_mode_switch_flg = 1;
    		button_func.sys_mode_switch_tick = clock_time();
    	}

    	if((button_last == FLAG_BUTTON_DPI)) {            //new event
    		++mouse_status->cpi;
//    		mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
//    		mouse_sensor_set_cpi( &mouse_status->cpi );
//
//    		device_led_setup(led_cfg[mouse_status->cpi]);

			if(p_custom_cfg->sensor_type != U8_MAX){
				mouse_status->cpi = (4) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
				if(mouse_status->cpi == 3){
	    		device_led_setup(led_cfg[LED_CPI_3]);
				}
				else{
				device_led_setup(led_cfg[mouse_status->cpi]);
				}
			}
			else{
				mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
				device_led_setup(led_cfg[mouse_status->cpi]);
			}
    	}



    }
    else{

    	if( !button_last ){						//There is no button be pressed
        	button_pre = button_last;
        	return 0;
    	}
#if(ADV_TYPE_SWITCH_BY_BUTTON)
    	if((button_func.system_mode == RF_1M_BLE_MODE) && button_func.adv_type_switch_flg && adv_direct_ind_flg \
    			&& clock_time_exceed(button_func.adv_type_switch_tick, 3000000)){
    		button_func.start_switch_adv_type = 1;  //adv_type_switch = 1;
    	}
#endif
    	if(button_func.sys_mode_switch_flg &&  !button_func.start_switch_sys_mode && \
    			clock_time_exceed(button_func.sys_mode_switch_tick, 3000000)){
    		button_func.start_switch_sys_mode = 1;
    		//switch_mode_start_flg = 1;
    		if(button_func.system_mode == RF_2M_2P4G_MODE)
    			device_led_setup(led_cfg[LED_BLE_SWITCH_MODE]);
    		else
    			device_led_setup(led_cfg[LED_2P4_SWITCH_MODE]);
    	}

    	if(button_func.emi_mode_switch_flg && clock_time_exceed(button_func.emi_mode_switch_tick, 1000000) ){
			mouse_status->mouse_mode = STATE_EMI;
			return 0;
    	}

    	if(button_func.system_mode == RF_2M_2P4G_MODE){
    		u8 btn_into_pair_flg = 0;
    		u8 power_on = mouse_status->mouse_mode == STATE_POWERON;
    		if(button_func.start_maual_pair && clock_time_exceed(button_func.start_manual_pair_tick, 100000)){

    			button_func.start_maual_pair = 0;
    			btn_into_pair_flg = 1;
        		if(power_on || (!mouse_cust_pairing_only_poweron && device_never_linked )){
        			mouse_status->mouse_mode = STATE_PAIRING;
        		}

    		}
    	}

    }
#else
    //button_last: current button
    //button_pre: previous button


    //switch mode, or switch adv type
	if( button_func.start_switch_sys_mode && !DEVICE_LED_BUSY){

    	if(button_func.start_switch_sys_mode){
    		u32 binding_mode_value = (button_func.system_mode == RF_1M_BLE_MODE) ? 0 : 0x1;
			binding_mode_addr_idx += 4;
			flash_write_page(CFG_DEVICE_MODE_ADDR + binding_mode_addr_idx, 4, &binding_mode_value);
    	}

		irq_disable();
		REG_ADDR8(0x6f) = 0x20;
		while(1);
	}

#if(ADV_TYPE_SWITCH_BY_BUTTON)
	if( button_func.system_mode == RF_1M_BLE_MODE){

		if (blc_ll_getCurrentState() != BLS_LINK_STATE_CONN){

			if(first_adv_switch == 1){
				first_adv_switch = 2;
				adv_direct_ind_flg = 0;
				adv_duration_timeout(0,0,0);
			}
			else if(first_adv_switch == 2){
				if(!DEVICE_LED_BUSY){
					device_led_setup(led_cfg[LED_NON_DIR_ADV]);		//Ƕ㲥,led blink slowly
				}
			}

			if( !first_adv_switch && button_func.start_switch_adv_type ){
				first_adv_switch = 1;
				button_func.start_switch_adv_type = 0;

				button_func.adv_type_switch_flg = 0;					//ǿrelease
				button_func.adv_type_switch_tick = clock_time();
			}
		}
	}
#endif

    if(button_func.btn_released){

#if(ADV_TYPE_SWITCH_BY_BUTTON)
	if( button_func.system_mode == RF_1M_BLE_MODE  && (blc_ll_getCurrentState() != BLS_LINK_STATE_CONN)){
		if( !first_adv_switch && button_func.start_switch_adv_type ){

			first_adv_switch = 1;
			adv_direct_ind_flg = 0;

			adv_duration_timeout(0,0,0);
			button_func.start_switch_adv_type = 0;

		}
	}

	if(mouse_button_dpi_pressed_flg&&(btn_power_value==0)){

		++mouse_status->cpi;
		mouse_button_dpi_pressed_flg = 0;
//		mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
//		mouse_sensor_set_cpi( &mouse_status->cpi );
//
//		device_led_setup(led_cfg[mouse_status->cpi]);

		if(p_custom_cfg->sensor_type != U8_MAX){
			mouse_status->cpi = (4) ? mouse_status->cpi : 0;
			mouse_sensor_set_cpi( &mouse_status->cpi );
			if(mouse_status->cpi == 3){
    		device_led_setup(led_cfg[LED_CPI_3]);
			}
			else{
			device_led_setup(led_cfg[mouse_status->cpi]);
			}
		}
		else{
			mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
			mouse_sensor_set_cpi( &mouse_status->cpi );
			device_led_setup(led_cfg[mouse_status->cpi]);
		}
	}

#endif


#if(ADV_TYPE_SWITCH_BY_BUTTON)
    	button_func.adv_type_switch_flg = 0;
#endif
    	button_func.sys_mode_switch_flg = 0;	//once the button be changed,  all flags be released
    	button_func.emi_mode_switch_flg = 0;
    	button_func.start_maual_pair = 0;


    	if( !button_last ){			//button -> no button
    		button_pre = button_last;
			btn_power_value=0;
    		return 0;
    	}

    	if(button_func.system_mode == RF_2M_2P4G_MODE){
    		if(button_last == mouse_btn_ui.emi_ui){
    			button_func.emi_mode_switch_flg = 1;
    			button_func.emi_mode_switch_tick = clock_time();
    		}
    		else if(button_last == mouse_btn_ui.manual_pair_ui){
    			button_func.start_maual_pair = 1;
    			button_func.start_manual_pair_tick = clock_time();
    		}
    		else if(button_last == mouse_btn_ui.mode_switch_ui){
    			button_func.sys_mode_switch_flg = 1;
    			button_func.sys_mode_switch_tick = clock_time();
    		}
    	}
    	else{
#if(ADV_TYPE_SWITCH_BY_BUTTON)

        	if( button_last == mouse_btn_ui.ble_pair_mode_ui ){
        		button_func.adv_type_switch_flg = 1;
        		button_func.adv_type_switch_tick = clock_time();
        	}
#endif
        	if((btn_power_value==0)&&(button_last == mouse_btn_ui.mode_switch_ui)){
        		button_func.sys_mode_switch_flg = 1;
        		button_func.sys_mode_switch_tick = clock_time();
        	}
    	}
    	if((button_last == FLAG_BUTTON_DPI)) {            //new event
    		mouse_button_dpi_pressed_flg = 1;
    	}
    }
    else{

    	if( !button_last ){						//There is no button be pressed
        	button_pre = button_last;
        	return 0;
    	}

#if(ADV_TYPE_SWITCH_BY_BUTTON)
    	if(button_func.adv_type_switch_flg && clock_time_exceed(button_func.adv_type_switch_tick, 2000000)){
    		//mode button be pressed time exceed than 3s,adv switch
    		blt_state = BLS_LINK_STATE_ADV;
    		button_func.sys_mode_switch_flg = 0;

    		button_func.start_switch_adv_type = 1;
    		//button_func.start_switch_adv_type = adv_direct_ind_flg;
    	}
#endif


    	if(button_func.sys_mode_switch_flg && clock_time_exceed(button_func.sys_mode_switch_tick, 2000000)){
    		//mode button be pressed time exceed than 3s,adv switch
    		button_func.sys_mode_switch_flg = 0;
    		button_func.start_switch_sys_mode = 1;

        	if(button_func.system_mode == RF_2M_2P4G_MODE){
        		device_led_init(GPIO_LED_BLE, 1);
        		device_led_setup(led_cfg[LED_BLE_SWITCH_MODE]);
        	}
        	else{
        		device_led_init(GPIO_LED_2P4, 1);
        		device_led_setup(led_cfg[LED_2P4_SWITCH_MODE]);
        	}
    	}

    	if(button_func.emi_mode_switch_flg && clock_time_exceed(button_func.emi_mode_switch_tick, 1000000) ){
			mouse_status->mouse_mode = STATE_EMI;
			return 0;
    	}

    	if(button_func.system_mode == RF_2M_2P4G_MODE){
    		u8 btn_into_pair_flg = 0;
    		u8 power_on = mouse_status->mouse_mode == STATE_POWERON;
    		if(button_func.start_maual_pair && clock_time_exceed(button_func.start_manual_pair_tick, 100000)){

    			button_func.start_maual_pair = 0;
    			btn_into_pair_flg = 1;
        		//u8 mouse_pair_anytime = device_never_linked && !mouse_cust_pairing_only_poweron
        		if(power_on || (!mouse_cust_pairing_only_poweron && device_never_linked)){
        			mouse_status->mouse_mode = STATE_PAIRING;
        		}
    		}
    	}
    }


#endif

	button_pre = button_last;
}
#elif(((DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_PUBLIC_BOARD)&&(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0))||(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V1P0 ))				//for newman dual mode mouse



u32 mouse_button_process(mouse_status_t * mouse_status)
{

#if((DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V1P0) && !DAUL_MOUSE_YJX_BOARD)
    //button_last: current button
    //button_pre: previous button


    //switch mode, or switch adv type
#if(!MOUSE_ONLY_BLE_MODE)
	if( button_func.start_switch_sys_mode && !DEVICE_LED_BUSY){

    	if(button_func.start_switch_sys_mode){
    		u32 binding_mode_value = (button_func.system_mode == RF_1M_BLE_MODE) ? 0 : 0x1;
			binding_mode_addr_idx += 4;
			flash_write_page(CFG_DEVICE_MODE_ADDR + binding_mode_addr_idx, 4, &binding_mode_value);
    	}

		irq_disable();
		REG_ADDR8(0x6f) = 0x20;
		while(1);
	}
#endif

#if(ADV_TYPE_SWITCH_BY_BUTTON)
	if( button_func.system_mode == RF_1M_BLE_MODE){

		if (blc_ll_getCurrentState() != BLS_LINK_STATE_CONN){

			if(first_adv_switch == 1){
				first_adv_switch = 2;
				adv_direct_ind_flg = 0;
				adv_duration_timeout(0,0,0);
			}
			else if(first_adv_switch == 2){
				if(!DEVICE_LED_BUSY){
					device_led_setup(led_cfg[LED_NON_DIR_ADV]);		//Ƕ㲥,led blink slowly
				}
			}

			if( !first_adv_switch && button_func.start_switch_adv_type ){
				first_adv_switch = 1;
				button_func.start_switch_adv_type = 0;

				button_func.adv_type_switch_flg = 0;					//ǿrelease
				button_func.adv_type_switch_tick = clock_time();
			}
		}
	}


#endif
    if(button_func.btn_released){
#if(ADV_TYPE_SWITCH_BY_BUTTON)
    	button_func.adv_type_switch_flg = 0;
#endif
    	button_func.sys_mode_switch_flg = 0;	//once the button be changed,  all flags be released
    	button_func.emi_mode_switch_flg = 0;
    	button_func.start_maual_pair = 0;


    	if( !button_last ){			//button -> no button
    		button_pre = button_last;
    		return 0;
    	}
#if(ADV_TYPE_SWITCH_BY_BUTTON)
    	if(button_func.system_mode == RF_1M_BLE_MODE && (blc_ll_getCurrentState() != BLS_LINK_STATE_CONN )&& button_last == mouse_btn_ui.ble_pair_mode_ui){
    		button_func.adv_type_switch_flg = 1;
    		button_func.adv_type_switch_tick = clock_time();
    	}
#endif
    	if(button_func.system_mode == RF_2M_2P4G_MODE){
    		//if(button_last == (FLAG_BUTTON_LEFT | FLAG_BUTTON_RIGHT |  FLAG_BUTTON_MIDDLE)){
    		if(button_last == mouse_btn_ui.emi_ui){
    			button_func.emi_mode_switch_flg = 1;
    			button_func.emi_mode_switch_tick = clock_time();
    		}
    		else if(button_last == mouse_btn_ui.manual_pair_ui){
    			button_func.start_maual_pair = 1;
    			button_func.start_manual_pair_tick = clock_time();
    		}
    	}

    	if(button_last == mouse_btn_ui.mode_switch_ui){
    		button_func.sys_mode_switch_flg = 1;
    		button_func.sys_mode_switch_tick = clock_time();
    	}

    	if((button_last == FLAG_BUTTON_DPI)) {            //new event
    		++mouse_status->cpi;
//    		mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
//    		mouse_sensor_set_cpi( &mouse_status->cpi );
//
//    		device_led_setup(led_cfg[mouse_status->cpi]);

    		if(p_custom_cfg->sensor_type != U8_MAX){
    			mouse_status->cpi = (4) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
    			if(mouse_status->cpi == 3){
        		device_led_setup(led_cfg[LED_CPI_3]);
    			}
    			else{
    			device_led_setup(led_cfg[mouse_status->cpi]);
    			}
    		}
    		else{
    			mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
    			device_led_setup(led_cfg[mouse_status->cpi]);
    		}
    	}



    }
    else{

    	if( !button_last ){						//There is no button be pressed
        	button_pre = button_last;
        	return 0;
    	}
#if(ADV_TYPE_SWITCH_BY_BUTTON)
    	if((button_func.system_mode == RF_1M_BLE_MODE) && button_func.adv_type_switch_flg && adv_direct_ind_flg \
    			&& clock_time_exceed(button_func.adv_type_switch_tick, 3000000)){
    		button_func.start_switch_adv_type = 1;  //adv_type_switch = 1;
    	}
#endif
    	if(button_func.sys_mode_switch_flg &&  !button_func.start_switch_sys_mode && \
    			clock_time_exceed(button_func.sys_mode_switch_tick, 3000000)){
    		button_func.start_switch_sys_mode = 1;
    		//switch_mode_start_flg = 1;
    		if(button_func.system_mode == RF_2M_2P4G_MODE)
    			device_led_setup(led_cfg[LED_BLE_SWITCH_MODE]);
    		else
    			device_led_setup(led_cfg[LED_2P4_SWITCH_MODE]);
    	}

    	if(button_func.emi_mode_switch_flg && clock_time_exceed(button_func.emi_mode_switch_tick, 1000000) ){
			mouse_status->mouse_mode = STATE_EMI;
			return 0;
    	}

    	if(button_func.system_mode == RF_2M_2P4G_MODE){
    		u8 btn_into_pair_flg = 0;
    		u8 power_on = mouse_status->mouse_mode == STATE_POWERON;
    		if(button_func.start_maual_pair && clock_time_exceed(button_func.start_manual_pair_tick, 100000)){

    			button_func.start_maual_pair = 0;
    			btn_into_pair_flg = 1;
        		if(power_on || (!mouse_cust_pairing_only_poweron && device_never_linked )){
        			mouse_status->mouse_mode = STATE_PAIRING;
        		}

    		}
    	}

    }
#else
    //button_last: current button
    //button_pre: previous button

	if( button_func.start_switch_sys_mode && !DEVICE_LED_BUSY){

    	if(button_func.start_switch_sys_mode){
    		u32 binding_mode_value = (button_func.system_mode == RF_1M_BLE_MODE) ? 0 : 0x1;
			binding_mode_addr_idx += 4;
			flash_write_page(CFG_DEVICE_MODE_ADDR + binding_mode_addr_idx, 4, &binding_mode_value);
    	}

		irq_disable();
		REG_ADDR8(0x6f) = 0x20;
		while(1);
	}
#if(ADV_TYPE_SWITCH_BY_BUTTON)
	if( button_func.system_mode == RF_1M_BLE_MODE){

		if (blc_ll_getCurrentState() != BLS_LINK_STATE_CONN){

			if(first_adv_switch == 1){
				first_adv_switch = 2;
				adv_direct_ind_flg = 0;
				adv_duration_timeout(0,0,0);
			}
			else if(first_adv_switch == 2){
				if(!DEVICE_LED_BUSY){
					device_led_setup(led_cfg[LED_NON_DIR_ADV]);		//Ƕ㲥,led blink slowly
				}
			}

			if( !first_adv_switch && button_func.start_switch_adv_type ){
				first_adv_switch = 1;
				button_func.start_switch_adv_type = 0;

				button_func.adv_type_switch_flg = 0;					//ǿrelease
				button_func.adv_type_switch_tick = clock_time();
			}
		}
	}
#endif
    if(button_func.btn_released){


    	if(button_func.system_mode == RF_1M_BLE_MODE && button_func.sys_mode_switch_flg){
    		button_func.start_switch_sys_mode = 1;
    		device_led_init(GPIO_LED_2P4, 1);
    		device_led_setup(led_cfg[LED_2P4_SWITCH_MODE]);
    	}

#if(ADV_TYPE_SWITCH_BY_BUTTON)
    	button_func.adv_type_switch_flg = 0;
#endif
    	button_func.sys_mode_switch_flg = 0;	//once the button be changed,  all flags be released
    	button_func.emi_mode_switch_flg = 0;
    	button_func.start_maual_pair = 0;


    	if( !button_last ){			//button -> no button
    		button_pre = button_last;
    		return 0;
    	}

    	if(button_func.system_mode == RF_2M_2P4G_MODE){
    		if(button_last == mouse_btn_ui.emi_ui){
    			button_func.emi_mode_switch_flg = 1;
    			button_func.emi_mode_switch_tick = clock_time();
    		}
    		else if(button_last == mouse_btn_ui.manual_pair_ui){
    			button_func.start_maual_pair = 1;
    			button_func.start_manual_pair_tick = clock_time();
    		}
    		else if(button_last == mouse_btn_ui.mode_switch_ui){
    			button_func.start_switch_sys_mode = 1;
    			device_led_init(GPIO_LED_BLE, 1);
    			device_led_setup(led_cfg[LED_BLE_SWITCH_MODE]);
    		}
    	}
    	else{
    		if(button_last == mouse_btn_ui.mode_switch_ui){
    			button_func.sys_mode_switch_flg = 1;
    		}
#if(ADV_TYPE_SWITCH_BY_BUTTON)

        	if( button_last == mouse_btn_ui.ble_pair_mode_ui ){
        		button_func.adv_type_switch_flg = 1;
        		button_func.adv_type_switch_tick = clock_time();
        	}
#endif

    	}

    	if((button_last == FLAG_BUTTON_DPI)) {            //new event
    		++mouse_status->cpi;
//    		mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
//    		mouse_sensor_set_cpi( &mouse_status->cpi );
//
//    		device_led_setup(led_cfg[mouse_status->cpi]);

			if(p_custom_cfg->sensor_type != U8_MAX){
				mouse_status->cpi = (4) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
				if(mouse_status->cpi == 3){
	    		device_led_setup(led_cfg[LED_CPI_3]);
				}
				else{
				device_led_setup(led_cfg[mouse_status->cpi]);
				}
			}
			else{
				mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
				device_led_setup(led_cfg[mouse_status->cpi]);
			}
    	}



    }
    else{

    	if( !button_last ){						//There is no button be pressed
        	button_pre = button_last;
        	return 0;
    	}
#if(ADV_TYPE_SWITCH_BY_BUTTON)
    	if(button_func.adv_type_switch_flg && clock_time_exceed(button_func.adv_type_switch_tick, 2000000)){
    		//mode button be pressed time exceed than 3s,adv switch
    		blt_state = BLS_LINK_STATE_ADV;
    		button_func.sys_mode_switch_flg = 0;

    		button_func.start_switch_adv_type = 1;
    		//button_func.start_switch_adv_type = adv_direct_ind_flg;
    	}
#endif

    	if(button_func.emi_mode_switch_flg && clock_time_exceed(button_func.emi_mode_switch_tick, 1000000) ){
			mouse_status->mouse_mode = STATE_EMI;
			return 0;
    	}

    	if(button_func.system_mode == RF_2M_2P4G_MODE){
    		u8 btn_into_pair_flg = 0;
    		u8 power_on = mouse_status->mouse_mode == STATE_POWERON;
    		if(button_func.start_maual_pair && clock_time_exceed(button_func.start_manual_pair_tick, 100000)){

    			button_func.start_maual_pair = 0;
    			btn_into_pair_flg = 1;
        		//u8 mouse_pair_anytime = device_never_linked && !mouse_cust_pairing_only_poweron
        		if(power_on || (!mouse_cust_pairing_only_poweron && device_never_linked)){
        			mouse_status->mouse_mode = STATE_PAIRING;
        		}
    		}
    	}
    }
#endif

	button_pre = button_last;

}
#elif((DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_THREE_BUTTON_BOARD)&&(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0))//for only three button

#define DPI_CHANGE_BTN 	FLAG_BUTTON_DPI		//(FLAG_BUTTON_RIGHT|FLAG_BUTTON_MIDDLE)
u8 dpi_press=0;

u32 dpi_tick=0;
u32 mouse_button_process(mouse_status_t * mouse_status)
{

    //button_last: current button
    //button_pre: previous button

	if(button_func.start_switch_sys_mode && !DEVICE_LED_BUSY){

    	if(button_func.start_switch_sys_mode){
    		u32 binding_mode_value = (button_func.system_mode == RF_1M_BLE_MODE) ? 0 : 0x1;
			binding_mode_addr_idx += 4;
			flash_write_page(CFG_DEVICE_MODE_ADDR + binding_mode_addr_idx, 4, &binding_mode_value);
    	}

		irq_disable();
		REG_ADDR8(0x6f) = 0x20;
		while(1);
	}
#if(ADV_TYPE_SWITCH_BY_BUTTON)
	if( button_func.system_mode == RF_1M_BLE_MODE){

		if (blc_ll_getCurrentState() != BLS_LINK_STATE_CONN){

			if(first_adv_switch == 1){
				first_adv_switch = 2;
				adv_direct_ind_flg = 0;
				adv_duration_timeout(0,0,0);
			}
			else if(first_adv_switch == 2){
				if(!DEVICE_LED_BUSY){
					device_led_setup(led_cfg[LED_NON_DIR_ADV]);		//Ƕ㲥,led blink slowly
				}
			}

			if( !first_adv_switch && button_func.start_switch_adv_type ){
				first_adv_switch = 1;
				button_func.start_switch_adv_type = 0;

				button_func.adv_type_switch_flg = 0;					//ǿrelease
				button_func.adv_type_switch_tick = clock_time();
			}
		}
	}
#endif
    if(button_func.btn_released)
	{
    	button_func.adv_type_switch_flg = 0;

    	button_func.sys_mode_switch_flg = 0;	//once the button be changed,  all flags be released
    	button_func.emi_mode_switch_flg = 0;
    	button_func.start_maual_pair = 0;
        dpi_press=0;
    	if( !button_last )//button -> no button
		{			
    		button_pre = button_last;
    		return 0;
    	}

    	if(button_func.system_mode == RF_2M_2P4G_MODE)
		{
    		if(button_last == mouse_btn_ui.emi_ui){
    			button_func.emi_mode_switch_flg = 1;
    			button_func.emi_mode_switch_tick = clock_time();
    		}
    		else if(button_last == mouse_btn_ui.manual_pair_ui){
    			button_func.start_maual_pair = 1;
    			button_func.start_manual_pair_tick = clock_time();
    		}
    		
    	}
    	else{
    		
#if(ADV_TYPE_SWITCH_BY_BUTTON)

        	if( button_last == mouse_btn_ui.ble_pair_mode_ui ){
        		button_func.adv_type_switch_flg = 1;
        		button_func.adv_type_switch_tick = clock_time();
        	}
#endif

    	}
		if(button_last == mouse_btn_ui.mode_switch_ui)
		{
    			button_func.sys_mode_switch_flg = 1;
				button_func.sys_mode_switch_tick= clock_time();
    	}
		if((button_last == DPI_CHANGE_BTN))
		{
			dpi_press=1;
			dpi_tick= clock_time();
		}
		

    }
    else{

    	if( !button_last ){						//There is no button be pressed
        	button_pre = button_last;
        	return 0;
    	}

    	if(button_func.emi_mode_switch_flg && clock_time_exceed(button_func.emi_mode_switch_tick, 1000000) ){
			mouse_status->mouse_mode = STATE_EMI;
			return 0;
    	}

    	if(button_func.system_mode == RF_2M_2P4G_MODE)
		{
    		u8 btn_into_pair_flg = 0;
    		u8 power_on = mouse_status->mouse_mode == STATE_POWERON;
    		if(button_func.start_maual_pair && clock_time_exceed(button_func.start_manual_pair_tick, 100000)){

    			button_func.start_maual_pair = 0;
				button_func.start_manual_pair_tick=clock_time();
    			btn_into_pair_flg = 1;
        		//u8 mouse_pair_anytime = device_never_linked && !mouse_cust_pairing_only_poweron
        		if(power_on || (!mouse_cust_pairing_only_poweron && device_never_linked)){
        			mouse_status->mouse_mode = STATE_PAIRING;
        		}
    		}
    	}
		else
		{
#if(ADV_TYPE_SWITCH_BY_BUTTON)
	    	if(button_func.adv_type_switch_flg)
			{
	    		if(clock_time_exceed(button_func.adv_type_switch_tick, 2000000))
	    		{
					
					blt_state = BLS_LINK_STATE_ADV;
	    			button_func.sys_mode_switch_flg = 0;
					button_func.adv_type_switch_flg=0;
	    			button_func.start_switch_adv_type = 1;
	    		//button_func.start_switch_adv_type = adv_direct_ind_flg;
	    		}
				else if(clock_time_exceed(button_func.adv_type_switch_tick, 1800000))
	    		{
					clear_ble_fifo();
				
	    		}
	    	}
			
#endif
		}
		if(button_func.sys_mode_switch_flg&& clock_time_exceed(button_func.sys_mode_switch_tick, 2000000))
		{
			button_func.start_switch_sys_mode = 1;
			button_func.sys_mode_switch_flg=0;
			if(button_func.system_mode == RF_1M_BLE_MODE)
			{
				device_led_init(GPIO_LED_2P4, 1);
    			device_led_setup(led_cfg[LED_2P4_SWITCH_MODE]);
				
			}
			else
			{
				device_led_init(GPIO_LED_BLE, 1);
    			device_led_setup(led_cfg[LED_BLE_SWITCH_MODE]);
			}
		}
		if(dpi_press)	//&&clock_time_exceed(dpi_tick, 2000000)
		{
			dpi_press=0;
    		++mouse_status->cpi;
//    		mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
//    		mouse_sensor_set_cpi( &mouse_status->cpi );
//
//    		device_led_setup(led_cfg[mouse_status->cpi]);
			if(p_custom_cfg->sensor_type != U8_MAX){
				mouse_status->cpi = (4) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
				if(mouse_status->cpi == 3){
	    		device_led_setup(led_cfg[LED_CPI_3]);
				}
				else{
				device_led_setup(led_cfg[mouse_status->cpi]);
				}
			}
			else{
				mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
				device_led_setup(led_cfg[mouse_status->cpi]);
			}
    	
		}
    }


	button_pre = button_last;

}
#elif((DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_NEWMAN_V3_BOARD)&&(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0))//for only three button

#define DPI_CHANGE_BTN (FLAG_BUTTON_DPI)

u32 mouse_button_process(mouse_status_t * mouse_status)
{
static	u8 dpi_press=0;
static	u32 dpi_tick=0;

    //button_last: current button
    //button_pre: previous button

	if(button_func.start_switch_sys_mode && !DEVICE_LED_BUSY){

    	if(button_func.start_switch_sys_mode){
    		u32 binding_mode_value = (button_func.system_mode == RF_1M_BLE_MODE) ? 0 : 0x1;
			binding_mode_addr_idx += 4;
			flash_write_page(CFG_DEVICE_MODE_ADDR + binding_mode_addr_idx, 4, &binding_mode_value);
    	}

		irq_disable();
		REG_ADDR8(0x6f) = 0x20;
		while(1);
	}
#if(ADV_TYPE_SWITCH_BY_BUTTON)
	if( button_func.system_mode == RF_1M_BLE_MODE){

		if (blc_ll_getCurrentState() != BLS_LINK_STATE_CONN){

			if(first_adv_switch == 1){
				first_adv_switch = 2;
				adv_direct_ind_flg = 0;
				adv_duration_timeout(0,0,0);
			}
			else if(first_adv_switch == 2){
				if(!DEVICE_LED_BUSY){
					device_led_setup(led_cfg[LED_NON_DIR_ADV]);		//Ƕ㲥,led blink slowly
				}
			}

			if( !first_adv_switch && button_func.start_switch_adv_type ){
				first_adv_switch = 1;
				button_func.start_switch_adv_type = 0;

				button_func.adv_type_switch_flg = 0;					//ǿrelease
				button_func.adv_type_switch_tick = clock_time();
			}
		}
	}
#endif
    if(button_func.btn_released)
	{
	
		if((dpi_press)&&(btn_power_value==0))
		{
			dpi_press=0;
			++mouse_status->cpi;
//			mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
//			mouse_sensor_set_cpi( &mouse_status->cpi );
//
//			device_led_setup(led_cfg[mouse_status->cpi]);
			if(p_custom_cfg->sensor_type != U8_MAX){
				mouse_status->cpi = (4) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
				if(mouse_status->cpi == 3){
	    		device_led_setup(led_cfg[LED_CPI_3]);
				}
				else{
				device_led_setup(led_cfg[mouse_status->cpi]);
				}
			}
			else{
				mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
				device_led_setup(led_cfg[mouse_status->cpi]);
			}

		}
	


		button_func.adv_type_switch_flg = 0;

    	button_func.sys_mode_switch_flg = 0;	//once the button be changed,  all flags be released
    	button_func.emi_mode_switch_flg = 0;
    	button_func.start_maual_pair = 0;
        dpi_press=0;
    	if( !button_last )//button -> no button
		{			
    		button_pre = button_last;
			btn_power_value=0;
    		return 0;
    	}

    	if(button_func.system_mode == RF_2M_2P4G_MODE)
		{
    		if(button_last == mouse_btn_ui.emi_ui){
    			button_func.emi_mode_switch_flg = 1;
    			button_func.emi_mode_switch_tick = clock_time();
    		}
    		else if(button_last == mouse_btn_ui.manual_pair_ui){
    			button_func.start_maual_pair = 1;
    			button_func.start_manual_pair_tick = clock_time();
    		}
    		
    	}
    	else{
    		
#if(ADV_TYPE_SWITCH_BY_BUTTON)

        	if( button_last == mouse_btn_ui.ble_pair_mode_ui ){
        		button_func.adv_type_switch_flg = 1;
        		button_func.adv_type_switch_tick = clock_time();
        	}
#endif

    	}
		if((btn_power_value==0)&&(button_last == mouse_btn_ui.mode_switch_ui))
		{
    			button_func.sys_mode_switch_flg = 1;
				button_func.sys_mode_switch_tick= clock_time();
    	}
		if((button_last == DPI_CHANGE_BTN))
		{
			dpi_press=1;
			dpi_tick= clock_time();
		}
		

    }
    else{

    	if( !button_last ){						//There is no button be pressed
        	button_pre = button_last;
        	return 0;
    	}

    	if(button_func.emi_mode_switch_flg && clock_time_exceed(button_func.emi_mode_switch_tick, 1000000) ){
			mouse_status->mouse_mode = STATE_EMI;
			return 0;
    	}

    	if(button_func.system_mode == RF_2M_2P4G_MODE)
		{
    		u8 btn_into_pair_flg = 0;
    		u8 power_on = mouse_status->mouse_mode == STATE_POWERON;
    		if(button_func.start_maual_pair && clock_time_exceed(button_func.start_manual_pair_tick, 100000)){

    			button_func.start_maual_pair = 0;
				button_func.start_manual_pair_tick=clock_time();
    			btn_into_pair_flg = 1;
        		//u8 mouse_pair_anytime = device_never_linked && !mouse_cust_pairing_only_poweron
        		if(power_on || (!mouse_cust_pairing_only_poweron && device_never_linked)){
        			mouse_status->mouse_mode = STATE_PAIRING;
        		}
    		}
    	}
		else
		{
#if(ADV_TYPE_SWITCH_BY_BUTTON)
	    	if(button_func.adv_type_switch_flg)
			{
	    		if(clock_time_exceed(button_func.adv_type_switch_tick, 2000000))
	    		{
					
					blt_state = BLS_LINK_STATE_ADV;
	    			button_func.sys_mode_switch_flg = 0;
					button_func.adv_type_switch_flg=0;
	    			button_func.start_switch_adv_type = 1;
	    		//button_func.start_switch_adv_type = adv_direct_ind_flg;
	    		}
				else if(clock_time_exceed(button_func.adv_type_switch_tick, 1800000))
	    		{
					clear_ble_fifo();
				
	    		}
	    	}
			
#endif
		}
		if(button_func.sys_mode_switch_flg&& clock_time_exceed(button_func.sys_mode_switch_tick, 2000000))
		{
			button_func.start_switch_sys_mode = 1;
			button_func.sys_mode_switch_flg=0;
			if(button_func.system_mode == RF_1M_BLE_MODE)
			{
				device_led_init(GPIO_LED_2P4, 1);
    			device_led_setup(led_cfg[LED_2P4_SWITCH_MODE]);
				
			}
			else
			{
				device_led_init(GPIO_LED_BLE, 1);
    			device_led_setup(led_cfg[LED_BLE_SWITCH_MODE]);
			}
		}


    }


	button_pre = button_last;

}

#elif((DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_YJX_V4_BOARD)&&(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0))//for only three button

#define DPI_CHANGE_BTN (FLAG_BUTTON_RIGHT|FLAG_BUTTON_MIDDLE)

u32 mouse_button_process(mouse_status_t * mouse_status)
{
    //button_last: current button
    //button_pre: previous button
    static u8 dpi_press=0;
	static u32 dpi_tick=0;
	if( 0 && !DEVICE_LED_BUSY){		//button_func.start_switch_sys_mode

    	if(button_func.start_switch_sys_mode){
    		u32 binding_mode_value = (button_func.system_mode == RF_1M_BLE_MODE) ? 0 : 0x1;
			binding_mode_addr_idx += 4;
			flash_write_page(CFG_DEVICE_MODE_ADDR + binding_mode_addr_idx, 4, &binding_mode_value);
    	}

		irq_disable();
		REG_ADDR8(0x6f) = 0x20;
		while(1);
	}
#if(ADV_TYPE_SWITCH_BY_BUTTON)
	if( button_func.system_mode == RF_1M_BLE_MODE){

		if (blc_ll_getCurrentState() != BLS_LINK_STATE_CONN){

			if(first_adv_switch == 1){
				first_adv_switch = 2;
				adv_direct_ind_flg = 0;
				adv_duration_timeout(0,0,0);
			}
			else if(first_adv_switch == 2){
				if(!DEVICE_LED_BUSY){
					device_led_setup(led_cfg[LED_NON_DIR_ADV]);		//Ƕ㲥,led blink slowly
				}
			}

			if( !first_adv_switch && button_func.start_switch_adv_type ){
				first_adv_switch = 1;
				button_func.start_switch_adv_type = 0;

				button_func.adv_type_switch_flg = 0;					//ǿrelease
				button_func.adv_type_switch_tick = clock_time();
			}
		}
	}
#endif
    if(button_func.btn_released){

									
    	if(button_func.system_mode == RF_1M_BLE_MODE && 0){	//button_func.sys_mode_switch_flg
    		button_func.start_switch_sys_mode = 1;
    		device_led_init(GPIO_LED_2P4, 1);
    		device_led_setup(led_cfg[LED_2P4_SWITCH_MODE]);
    	}

#if(ADV_TYPE_SWITCH_BY_BUTTON)
    	button_func.adv_type_switch_flg = 0;
#endif
    	button_func.sys_mode_switch_flg = 0;	//once the button be changed,  all flags be released
    	button_func.emi_mode_switch_flg = 0;
    	button_func.start_maual_pair = 0;
		dpi_press=0;

    	if( !button_last ){			//button -> no button
    		button_pre = button_last;
    		return 0;
    	}

    	if(button_func.system_mode == RF_2M_2P4G_MODE){
    		if(button_last == mouse_btn_ui.emi_ui){
    			button_func.emi_mode_switch_flg = 1;
    			button_func.emi_mode_switch_tick = clock_time();
    		}
    		else if(button_last == mouse_btn_ui.manual_pair_ui){
    			button_func.start_maual_pair = 1;
    			button_func.start_manual_pair_tick = clock_time();
    		}
    		else if(button_last == mouse_btn_ui.mode_switch_ui){
    			button_func.start_switch_sys_mode = 1;
    			device_led_init(GPIO_LED_BLE, 1);
    			device_led_setup(led_cfg[LED_BLE_SWITCH_MODE]);
    		}
    	}
    	else{
    		if(button_last == mouse_btn_ui.mode_switch_ui){
    			button_func.sys_mode_switch_flg = 1;
    		}
#if(ADV_TYPE_SWITCH_BY_BUTTON)

        	if( button_last == mouse_btn_ui.ble_pair_mode_ui ){
        		button_func.adv_type_switch_flg = 1;
        		button_func.adv_type_switch_tick = clock_time();
        	}
#endif

    	}

    	if((button_last == FLAG_BUTTON_DPI)) {            //new event
    		++mouse_status->cpi;
//    		mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
//    		mouse_sensor_set_cpi( &mouse_status->cpi );
//
//    		device_led_setup(led_cfg[mouse_status->cpi]);

			if(p_custom_cfg->sensor_type != U8_MAX){
				mouse_status->cpi = (4) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
				if(mouse_status->cpi == 3){
	    		device_led_setup(led_cfg[LED_CPI_3]);
				}
				else{
				device_led_setup(led_cfg[mouse_status->cpi]);
				}
			}
			else{
				mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
				device_led_setup(led_cfg[mouse_status->cpi]);
			}
    	}
        if((button_last == DPI_CHANGE_BTN))
		{
			dpi_press=1;
			dpi_tick= clock_time();
		}


    }
    else{

    	if( !button_last ){						//There is no button be pressed
        	button_pre = button_last;
        	return 0;
    	}
#if(ADV_TYPE_SWITCH_BY_BUTTON)
    	if(button_func.adv_type_switch_flg && clock_time_exceed(button_func.adv_type_switch_tick, 2000000)){
    		//mode button be pressed time exceed than 3s,adv switch
    		blt_state = BLS_LINK_STATE_ADV;
    		button_func.sys_mode_switch_flg = 0;

    		button_func.start_switch_adv_type = 1;
    		//button_func.start_switch_adv_type = adv_direct_ind_flg;
    	}
#endif

    	if(button_func.emi_mode_switch_flg && clock_time_exceed(button_func.emi_mode_switch_tick, 1000000) ){
			mouse_status->mouse_mode = STATE_EMI;
			return 0;
    	}

    	if(button_func.system_mode == RF_2M_2P4G_MODE){
    		u8 btn_into_pair_flg = 0;
    		u8 power_on = mouse_status->mouse_mode == STATE_POWERON;
    		if(button_func.start_maual_pair && clock_time_exceed(button_func.start_manual_pair_tick, 100000)){

    			button_func.start_maual_pair = 0;
    			btn_into_pair_flg = 1;
        		//u8 mouse_pair_anytime = device_never_linked && !mouse_cust_pairing_only_poweron
        		if(power_on || (!mouse_cust_pairing_only_poweron && device_never_linked)){
        			mouse_status->mouse_mode = STATE_PAIRING;
        		}
    		}
    	}
		if(dpi_press&&clock_time_exceed(dpi_tick, 2000000))
		{
			dpi_press=0;
    		++mouse_status->cpi;
//    		mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
//    		mouse_sensor_set_cpi( &mouse_status->cpi );
//
//    		device_led_setup(led_cfg[mouse_status->cpi]);
			if(p_custom_cfg->sensor_type != U8_MAX){
				mouse_status->cpi = (4) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
				if(mouse_status->cpi == 3){
	    		device_led_setup(led_cfg[LED_CPI_3]);
				}
				else{
				device_led_setup(led_cfg[mouse_status->cpi]);
				}
			}
			else{
				mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
				device_led_setup(led_cfg[mouse_status->cpi]);
			}
    	
		}
    }

	button_pre = button_last;

}
#elif((DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_BingShou_V5_BOARD)&&(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0))

#define DPI_IS_COMBLE_BTN   0
//#define DPI_CHANGE_BTN (FLAG_BUTTON_DPI)

u32 mouse_button_process(mouse_status_t * mouse_status)
{
    //button_last: current button
    //button_pre: previous button
#if (DPI_IS_COMBLE_BTN)
    static u8 dpi_press=0;
	static u32 dpi_tick=0;
#endif
	if( 0){

    	if(button_func.start_switch_sys_mode){
    		u32 binding_mode_value = (button_func.system_mode == RF_1M_BLE_MODE) ? 0 : 0x1;
			binding_mode_addr_idx += 4;
			flash_write_page(CFG_DEVICE_MODE_ADDR + binding_mode_addr_idx, 4, &binding_mode_value);
    	}

		irq_disable();
		REG_ADDR8(0x6f) = 0x20;
		while(1);
	}
#if(ADV_TYPE_SWITCH_BY_BUTTON)
	if( button_func.system_mode == RF_1M_BLE_MODE){

		if (blc_ll_getCurrentState() != BLS_LINK_STATE_CONN){

			if(first_adv_switch == 1){
				first_adv_switch = 2;
				adv_direct_ind_flg = 0;
				adv_duration_timeout(0,0,0);
			}
			else if(first_adv_switch == 2){
				if(!DEVICE_LED_BUSY){
					device_led_setup(led_cfg[LED_NON_DIR_ADV]);		//Ƕ㲥,led blink slowly
				}
			}

			if( !first_adv_switch && button_func.start_switch_adv_type ){
				first_adv_switch = 1;
				button_func.start_switch_adv_type = 0;

				button_func.adv_type_switch_flg = 0;					//ǿrelease
				button_func.adv_type_switch_tick = clock_time();
			}
		}
	}
#endif
    if(button_func.btn_released){


    	if(button_func.system_mode == RF_1M_BLE_MODE && button_func.sys_mode_switch_flg){
    		button_func.start_switch_sys_mode = 1;
    		device_led_init(GPIO_LED_2P4, 1);
    		device_led_setup(led_cfg[LED_2P4_SWITCH_MODE]);
    	}

#if(ADV_TYPE_SWITCH_BY_BUTTON)
    	button_func.adv_type_switch_flg = 0;
#endif
    	button_func.sys_mode_switch_flg = 0;	//once the button be changed,  all flags be released
    	button_func.emi_mode_switch_flg = 0;
    	button_func.start_maual_pair = 0;
#if (DPI_IS_COMBLE_BTN)

		dpi_press=0;
#endif
    	if( !button_last ){			//button -> no button
    		button_pre = button_last;
    		return 0;
    	}

    	if(button_func.system_mode == RF_2M_2P4G_MODE){
    		if(button_last == mouse_btn_ui.emi_ui){
    			button_func.emi_mode_switch_flg = 1;
    			button_func.emi_mode_switch_tick = clock_time();
    		}
    		else if(button_last == mouse_btn_ui.manual_pair_ui){
    			button_func.start_maual_pair = 1;
    			button_func.start_manual_pair_tick = clock_time();
    		}
    		else if(button_last == mouse_btn_ui.mode_switch_ui){
    			button_func.start_switch_sys_mode = 1;
    			device_led_init(GPIO_LED_BLE, 1);
    			device_led_setup(led_cfg[LED_BLE_SWITCH_MODE]);
    		}
    	}
    	else{
    		if(button_last == mouse_btn_ui.mode_switch_ui){
    			button_func.sys_mode_switch_flg = 1;
    		}
#if(ADV_TYPE_SWITCH_BY_BUTTON)

        	if( button_last == mouse_btn_ui.ble_pair_mode_ui ){
        		button_func.adv_type_switch_flg = 1;
        		button_func.adv_type_switch_tick = clock_time();
        	}
#endif

    	}
#if (DPI_IS_COMBLE_BTN)
		if((button_last == DPI_CHANGE_BTN))
	   {
		   dpi_press=1;
		   dpi_tick= clock_time();
	   }

#else
		if((button_last == FLAG_BUTTON_DPI)) {            //new event
    		++mouse_status->cpi;
    	//	mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
    	//	mouse_sensor_set_cpi( &mouse_status->cpi );
    	//	device_led_setup(led_cfg[mouse_status->cpi]);
//=====================================//sensor 3212 //xiao=============================// 	
			if(p_custom_cfg->sensor_type != U8_MAX){		
				mouse_status->cpi = (4) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
				if(mouse_status->cpi == 3){
	    		device_led_setup(led_cfg[LED_CPI_3]);
				}
				else{
				device_led_setup(led_cfg[mouse_status->cpi]);
				}
			}
			else{
				mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
				device_led_setup(led_cfg[mouse_status->cpi]);
			}
    	}
#endif
    	
		
       


    }
    else{

    	if( !button_last ){						//There is no button be pressed
        	button_pre = button_last;
        	return 0;
    	}
#if(ADV_TYPE_SWITCH_BY_BUTTON)
    	if(button_func.adv_type_switch_flg && clock_time_exceed(button_func.adv_type_switch_tick, 2000000)){
    		//mode button be pressed time exceed than 3s,adv switch
    		blt_state = BLS_LINK_STATE_ADV;
    		button_func.sys_mode_switch_flg = 0;

    		button_func.start_switch_adv_type = 1;
    		//button_func.start_switch_adv_type = adv_direct_ind_flg;
    	}
#endif

    	if(button_func.emi_mode_switch_flg && clock_time_exceed(button_func.emi_mode_switch_tick, 1000000) ){
			mouse_status->mouse_mode = STATE_EMI;
			return 0;
    	}

    	if(button_func.system_mode == RF_2M_2P4G_MODE){
    		u8 btn_into_pair_flg = 0;
    		u8 power_on = mouse_status->mouse_mode == STATE_POWERON;
    		if(button_func.start_maual_pair && clock_time_exceed(button_func.start_manual_pair_tick, 100000)){

    			button_func.start_maual_pair = 0;
    			btn_into_pair_flg = 1;
        		//u8 mouse_pair_anytime = device_never_linked && !mouse_cust_pairing_only_poweron
        		if(power_on || (!mouse_cust_pairing_only_poweron && device_never_linked)){
        			mouse_status->mouse_mode = STATE_PAIRING;
        		}
    		}
    	}
#if (DPI_IS_COMBLE_BTN)

		if(dpi_press&&clock_time_exceed(dpi_tick, 2000000))
		{
			dpi_press=0;
    		++mouse_status->cpi;
//    		mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
//    		mouse_sensor_set_cpi( &mouse_status->cpi );
//
//    		device_led_setup(led_cfg[mouse_status->cpi]);
			if(p_custom_cfg->sensor_type != U8_MAX){
				mouse_status->cpi = (4) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
				if(mouse_status->cpi == 3){
	    		device_led_setup(led_cfg[LED_CPI_3]);
				}
				else{
				device_led_setup(led_cfg[mouse_status->cpi]);
				}
			}
			else{
				mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
				device_led_setup(led_cfg[mouse_status->cpi]);
			}
    	
		}
#endif
    }

	button_pre = button_last;

}
#elif((DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_BingShou_V6_BOARD)&&(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0))

#define DPI_IS_COMBLE_BTN   0
//#define DPI_CHANGE_BTN (FLAG_BUTTON_DPI)

u32 mouse_button_process(mouse_status_t * mouse_status)
{
    //button_last: current button
    //button_pre: previous button
#if (DPI_IS_COMBLE_BTN)
    static u8 dpi_press=0;
	static u32 dpi_tick=0;
#endif
	if( 0){

    	if(button_func.start_switch_sys_mode){
    		u32 binding_mode_value = (button_func.system_mode == RF_1M_BLE_MODE) ? 0 : 0x1;
			binding_mode_addr_idx += 4;
			flash_write_page(CFG_DEVICE_MODE_ADDR + binding_mode_addr_idx, 4, &binding_mode_value);
    	}

		irq_disable();
		REG_ADDR8(0x6f) = 0x20;
		while(1);
	}
#if(ADV_TYPE_SWITCH_BY_BUTTON)
	if( button_func.system_mode == RF_1M_BLE_MODE){

		if (blc_ll_getCurrentState() != BLS_LINK_STATE_CONN){

			if(first_adv_switch == 1){
				first_adv_switch = 2;
				adv_direct_ind_flg = 0;
				adv_duration_timeout(0,0,0);
			}
			else if(first_adv_switch == 2){
				if(!DEVICE_LED_BUSY){
					device_led_setup(led_cfg[LED_NON_DIR_ADV]);		//Ƕ㲥,led blink slowly
				}
			}

			if( !first_adv_switch && button_func.start_switch_adv_type ){
				first_adv_switch = 1;
				button_func.start_switch_adv_type = 0;

				button_func.adv_type_switch_flg = 0;					//ǿrelease
				button_func.adv_type_switch_tick = clock_time();
			}
		}
	}
#endif
    if(button_func.btn_released){


    	if(button_func.system_mode == RF_1M_BLE_MODE && button_func.sys_mode_switch_flg){
    		button_func.start_switch_sys_mode = 1;
    		device_led_init(GPIO_LED_2P4, 1);
    		device_led_setup(led_cfg[LED_2P4_SWITCH_MODE]);
    	}

#if(ADV_TYPE_SWITCH_BY_BUTTON)
    	button_func.adv_type_switch_flg = 0;
#endif
    	button_func.sys_mode_switch_flg = 0;	//once the button be changed,  all flags be released
    	button_func.emi_mode_switch_flg = 0;
    	button_func.start_maual_pair = 0;
#if (DPI_IS_COMBLE_BTN)

		dpi_press=0;
#endif
    	if( !button_last ){			//button -> no button
    		button_pre = button_last;
    		return 0;
    	}

    	if(button_func.system_mode == RF_2M_2P4G_MODE){
    		if(button_last == mouse_btn_ui.emi_ui){
    			button_func.emi_mode_switch_flg = 1;
    			button_func.emi_mode_switch_tick = clock_time();
    		}
    		else if(button_last == mouse_btn_ui.manual_pair_ui){
    			button_func.start_maual_pair = 1;
    			button_func.start_manual_pair_tick = clock_time();
    		}
    		else if(button_last == mouse_btn_ui.mode_switch_ui){
    			button_func.start_switch_sys_mode = 1;
    			device_led_init(GPIO_LED_BLE, 1);
    			device_led_setup(led_cfg[LED_BLE_SWITCH_MODE]);
    		}
    	}
    	else{
    		if(button_last == mouse_btn_ui.mode_switch_ui){
    			button_func.sys_mode_switch_flg = 1;
    		}
#if(ADV_TYPE_SWITCH_BY_BUTTON)

        	if( button_last == mouse_btn_ui.ble_pair_mode_ui ){
        		button_func.adv_type_switch_flg = 1;
        		button_func.adv_type_switch_tick = clock_time();
        	}
#endif

    	}
#if (DPI_IS_COMBLE_BTN)
		if((button_last == DPI_CHANGE_BTN))
	   {
		   dpi_press=1;
		   dpi_tick= clock_time();
	   }

#else
		if((button_last == FLAG_BUTTON_DPI)) {            //new event
    		++mouse_status->cpi;
//    		mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
//    		mouse_sensor_set_cpi( &mouse_status->cpi );
//
//    		device_led_setup(led_cfg[mouse_status->cpi]);

			if(p_custom_cfg->sensor_type != U8_MAX){
				mouse_status->cpi = (4) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
				if(mouse_status->cpi == 3){
	    		device_led_setup(led_cfg[LED_CPI_3]);
				}
				else{
				device_led_setup(led_cfg[mouse_status->cpi]);
				}
			}
			else{
				mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
				device_led_setup(led_cfg[mouse_status->cpi]);
			}
    	}
#endif
    	
		
       


    }
    else{

    	if( !button_last ){						//There is no button be pressed
        	button_pre = button_last;
        	return 0;
    	}
#if(ADV_TYPE_SWITCH_BY_BUTTON)
    	if(button_func.adv_type_switch_flg && clock_time_exceed(button_func.adv_type_switch_tick, 2000000)){
    		//mode button be pressed time exceed than 3s,adv switch
    		blt_state = BLS_LINK_STATE_ADV;
    		button_func.sys_mode_switch_flg = 0;

    		button_func.start_switch_adv_type = 1;
    		//button_func.start_switch_adv_type = adv_direct_ind_flg;
    	}
#endif

    	if(button_func.emi_mode_switch_flg && clock_time_exceed(button_func.emi_mode_switch_tick, 1000000) ){
			mouse_status->mouse_mode = STATE_EMI;
			return 0;
    	}

    	if(button_func.system_mode == RF_2M_2P4G_MODE){
    		u8 btn_into_pair_flg = 0;
    		u8 power_on = mouse_status->mouse_mode == STATE_POWERON;
    		if(button_func.start_maual_pair && clock_time_exceed(button_func.start_manual_pair_tick, 100000)){

    			button_func.start_maual_pair = 0;
    			btn_into_pair_flg = 1;
        		//u8 mouse_pair_anytime = device_never_linked && !mouse_cust_pairing_only_poweron
        		if(power_on || (!mouse_cust_pairing_only_poweron && device_never_linked)){
        			mouse_status->mouse_mode = STATE_PAIRING;
        		}
    		}
    	}
#if (DPI_IS_COMBLE_BTN)

		if(dpi_press&&clock_time_exceed(dpi_tick, 2000000))
		{
			dpi_press=0;
    		++mouse_status->cpi;
//    		mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
//    		mouse_sensor_set_cpi( &mouse_status->cpi );
//
//    		device_led_setup(led_cfg[mouse_status->cpi]);

			if(p_custom_cfg->sensor_type != U8_MAX){
				mouse_status->cpi = (4) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
				if(mouse_status->cpi == 3){
	    		device_led_setup(led_cfg[LED_CPI_3]);
				}
				else{
				device_led_setup(led_cfg[mouse_status->cpi]);
				}
			}
			else{
				mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
				device_led_setup(led_cfg[mouse_status->cpi]);
			}
    	
		}
#endif
    }

	button_pre = button_last;

}
#elif((DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_BingShou_V7_BOARD)&&(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0))

#define DPI_IS_COMBLE_BTN   0
//#define DPI_CHANGE_BTN (FLAG_BUTTON_DPI)

u32 mouse_button_process(mouse_status_t * mouse_status)
{
    //button_last: current button
    //button_pre: previous button
#if (DPI_IS_COMBLE_BTN)
    static u8 dpi_press=0;
	static u32 dpi_tick=0;
#endif
	if( 0){

    	if(button_func.start_switch_sys_mode){
    		u32 binding_mode_value = (button_func.system_mode == RF_1M_BLE_MODE) ? 0 : 0x1;
			binding_mode_addr_idx += 4;
			flash_write_page(CFG_DEVICE_MODE_ADDR + binding_mode_addr_idx, 4, &binding_mode_value);
    	}

		irq_disable();
		REG_ADDR8(0x6f) = 0x20;
		while(1);
	}
#if(ADV_TYPE_SWITCH_BY_BUTTON)
	if( button_func.system_mode == RF_1M_BLE_MODE){

		if (blc_ll_getCurrentState() != BLS_LINK_STATE_CONN){

			if(first_adv_switch == 1){
				first_adv_switch = 2;
				adv_direct_ind_flg = 0;
				adv_duration_timeout(0,0,0);
			}
			else if(first_adv_switch == 2){
				if(!DEVICE_LED_BUSY){
					device_led_setup(led_cfg[LED_NON_DIR_ADV]);		//Ƕ㲥,led blink slowly
				}
			}

			if( !first_adv_switch && button_func.start_switch_adv_type ){
				first_adv_switch = 1;
				button_func.start_switch_adv_type = 0;

				button_func.adv_type_switch_flg = 0;					//ǿrelease
				button_func.adv_type_switch_tick = clock_time();
			}
		}
	}
#endif
    if(button_func.btn_released){


    	if(button_func.system_mode == RF_1M_BLE_MODE && button_func.sys_mode_switch_flg){
    		button_func.start_switch_sys_mode = 1;
    		device_led_init(GPIO_LED_2P4, 1);
    		device_led_setup(led_cfg[LED_2P4_SWITCH_MODE]);
    	}

#if(ADV_TYPE_SWITCH_BY_BUTTON)
    	button_func.adv_type_switch_flg = 0;
#endif
    	button_func.sys_mode_switch_flg = 0;	//once the button be changed,  all flags be released
    	button_func.emi_mode_switch_flg = 0;
    	button_func.start_maual_pair = 0;
#if (DPI_IS_COMBLE_BTN)

		dpi_press=0;
#endif
    	if( !button_last ){			//button -> no button
    		button_pre = button_last;
    		return 0;
    	}

    	if(button_func.system_mode == RF_2M_2P4G_MODE){
    		if(button_last == mouse_btn_ui.emi_ui){
    			button_func.emi_mode_switch_flg = 1;
    			button_func.emi_mode_switch_tick = clock_time();
    		}
    		else if(button_last == mouse_btn_ui.manual_pair_ui){
    			button_func.start_maual_pair = 1;
    			button_func.start_manual_pair_tick = clock_time();
    		}
    		else if(button_last == mouse_btn_ui.mode_switch_ui){
    			button_func.start_switch_sys_mode = 1;
    			device_led_init(GPIO_LED_BLE, 1);
    			device_led_setup(led_cfg[LED_BLE_SWITCH_MODE]);
    		}
    	}
    	else{
    		if(button_last == mouse_btn_ui.mode_switch_ui){
    			button_func.sys_mode_switch_flg = 1;
    		}
#if(ADV_TYPE_SWITCH_BY_BUTTON)

        	if( button_last == mouse_btn_ui.ble_pair_mode_ui ){
        		button_func.adv_type_switch_flg = 1;
        		button_func.adv_type_switch_tick = clock_time();
        	}
#endif

    	}
#if (DPI_IS_COMBLE_BTN)
		if((button_last == DPI_CHANGE_BTN))
	   {
		   dpi_press=1;
		   dpi_tick= clock_time();
	   }

#else
		if((button_last == FLAG_BUTTON_DPI)) {            //new event
    		++mouse_status->cpi;
    	//	mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
    	//	mouse_sensor_set_cpi( &mouse_status->cpi );
    	//	device_led_setup(led_cfg[mouse_status->cpi]);
//=====================================//sensor 3212 //xiao=============================// 	
			if(p_custom_cfg->sensor_type != U8_MAX){		
				mouse_status->cpi = (4) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
				if(mouse_status->cpi == 3){
	    		device_led_setup(led_cfg[LED_CPI_3]);
				}
				else{
				device_led_setup(led_cfg[mouse_status->cpi]);
				}
			}
			else{
				mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
				device_led_setup(led_cfg[mouse_status->cpi]);
			}
    	}

    	if((button_last == FLAG_BUTTON_CPIJIANKEY)) {            //new event
    		--mouse_status->cpi;
    	//	mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
    	//	mouse_sensor_set_cpi( &mouse_status->cpi );
    	//	device_led_setup(led_cfg[mouse_status->cpi]);
//=====================================//sensor 3212 //xiao=============================// 	
			if(p_custom_cfg->sensor_type != U8_MAX){		
				mouse_status->cpi = (4) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
				if(mouse_status->cpi == 3){
	    		device_led_setup(led_cfg[LED_CPI_3]);
				}
				else{
				device_led_setup(led_cfg[mouse_status->cpi]);
				}
			}
			else{
				mouse_status->cpi = (mouse_status->cpi < 0) ? 2 : mouse_status->cpi;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
				device_led_setup(led_cfg[mouse_status->cpi]);
			}
    	}
#endif
    	
		
       


    }
    else{

    	if( !button_last ){						//There is no button be pressed
        	button_pre = button_last;
        	return 0;
    	}
#if(ADV_TYPE_SWITCH_BY_BUTTON)
    	if(button_func.adv_type_switch_flg && clock_time_exceed(button_func.adv_type_switch_tick, 2000000)){
    		//mode button be pressed time exceed than 3s,adv switch
    		blt_state = BLS_LINK_STATE_ADV;
    		button_func.sys_mode_switch_flg = 0;

    		button_func.start_switch_adv_type = 1;
    		//button_func.start_switch_adv_type = adv_direct_ind_flg;
    	}
#endif

    	if(button_func.emi_mode_switch_flg && clock_time_exceed(button_func.emi_mode_switch_tick, 1000000) ){
			mouse_status->mouse_mode = STATE_EMI;
			return 0;
    	}

    	if(button_func.system_mode == RF_2M_2P4G_MODE){
    		u8 btn_into_pair_flg = 0;
    		u8 power_on = mouse_status->mouse_mode == STATE_POWERON;
    		if(button_func.start_maual_pair && clock_time_exceed(button_func.start_manual_pair_tick, 100000)){

    			button_func.start_maual_pair = 0;
    			btn_into_pair_flg = 1;
        		//u8 mouse_pair_anytime = device_never_linked && !mouse_cust_pairing_only_poweron
        		if(power_on || (!mouse_cust_pairing_only_poweron && device_never_linked)){
        			mouse_status->mouse_mode = STATE_PAIRING;
        		}
    		}
    	}
#if (DPI_IS_COMBLE_BTN)

		if(dpi_press&&clock_time_exceed(dpi_tick, 2000000))
		{
			dpi_press=0;
    		++mouse_status->cpi;
//    		mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
//    		mouse_sensor_set_cpi( &mouse_status->cpi );
//
//    		device_led_setup(led_cfg[mouse_status->cpi]);
			if(p_custom_cfg->sensor_type != U8_MAX){
				mouse_status->cpi = (4) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
				if(mouse_status->cpi == 3){
	    		device_led_setup(led_cfg[LED_CPI_3]);
				}
				else{
				device_led_setup(led_cfg[mouse_status->cpi]);
				}
			}
			else{
				mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
				device_led_setup(led_cfg[mouse_status->cpi]);
			}
    	
		}
#endif
    }

	button_pre = button_last;

}
#elif(((DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_wulian_V8_BOARD)&&(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0))||(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V1P0 ))				//for newman dual mode mouse

u32 mouse_button_process(mouse_status_t * mouse_status)
{

#if((DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V1P0) && !DAUL_MOUSE_YJX_BOARD)
    //button_last: current button
    //button_pre: previous button


    //switch mode, or switch adv type
#if(!MOUSE_ONLY_BLE_MODE)
	if( button_func.start_switch_sys_mode && !DEVICE_LED_BUSY){

    	if(button_func.start_switch_sys_mode){
    		u32 binding_mode_value = (button_func.system_mode == RF_1M_BLE_MODE) ? 0 : 0x1;
			binding_mode_addr_idx += 4;
			flash_write_page(CFG_DEVICE_MODE_ADDR + binding_mode_addr_idx, 4, &binding_mode_value);
    	}

		irq_disable();
		REG_ADDR8(0x6f) = 0x20;
		while(1);
	}
#endif

#if(ADV_TYPE_SWITCH_BY_BUTTON)
	if( button_func.system_mode == RF_1M_BLE_MODE){

		if (blc_ll_getCurrentState() != BLS_LINK_STATE_CONN){

			if(first_adv_switch == 1){
				first_adv_switch = 2;
				adv_direct_ind_flg = 0;
				adv_duration_timeout(0,0,0);
			}
			else if(first_adv_switch == 2){
				if(!DEVICE_LED_BUSY){
					device_led_setup(led_cfg[LED_NON_DIR_ADV]);		//Ƕ㲥,led blink slowly
				}
			}

			if( !first_adv_switch && button_func.start_switch_adv_type ){
				first_adv_switch = 1;
				button_func.start_switch_adv_type = 0;

				button_func.adv_type_switch_flg = 0;					//ǿrelease
				button_func.adv_type_switch_tick = clock_time();
			}
		}
	}


#endif
    if(button_func.btn_released){
#if(ADV_TYPE_SWITCH_BY_BUTTON)
    	button_func.adv_type_switch_flg = 0;
#endif
    	button_func.sys_mode_switch_flg = 0;	//once the button be changed,  all flags be released
    	button_func.emi_mode_switch_flg = 0;
    	button_func.start_maual_pair = 0;


    	if( !button_last ){			//button -> no button
    		button_pre = button_last;
    		return 0;
    	}
#if(ADV_TYPE_SWITCH_BY_BUTTON)
    	if(button_func.system_mode == RF_1M_BLE_MODE && (blc_ll_getCurrentState() != BLS_LINK_STATE_CONN )&& button_last == mouse_btn_ui.ble_pair_mode_ui){
    		button_func.adv_type_switch_flg = 1;
    		button_func.adv_type_switch_tick = clock_time();
    	}
#endif
    	if(button_func.system_mode == RF_2M_2P4G_MODE){
    		//if(button_last == (FLAG_BUTTON_LEFT | FLAG_BUTTON_RIGHT |  FLAG_BUTTON_MIDDLE)){
    		if(button_last == mouse_btn_ui.emi_ui){
    			button_func.emi_mode_switch_flg = 1;
    			button_func.emi_mode_switch_tick = clock_time();
    		}
    		else if(button_last == mouse_btn_ui.manual_pair_ui){
    			button_func.start_maual_pair = 1;
    			button_func.start_manual_pair_tick = clock_time();
    		}
    	}

    	if(button_last == mouse_btn_ui.mode_switch_ui){
    		button_func.sys_mode_switch_flg = 1;
    		button_func.sys_mode_switch_tick = clock_time();
    	}

    	if((button_last == FLAG_BUTTON_DPI)) {            //new event
    		++mouse_status->cpi;
//    		mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
//    		mouse_sensor_set_cpi( &mouse_status->cpi );
//
//    		device_led_setup(led_cfg[mouse_status->cpi]);

    		if(p_custom_cfg->sensor_type != U8_MAX){
    			mouse_status->cpi = (4) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
    			if(mouse_status->cpi == 3){
        		device_led_setup(led_cfg[LED_CPI_3]);
    			}
    			else{
    			device_led_setup(led_cfg[mouse_status->cpi]);
    			}
    		}
    		else{
    			mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
    			device_led_setup(led_cfg[mouse_status->cpi]);
    		}
    	}



    }
    else{

    	if( !button_last ){						//There is no button be pressed
        	button_pre = button_last;
        	return 0;
    	}
#if(ADV_TYPE_SWITCH_BY_BUTTON)
    	if((button_func.system_mode == RF_1M_BLE_MODE) && button_func.adv_type_switch_flg && adv_direct_ind_flg \
    			&& clock_time_exceed(button_func.adv_type_switch_tick, 3000000)){
    		button_func.start_switch_adv_type = 1;  //adv_type_switch = 1;
    	}
#endif
    	if(button_func.sys_mode_switch_flg &&  !button_func.start_switch_sys_mode && \
    			clock_time_exceed(button_func.sys_mode_switch_tick, 3000000)){
    		button_func.start_switch_sys_mode = 1;
    		//switch_mode_start_flg = 1;
    		if(button_func.system_mode == RF_2M_2P4G_MODE)
    			device_led_setup(led_cfg[LED_BLE_SWITCH_MODE]);
    		else
    			device_led_setup(led_cfg[LED_2P4_SWITCH_MODE]);
    	}

    	if(button_func.emi_mode_switch_flg && clock_time_exceed(button_func.emi_mode_switch_tick, 1000000) ){
			mouse_status->mouse_mode = STATE_EMI;
			return 0;
    	}

    	if(button_func.system_mode == RF_2M_2P4G_MODE){
    		u8 btn_into_pair_flg = 0;
    		u8 power_on = mouse_status->mouse_mode == STATE_POWERON;
    		if(button_func.start_maual_pair && clock_time_exceed(button_func.start_manual_pair_tick, 100000)){

    			button_func.start_maual_pair = 0;
    			btn_into_pair_flg = 1;
        		if(power_on || (!mouse_cust_pairing_only_poweron && device_never_linked )){
        			mouse_status->mouse_mode = STATE_PAIRING;
        		}

    		}
    	}

    }
#else
    //button_last: current button
    //button_pre: previous button

	if( button_func.start_switch_sys_mode && !DEVICE_LED_BUSY){

    	if(button_func.start_switch_sys_mode){
    		u32 binding_mode_value = (button_func.system_mode == RF_1M_BLE_MODE) ? 0 : 0x1;
			binding_mode_addr_idx += 4;
			flash_write_page(CFG_DEVICE_MODE_ADDR + binding_mode_addr_idx, 4, &binding_mode_value);
    	}

		irq_disable();
		REG_ADDR8(0x6f) = 0x20;
		while(1);
	}
#if(ADV_TYPE_SWITCH_BY_BUTTON)
	if( button_func.system_mode == RF_1M_BLE_MODE){

		if (blc_ll_getCurrentState() != BLS_LINK_STATE_CONN){

			if(first_adv_switch == 1){
				first_adv_switch = 2;
				adv_direct_ind_flg = 0;
				adv_duration_timeout(0,0,0);
			}
			else if(first_adv_switch == 2){
				if(!DEVICE_LED_BUSY){
					device_led_setup(led_cfg[LED_NON_DIR_ADV]);		//Ƕ㲥,led blink slowly
				}
			}

			if( !first_adv_switch && button_func.start_switch_adv_type ){
				first_adv_switch = 1;
				button_func.start_switch_adv_type = 0;

				button_func.adv_type_switch_flg = 0;					//ǿrelease
				button_func.adv_type_switch_tick = clock_time();
			}
		}
	}
#endif
    if(button_func.btn_released){


    	if(button_func.system_mode == RF_1M_BLE_MODE && button_func.sys_mode_switch_flg){
    		button_func.start_switch_sys_mode = 1;
    		device_led_init(GPIO_LED_2P4, 1);
    		device_led_setup(led_cfg[LED_2P4_SWITCH_MODE]);
    	}

#if(ADV_TYPE_SWITCH_BY_BUTTON)
    	button_func.adv_type_switch_flg = 0;
#endif
    	button_func.sys_mode_switch_flg = 0;	//once the button be changed,  all flags be released
    	button_func.emi_mode_switch_flg = 0;
    	button_func.start_maual_pair = 0;


    	if( !button_last ){			//button -> no button
    		button_pre = button_last;
    		return 0;
    	}

    	if(button_func.system_mode == RF_2M_2P4G_MODE){
    		if(button_last == mouse_btn_ui.emi_ui){
    			button_func.emi_mode_switch_flg = 1;
    			button_func.emi_mode_switch_tick = clock_time();
    		}
    		else if(button_last == mouse_btn_ui.manual_pair_ui){
    			button_func.start_maual_pair = 1;
    			button_func.start_manual_pair_tick = clock_time();
    		}
    		else if(button_last == mouse_btn_ui.mode_switch_ui){
    			button_func.start_switch_sys_mode = 1;
    			device_led_init(GPIO_LED_BLE, 1);
    			device_led_setup(led_cfg[LED_BLE_SWITCH_MODE]);
    		}
    	}
    	else{
    		if(button_last == mouse_btn_ui.mode_switch_ui){
    			button_func.sys_mode_switch_flg = 1;
    		}
#if(ADV_TYPE_SWITCH_BY_BUTTON)

        	if( button_last == mouse_btn_ui.ble_pair_mode_ui ){
        		button_func.adv_type_switch_flg = 1;
        		button_func.adv_type_switch_tick = clock_time();
        	}
#endif

    	}

    	if((button_last == FLAG_BUTTON_DPI)) {            //new event
    		++mouse_status->cpi;
//    		mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
//    		mouse_sensor_set_cpi( &mouse_status->cpi );
//
//    		device_led_setup(led_cfg[mouse_status->cpi]);

			if(p_custom_cfg->sensor_type != U8_MAX){
				mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
				device_led_setup(led_cfg[mouse_status->cpi]);
			}
			else{
				mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
				device_led_setup(led_cfg[mouse_status->cpi]);
			}
    	}



    }
    else{

    	if( !button_last ){						//There is no button be pressed
        	button_pre = button_last;
        	return 0;
    	}
#if(ADV_TYPE_SWITCH_BY_BUTTON)
    	if(button_func.adv_type_switch_flg && clock_time_exceed(button_func.adv_type_switch_tick, 2000000)){
    		//mode button be pressed time exceed than 3s,adv switch
    		blt_state = BLS_LINK_STATE_ADV;
    		button_func.sys_mode_switch_flg = 0;

    		button_func.start_switch_adv_type = 1;
    		//button_func.start_switch_adv_type = adv_direct_ind_flg;
    	}
#endif

    	if(button_func.emi_mode_switch_flg && clock_time_exceed(button_func.emi_mode_switch_tick, 1000000) ){
			mouse_status->mouse_mode = STATE_EMI;
			return 0;
    	}

    	if(button_func.system_mode == RF_2M_2P4G_MODE){
    		u8 btn_into_pair_flg = 0;
    		u8 power_on = mouse_status->mouse_mode == STATE_POWERON;
    		if(button_func.start_maual_pair && clock_time_exceed(button_func.start_manual_pair_tick, 100000)){

    			button_func.start_maual_pair = 0;
    			btn_into_pair_flg = 1;
        		//u8 mouse_pair_anytime = device_never_linked && !mouse_cust_pairing_only_poweron
        		if(power_on || (!mouse_cust_pairing_only_poweron && device_never_linked)){
        			mouse_status->mouse_mode = STATE_PAIRING;
        		}
    		}
    	}
    }
#endif

	button_pre = button_last;

}
#elif((DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_wulian_V9_BOARD)&&(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0))//for only three button

#define DPI_CHANGE_BTN (FLAG_BUTTON_RIGHT|FLAG_BUTTON_MIDDLE)

u32 mouse_button_process(mouse_status_t * mouse_status)
{
    //button_last: current button
    //button_pre: previous button
    static u8 dpi_press=0;
	static u32 dpi_tick=0;
	if( 0 && !DEVICE_LED_BUSY){		//button_func.start_switch_sys_mode

    	if(button_func.start_switch_sys_mode){
    		u32 binding_mode_value = (button_func.system_mode == RF_1M_BLE_MODE) ? 0 : 0x1;
			binding_mode_addr_idx += 4;
			flash_write_page(CFG_DEVICE_MODE_ADDR + binding_mode_addr_idx, 4, &binding_mode_value);
    	}

		irq_disable();
		REG_ADDR8(0x6f) = 0x20;
		while(1);
	}
#if(ADV_TYPE_SWITCH_BY_BUTTON)
	if( button_func.system_mode == RF_1M_BLE_MODE){

		if (blc_ll_getCurrentState() != BLS_LINK_STATE_CONN){

			if(first_adv_switch == 1){
				first_adv_switch = 2;
				adv_direct_ind_flg = 0;
				adv_duration_timeout(0,0,0);
			}
			else if(first_adv_switch == 2){
				if(!DEVICE_LED_BUSY){
					device_led_setup(led_cfg[LED_NON_DIR_ADV]);		//Ƕ㲥,led blink slowly
				}
			}

			if( !first_adv_switch && button_func.start_switch_adv_type ){
				first_adv_switch = 1;
				button_func.start_switch_adv_type = 0;

				button_func.adv_type_switch_flg = 0;					//ǿrelease
				button_func.adv_type_switch_tick = clock_time();
			}
		}
	}
#endif
    if(button_func.btn_released){

									
    	if(button_func.system_mode == RF_1M_BLE_MODE && 0){	//button_func.sys_mode_switch_flg
    		button_func.start_switch_sys_mode = 1;
    		device_led_init(GPIO_LED_2P4, 1);
    		device_led_setup(led_cfg[LED_2P4_SWITCH_MODE]);
    	}

#if(ADV_TYPE_SWITCH_BY_BUTTON)
    	button_func.adv_type_switch_flg = 0;
#endif
    	button_func.sys_mode_switch_flg = 0;	//once the button be changed,  all flags be released
    	button_func.emi_mode_switch_flg = 0;
    	button_func.start_maual_pair = 0;
		dpi_press=0;

    	if( !button_last ){			//button -> no button
    		button_pre = button_last;
    		return 0;
    	}

    	if(button_func.system_mode == RF_2M_2P4G_MODE){
    		if(button_last == mouse_btn_ui.emi_ui){
    			button_func.emi_mode_switch_flg = 1;
    			button_func.emi_mode_switch_tick = clock_time();
    		}
    		else if(button_last == mouse_btn_ui.manual_pair_ui){
    			button_func.start_maual_pair = 1;
    			button_func.start_manual_pair_tick = clock_time();
    		}
    		else if(button_last == mouse_btn_ui.mode_switch_ui){
    			button_func.start_switch_sys_mode = 1;
    			device_led_init(GPIO_LED_BLE, 1);
    			device_led_setup(led_cfg[LED_BLE_SWITCH_MODE]);
    		}
    	}
    	else{
    		if(button_last == mouse_btn_ui.mode_switch_ui){
    			button_func.sys_mode_switch_flg = 1;
    		}
#if(ADV_TYPE_SWITCH_BY_BUTTON)

        	if( button_last == mouse_btn_ui.ble_pair_mode_ui ){
        		button_func.adv_type_switch_flg = 1;
        		button_func.adv_type_switch_tick = clock_time();
        	}
#endif

    	}

    	if((button_last == FLAG_BUTTON_DPI)) {            //new event
    		++mouse_status->cpi;
//    		mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
//    		mouse_sensor_set_cpi( &mouse_status->cpi );
//
//    		device_led_setup(led_cfg[mouse_status->cpi]);

			if(p_custom_cfg->sensor_type != U8_MAX){
				mouse_status->cpi = (4) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
				if(mouse_status->cpi == 3){
	    		device_led_setup(led_cfg[LED_CPI_3]);
				}
				else{
				device_led_setup(led_cfg[mouse_status->cpi]);
				}
			}
			else{
				mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
				device_led_setup(led_cfg[mouse_status->cpi]);
			}
    	}
        if((button_last == DPI_CHANGE_BTN))
		{
			dpi_press=1;
			dpi_tick= clock_time();
		}


    }
    else{

    	if( !button_last ){						//There is no button be pressed
        	button_pre = button_last;
        	return 0;
    	}
#if(ADV_TYPE_SWITCH_BY_BUTTON)	
    	if(button_func.adv_type_switch_flg){		// && clock_time_exceed(button_func.adv_type_switch_tick, 2000000)
    		//mode button be pressed time exceed than 3s,adv switch
    		blt_state = BLS_LINK_STATE_ADV;
    		button_func.sys_mode_switch_flg = 0;

    		button_func.start_switch_adv_type = 1;
    		//button_func.start_switch_adv_type = adv_direct_ind_flg;
    	}
#endif

    	if(button_func.emi_mode_switch_flg && clock_time_exceed(button_func.emi_mode_switch_tick, 1000000) ){
			mouse_status->mouse_mode = STATE_EMI;
			return 0;
    	}

    	if(button_func.system_mode == RF_2M_2P4G_MODE){
    		u8 btn_into_pair_flg = 0;
    		u8 power_on = mouse_status->mouse_mode == STATE_POWERON;
    		if(button_func.start_maual_pair && clock_time_exceed(button_func.start_manual_pair_tick, 100000)){

    			button_func.start_maual_pair = 0;
    			btn_into_pair_flg = 1;
        		//u8 mouse_pair_anytime = device_never_linked && !mouse_cust_pairing_only_poweron
        		if(power_on || (!mouse_cust_pairing_only_poweron && device_never_linked)){
        			mouse_status->mouse_mode = STATE_PAIRING;
        		}
    		}
    	}
		if(dpi_press&&clock_time_exceed(dpi_tick, 2000000))
		{
			dpi_press=0;
    		++mouse_status->cpi;
//    		mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
//    		mouse_sensor_set_cpi( &mouse_status->cpi );
//
//    		device_led_setup(led_cfg[mouse_status->cpi]);
			if(p_custom_cfg->sensor_type != U8_MAX){
				mouse_status->cpi = (4) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
				if(mouse_status->cpi == 3){
	    		device_led_setup(led_cfg[LED_CPI_3]);
				}
				else{
				device_led_setup(led_cfg[mouse_status->cpi]);
				}
			}
			else{
				mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
				device_led_setup(led_cfg[mouse_status->cpi]);
			}
    	
		}
    }

	button_pre = button_last;

}

#elif((DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_wulian_V10_BOARD)&&(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0))//for only three button

#define DPI_CHANGE_BTN (FLAG_BUTTON_RIGHT|FLAG_BUTTON_MIDDLE)

u32 mouse_button_process(mouse_status_t * mouse_status)
{
    //button_last: current button
    //button_pre: previous button
    static u8 dpi_press=0;
	static u32 dpi_tick=0;
	if( 0 && !DEVICE_LED_BUSY){		//button_func.start_switch_sys_mode

    	if(button_func.start_switch_sys_mode){
    		u32 binding_mode_value = (button_func.system_mode == RF_1M_BLE_MODE) ? 0 : 0x1;
			binding_mode_addr_idx += 4;
			flash_write_page(CFG_DEVICE_MODE_ADDR + binding_mode_addr_idx, 4, &binding_mode_value);
    	}

		irq_disable();
		REG_ADDR8(0x6f) = 0x20;
		while(1);
	}
#if(ADV_TYPE_SWITCH_BY_BUTTON)
	if( button_func.system_mode == RF_1M_BLE_MODE){

		if (blc_ll_getCurrentState() != BLS_LINK_STATE_CONN){

			if(first_adv_switch == 1){
				first_adv_switch = 2;
				adv_direct_ind_flg = 0;
				adv_duration_timeout(0,0,0);
			}
			else if(first_adv_switch == 2){
				if(!DEVICE_LED_BUSY){
					device_led_setup(led_cfg[LED_NON_DIR_ADV]);		//Ƕ㲥,led blink slowly
				}
			}

			if( !first_adv_switch && button_func.start_switch_adv_type ){
				first_adv_switch = 1;
				button_func.start_switch_adv_type = 0;

				button_func.adv_type_switch_flg = 0;					//ǿrelease
				button_func.adv_type_switch_tick = clock_time();
			}
		}
	}
#endif
    if(button_func.btn_released){
		if(button_func.sys_mode_switch_flg){            //new event
    		++mouse_status->cpi;
//    		mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
//    		mouse_sensor_set_cpi( &mouse_status->cpi );
//
//    		device_led_setup(led_cfg[mouse_status->cpi]);

			if(p_custom_cfg->sensor_type != U8_MAX){
				mouse_status->cpi = (4) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
				if(mouse_status->cpi == 3){
	    		device_led_setup(led_cfg[LED_CPI_3]);
				}
				else{
				device_led_setup(led_cfg[mouse_status->cpi]);
				}
			}
			else{
				mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
				device_led_setup(led_cfg[mouse_status->cpi]);
			}
    	}
									
    	if(button_func.system_mode == RF_1M_BLE_MODE && 0){	//button_func.sys_mode_switch_flg
    		button_func.start_switch_sys_mode = 1;
    		device_led_init(GPIO_LED_2P4, 1);
    		device_led_setup(led_cfg[LED_2P4_SWITCH_MODE]);
    	}

#if(ADV_TYPE_SWITCH_BY_BUTTON)
    	button_func.adv_type_switch_flg = 0;
#endif
    	button_func.sys_mode_switch_flg = 0;	//once the button be changed,  all flags be released
    	button_func.emi_mode_switch_flg = 0;
    	button_func.start_maual_pair = 0;
		dpi_press=0;

    	if( !button_last ){			//button -> no button
    		button_pre = button_last;
    		return 0;
    	}

    	if(button_func.system_mode == RF_2M_2P4G_MODE){
    		if(button_last == mouse_btn_ui.emi_ui){
    			button_func.emi_mode_switch_flg = 1;
    			button_func.emi_mode_switch_tick = clock_time();
    		}
    		else if(button_last == mouse_btn_ui.manual_pair_ui){
    			button_func.start_maual_pair = 1;
    			button_func.start_manual_pair_tick = clock_time();
    		}
    		else if(button_last == mouse_btn_ui.mode_switch_ui){
    			button_func.start_switch_sys_mode = 1;
    			device_led_init(GPIO_LED_BLE, 1);
    			device_led_setup(led_cfg[LED_BLE_SWITCH_MODE]);
    		}
    	}
    	else{
    		if(button_last == mouse_btn_ui.mode_switch_ui){
    			button_func.sys_mode_switch_flg = 1;
    		}
#if(ADV_TYPE_SWITCH_BY_BUTTON)

        	if( button_last == mouse_btn_ui.ble_pair_mode_ui ){
        		button_func.adv_type_switch_flg = 1;
        		button_func.adv_type_switch_tick = clock_time();
        	}
#endif

    	}
		
		
    	if((button_last == FLAG_BUTTON_DPI)) {            //new event
    		++mouse_status->cpi;
//    		mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
//    		mouse_sensor_set_cpi( &mouse_status->cpi );
//
//    		device_led_setup(led_cfg[mouse_status->cpi]);

			if(p_custom_cfg->sensor_type != U8_MAX){
				mouse_status->cpi = (4) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
				if(mouse_status->cpi == 3){
	    		device_led_setup(led_cfg[LED_CPI_3]);
				}
				else{
				device_led_setup(led_cfg[mouse_status->cpi]);
				}
			}
			else{
				mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
				device_led_setup(led_cfg[mouse_status->cpi]);
			}
    	}
        if((button_last == DPI_CHANGE_BTN))
		{
			dpi_press=1;
			dpi_tick= clock_time();
		}


    }
    else{
		u8 mouse_relsease_buff1[4] = {0};
    	if( !button_last ){						//There is no button be pressed
        	button_pre = button_last;
        	return 0;
    	}
#if(ADV_TYPE_SWITCH_BY_BUTTON)
    	if(button_func.adv_type_switch_flg && clock_time_exceed(button_func.adv_type_switch_tick, 2000000)){
    		//mode button be pressed time exceed than 3s,adv switch
			bls_att_pushNotifyData (19, mouse_relsease_buff1, 4);
			WaitMs(10);
			
    		blt_state = BLS_LINK_STATE_ADV;
    		button_func.sys_mode_switch_flg = 0;

    		button_func.start_switch_adv_type = 1;
    		//button_func.start_switch_adv_type = adv_direct_ind_flg;
    	}
#endif

    	if(button_func.emi_mode_switch_flg && clock_time_exceed(button_func.emi_mode_switch_tick, 1000000) ){
			mouse_status->mouse_mode = STATE_EMI;
			return 0;
    	}

    	if(button_func.system_mode == RF_2M_2P4G_MODE){
    		u8 btn_into_pair_flg = 0;
    		u8 power_on = mouse_status->mouse_mode == STATE_POWERON;
    		if(button_func.start_maual_pair && clock_time_exceed(button_func.start_manual_pair_tick, 100000)){

    			button_func.start_maual_pair = 0;
    			btn_into_pair_flg = 1;
        		//u8 mouse_pair_anytime = device_never_linked && !mouse_cust_pairing_only_poweron
        		if(power_on || (!mouse_cust_pairing_only_poweron && device_never_linked)){
        			mouse_status->mouse_mode = STATE_PAIRING;
        		}
    		}
    	}
		if(dpi_press&&clock_time_exceed(dpi_tick, 2000000))
		{
			dpi_press=0;
    		++mouse_status->cpi;
//    		mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
//    		mouse_sensor_set_cpi( &mouse_status->cpi );
//
//    		device_led_setup(led_cfg[mouse_status->cpi]);
			if(p_custom_cfg->sensor_type != U8_MAX){
				mouse_status->cpi = (4) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
				if(mouse_status->cpi == 3){
	    		device_led_setup(led_cfg[LED_CPI_3]);
				}
				else{
				device_led_setup(led_cfg[mouse_status->cpi]);
				}
			}
			else{
				mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
				device_led_setup(led_cfg[mouse_status->cpi]);
			}
    	
		}
    }

	button_pre = button_last;

}

#elif(((DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_wulian_V11_BOARD)&&(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0))||(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V1P0 ))				//for newman dual mode mouse

u32 mouse_button_process(mouse_status_t * mouse_status)
{
	static u8 mouse_button_dpi_pressed_flg = 0;

#if((DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V1P0) && !DAUL_MOUSE_YJX_BOARD)

    //button_last: current button
    //button_pre: previous button


    //switch mode, or switch adv type
#if(!MOUSE_ONLY_BLE_MODE)
	if( button_func.start_switch_sys_mode && !DEVICE_LED_BUSY){

    	if(button_func.start_switch_sys_mode){
    		u32 binding_mode_value = (button_func.system_mode == RF_1M_BLE_MODE) ? 0 : 0x1;
			binding_mode_addr_idx += 4;
			flash_write_page(CFG_DEVICE_MODE_ADDR + binding_mode_addr_idx, 4, &binding_mode_value);
    	}

		irq_disable();
		REG_ADDR8(0x6f) = 0x20;
		while(1);
	}
#endif

#if(ADV_TYPE_SWITCH_BY_BUTTON)
	if( button_func.system_mode == RF_1M_BLE_MODE){

		if (blc_ll_getCurrentState() != BLS_LINK_STATE_CONN){

			if(first_adv_switch == 1){
				first_adv_switch = 2;
				adv_direct_ind_flg = 0;
				adv_duration_timeout(0,0,0);
			}
			else if(first_adv_switch == 2){
				if(!DEVICE_LED_BUSY){
					device_led_setup(led_cfg[LED_NON_DIR_ADV]);		//Ƕ㲥,led blink slowly
				}
			}

			if( !first_adv_switch && button_func.start_switch_adv_type ){
				first_adv_switch = 1;
				button_func.start_switch_adv_type = 0;

				button_func.adv_type_switch_flg = 0;					//ǿrelease
				button_func.adv_type_switch_tick = clock_time();
			}
		}
	}


#endif
    if(button_func.btn_released){
#if(ADV_TYPE_SWITCH_BY_BUTTON)
    	button_func.adv_type_switch_flg = 0;
#endif
    	button_func.sys_mode_switch_flg = 0;	//once the button be changed,  all flags be released
    	button_func.emi_mode_switch_flg = 0;
    	button_func.start_maual_pair = 0;


    	if( !button_last ){			//button -> no button
    		button_pre = button_last;
    		return 0;
    	}
#if(ADV_TYPE_SWITCH_BY_BUTTON)
    	if(button_func.system_mode == RF_1M_BLE_MODE && (blc_ll_getCurrentState() != BLS_LINK_STATE_CONN )&& button_last == mouse_btn_ui.ble_pair_mode_ui){
    		button_func.adv_type_switch_flg = 1;
    		button_func.adv_type_switch_tick = clock_time();
    	}
#endif
    	if(button_func.system_mode == RF_2M_2P4G_MODE){
    		//if(button_last == (FLAG_BUTTON_LEFT | FLAG_BUTTON_RIGHT |  FLAG_BUTTON_MIDDLE)){
    		if(button_last == mouse_btn_ui.emi_ui){
    			button_func.emi_mode_switch_flg = 1;
    			button_func.emi_mode_switch_tick = clock_time();
    		}
    		else if(button_last == mouse_btn_ui.manual_pair_ui){
    			button_func.start_maual_pair = 1;
    			button_func.start_manual_pair_tick = clock_time();
    		}
    	}

    	if(button_last == mouse_btn_ui.mode_switch_ui){
    		button_func.sys_mode_switch_flg = 1;
    		button_func.sys_mode_switch_tick = clock_time();
    	}

    	if((button_last == FLAG_BUTTON_DPI)) {            //new event
    		++mouse_status->cpi;
//    		mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
//    		mouse_sensor_set_cpi( &mouse_status->cpi );
//
//    		device_led_setup(led_cfg[mouse_status->cpi]);

			if(p_custom_cfg->sensor_type != U8_MAX){
				mouse_status->cpi = (4) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
				if(mouse_status->cpi == 3){
	    		device_led_setup(led_cfg[LED_CPI_3]);
				}
				else{
				device_led_setup(led_cfg[mouse_status->cpi]);
				}
			}
			else{
				mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
				device_led_setup(led_cfg[mouse_status->cpi]);
			}
    	}



    }
    else{

    	if( !button_last ){						//There is no button be pressed
        	button_pre = button_last;
        	return 0;
    	}
#if(ADV_TYPE_SWITCH_BY_BUTTON)
    	if((button_func.system_mode == RF_1M_BLE_MODE) && button_func.adv_type_switch_flg && adv_direct_ind_flg \
    			&& clock_time_exceed(button_func.adv_type_switch_tick, 3000000)){
    		button_func.start_switch_adv_type = 1;  //adv_type_switch = 1;
    	}
#endif
    	if(button_func.sys_mode_switch_flg &&  !button_func.start_switch_sys_mode && \
    			clock_time_exceed(button_func.sys_mode_switch_tick, 3000000)){
    		button_func.start_switch_sys_mode = 1;
    		//switch_mode_start_flg = 1;
    		if(button_func.system_mode == RF_2M_2P4G_MODE)
    			device_led_setup(led_cfg[LED_BLE_SWITCH_MODE]);
    		else
    			device_led_setup(led_cfg[LED_2P4_SWITCH_MODE]);
    	}

    	if(button_func.emi_mode_switch_flg && clock_time_exceed(button_func.emi_mode_switch_tick, 1000000) ){
			mouse_status->mouse_mode = STATE_EMI;
			return 0;
    	}

    	if(button_func.system_mode == RF_2M_2P4G_MODE){
    		u8 btn_into_pair_flg = 0;
    		u8 power_on = mouse_status->mouse_mode == STATE_POWERON;
    		if(button_func.start_maual_pair && clock_time_exceed(button_func.start_manual_pair_tick, 100000)){

    			button_func.start_maual_pair = 0;
    			btn_into_pair_flg = 1;
        		if(power_on || (!mouse_cust_pairing_only_poweron && device_never_linked )){
        			mouse_status->mouse_mode = STATE_PAIRING;
        		}

    		}
    	}

    }
#else
    //button_last: current button
    //button_pre: previous button


    //switch mode, or switch adv type
	if( button_func.start_switch_sys_mode && !DEVICE_LED_BUSY){

    	if(button_func.start_switch_sys_mode){
    		u32 binding_mode_value = (button_func.system_mode == RF_1M_BLE_MODE) ? 0 : 0x1;
			binding_mode_addr_idx += 4;
			flash_write_page(CFG_DEVICE_MODE_ADDR + binding_mode_addr_idx, 4, &binding_mode_value);
    	}

		irq_disable();
		REG_ADDR8(0x6f) = 0x20;
		while(1);
	}

#if(ADV_TYPE_SWITCH_BY_BUTTON)
	if( button_func.system_mode == RF_1M_BLE_MODE){

		if (blc_ll_getCurrentState() != BLS_LINK_STATE_CONN){

			if(first_adv_switch == 1){
				first_adv_switch = 2;
				adv_direct_ind_flg = 0;
				adv_duration_timeout(0,0,0);
			}
			else if(first_adv_switch == 2){
				if(!DEVICE_LED_BUSY){
					device_led_setup(led_cfg[LED_NON_DIR_ADV]);		//Ƕ㲥,led blink slowly
				}
			}

			if( !first_adv_switch && button_func.start_switch_adv_type ){
				first_adv_switch = 1;
				button_func.start_switch_adv_type = 0;

				button_func.adv_type_switch_flg = 0;					//ǿrelease
				button_func.adv_type_switch_tick = clock_time();
			}
		}
	}
#endif

    if(button_func.btn_released){

#if(ADV_TYPE_SWITCH_BY_BUTTON)
	if( button_func.system_mode == RF_1M_BLE_MODE  && (blc_ll_getCurrentState() != BLS_LINK_STATE_CONN)){
		if( !first_adv_switch && button_func.start_switch_adv_type ){

			first_adv_switch = 1;
			adv_direct_ind_flg = 0;

			adv_duration_timeout(0,0,0);
			button_func.start_switch_adv_type = 0;

		}
	}

	if(mouse_button_dpi_pressed_flg&&(btn_power_value==0)){

		++mouse_status->cpi;
		mouse_button_dpi_pressed_flg = 0;
//		mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
//		mouse_sensor_set_cpi( &mouse_status->cpi );
//
//		device_led_setup(led_cfg[mouse_status->cpi]);

		if(p_custom_cfg->sensor_type != U8_MAX){
			mouse_status->cpi = (4) ? mouse_status->cpi : 0;
			mouse_sensor_set_cpi( &mouse_status->cpi );
			if(mouse_status->cpi == 3){
    		device_led_setup(led_cfg[LED_CPI_3]);
			}
			else{
			device_led_setup(led_cfg[mouse_status->cpi]);
			}
		}
		else{
			mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
			mouse_sensor_set_cpi( &mouse_status->cpi );
			device_led_setup(led_cfg[mouse_status->cpi]);
		}
	}

#endif


#if(ADV_TYPE_SWITCH_BY_BUTTON)
    	button_func.adv_type_switch_flg = 0;
#endif
    	button_func.sys_mode_switch_flg = 0;	//once the button be changed,  all flags be released
    	button_func.emi_mode_switch_flg = 0;
    	button_func.start_maual_pair = 0;


    	if( !button_last ){			//button -> no button
    		button_pre = button_last;
			btn_power_value=0;
    		return 0;
    	}

    	if(button_func.system_mode == RF_2M_2P4G_MODE){
    		if(button_last == mouse_btn_ui.emi_ui){
    			button_func.emi_mode_switch_flg = 1;
    			button_func.emi_mode_switch_tick = clock_time();
    		}
    		else if(button_last == mouse_btn_ui.manual_pair_ui){
    			button_func.start_maual_pair = 1;
    			button_func.start_manual_pair_tick = clock_time();
    		}
    		else if(button_last == mouse_btn_ui.mode_switch_ui){
    			button_func.sys_mode_switch_flg = 1;
    			button_func.sys_mode_switch_tick = clock_time();
    		}
    	}
    	else{
#if(ADV_TYPE_SWITCH_BY_BUTTON)

        	if( button_last == mouse_btn_ui.ble_pair_mode_ui ){
        		button_func.adv_type_switch_flg = 1;
        		button_func.adv_type_switch_tick = clock_time();
        	}
#endif
        	if((btn_power_value==0)&&(button_last == mouse_btn_ui.mode_switch_ui)){
        		button_func.sys_mode_switch_flg = 1;
        		button_func.sys_mode_switch_tick = clock_time();
        	}
    	}
    	if((button_last == FLAG_BUTTON_DPI)) {            //new event
    		mouse_button_dpi_pressed_flg = 1;
    	}
    }
    else{

    	if( !button_last ){						//There is no button be pressed
        	button_pre = button_last;
        	return 0;
    	}

#if(ADV_TYPE_SWITCH_BY_BUTTON)
    	if(button_func.adv_type_switch_flg){	// && clock_time_exceed(button_func.adv_type_switch_tick, 2000000)
    		//mode button be pressed time exceed than 3s,adv switch
    		blt_state = BLS_LINK_STATE_ADV;
    		button_func.sys_mode_switch_flg = 0;

    		button_func.start_switch_adv_type = 1;
    		//button_func.start_switch_adv_type = adv_direct_ind_flg;
    	}
#endif


    	if(button_func.sys_mode_switch_flg && clock_time_exceed(button_func.sys_mode_switch_tick, 2000000)){
    		//mode button be pressed time exceed than 3s,adv switch
    		button_func.sys_mode_switch_flg = 0;
    		button_func.start_switch_sys_mode = 1;

        	if(button_func.system_mode == RF_2M_2P4G_MODE){
        		device_led_init(GPIO_LED_BLE, 1);
        		device_led_setup(led_cfg[LED_BLE_SWITCH_MODE]);
        	}
        	else{
        		device_led_init(GPIO_LED_2P4, 1);
        		device_led_setup(led_cfg[LED_2P4_SWITCH_MODE]);
        	}
    	}

    	if(button_func.emi_mode_switch_flg && clock_time_exceed(button_func.emi_mode_switch_tick, 1000000) ){
			mouse_status->mouse_mode = STATE_EMI;
			return 0;
    	}

    	if(button_func.system_mode == RF_2M_2P4G_MODE){
    		u8 btn_into_pair_flg = 0;
    		u8 power_on = mouse_status->mouse_mode == STATE_POWERON;
    		if(button_func.start_maual_pair && clock_time_exceed(button_func.start_manual_pair_tick, 100000)){

    			button_func.start_maual_pair = 0;
    			btn_into_pair_flg = 1;
        		//u8 mouse_pair_anytime = device_never_linked && !mouse_cust_pairing_only_poweron
        		if(power_on || (!mouse_cust_pairing_only_poweron && device_never_linked)){
        			mouse_status->mouse_mode = STATE_PAIRING;
        		}
    		}
    	}
    }


#endif

	button_pre = button_last;
}

#elif(((DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_wulian_V12_BOARD)&&(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0))||(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V1P0 ))				//for newman dual mode mouse

u32 mouse_button_process(mouse_status_t * mouse_status)
{
	static u8 mouse_button_dpi_pressed_flg = 0;

#if((DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V1P0) && !DAUL_MOUSE_YJX_BOARD)

    //button_last: current button
    //button_pre: previous button


    //switch mode, or switch adv type
#if(!MOUSE_ONLY_BLE_MODE)
	if( button_func.start_switch_sys_mode && !DEVICE_LED_BUSY){

    	if(button_func.start_switch_sys_mode){
    		u32 binding_mode_value = (button_func.system_mode == RF_1M_BLE_MODE) ? 0 : 0x1;
			binding_mode_addr_idx += 4;
			flash_write_page(CFG_DEVICE_MODE_ADDR + binding_mode_addr_idx, 4, &binding_mode_value);
    	}

		irq_disable();
		REG_ADDR8(0x6f) = 0x20;
		while(1);
	}
#endif

#if(ADV_TYPE_SWITCH_BY_BUTTON)
	if( button_func.system_mode == RF_1M_BLE_MODE){

		if (blc_ll_getCurrentState() != BLS_LINK_STATE_CONN){

			if(first_adv_switch == 1){
				first_adv_switch = 2;
				adv_direct_ind_flg = 0;
				adv_duration_timeout(0,0,0);
			}
			else if(first_adv_switch == 2){
				if(!DEVICE_LED_BUSY){
					device_led_setup(led_cfg[LED_NON_DIR_ADV]);		//Ƕ㲥,led blink slowly
				}
			}

			if( !first_adv_switch && button_func.start_switch_adv_type ){
				first_adv_switch = 1;
				button_func.start_switch_adv_type = 0;

				button_func.adv_type_switch_flg = 0;					//ǿrelease
				button_func.adv_type_switch_tick = clock_time();
			}
		}
	}


#endif
    if(button_func.btn_released){
#if(ADV_TYPE_SWITCH_BY_BUTTON)
    	button_func.adv_type_switch_flg = 0;
#endif
    	button_func.sys_mode_switch_flg = 0;	//once the button be changed,  all flags be released
    	button_func.emi_mode_switch_flg = 0;
    	button_func.start_maual_pair = 0;


    	if( !button_last ){			//button -> no button
    		button_pre = button_last;
    		return 0;
    	}
#if(ADV_TYPE_SWITCH_BY_BUTTON)
    	if(button_func.system_mode == RF_1M_BLE_MODE && (blc_ll_getCurrentState() != BLS_LINK_STATE_CONN )&& button_last == mouse_btn_ui.ble_pair_mode_ui){
    		button_func.adv_type_switch_flg = 1;
    		button_func.adv_type_switch_tick = clock_time();
    	}
#endif
    	if(button_func.system_mode == RF_2M_2P4G_MODE){
    		//if(button_last == (FLAG_BUTTON_LEFT | FLAG_BUTTON_RIGHT |  FLAG_BUTTON_MIDDLE)){
    		if(button_last == mouse_btn_ui.emi_ui){
    			button_func.emi_mode_switch_flg = 1;
    			button_func.emi_mode_switch_tick = clock_time();
    		}
    		else if(button_last == mouse_btn_ui.manual_pair_ui){
    			button_func.start_maual_pair = 1;
    			button_func.start_manual_pair_tick = clock_time();
    		}
    	}

    	if(button_last == mouse_btn_ui.mode_switch_ui){
    		button_func.sys_mode_switch_flg = 1;
    		button_func.sys_mode_switch_tick = clock_time();
    	}

    	if((button_last == FLAG_BUTTON_DPI)) {            //new event
    		++mouse_status->cpi;
//    		mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
//    		mouse_sensor_set_cpi( &mouse_status->cpi );
//
//    		device_led_setup(led_cfg[mouse_status->cpi]);

			if(p_custom_cfg->sensor_type != U8_MAX){
				mouse_status->cpi = (4) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
				if(mouse_status->cpi == 3){
	    		device_led_setup(led_cfg[LED_CPI_3]);
				}
				else{
				device_led_setup(led_cfg[mouse_status->cpi]);
				}
			}
			else{
				mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
    			mouse_sensor_set_cpi( &mouse_status->cpi );
				device_led_setup(led_cfg[mouse_status->cpi]);
			}
    	}



    }
    else{

    	if( !button_last ){						//There is no button be pressed
        	button_pre = button_last;
        	return 0;
    	}
#if(ADV_TYPE_SWITCH_BY_BUTTON)
    	if((button_func.system_mode == RF_1M_BLE_MODE) && button_func.adv_type_switch_flg && adv_direct_ind_flg \
    			&& clock_time_exceed(button_func.adv_type_switch_tick, 3000000)){
    		button_func.start_switch_adv_type = 1;  //adv_type_switch = 1;
    	}
#endif
    	if(button_func.sys_mode_switch_flg &&  !button_func.start_switch_sys_mode && \
    			clock_time_exceed(button_func.sys_mode_switch_tick, 3000000)){
    		button_func.start_switch_sys_mode = 1;
    		//switch_mode_start_flg = 1;
    		if(button_func.system_mode == RF_2M_2P4G_MODE)
    			device_led_setup(led_cfg[LED_BLE_SWITCH_MODE]);
    		else
    			device_led_setup(led_cfg[LED_2P4_SWITCH_MODE]);
    	}

    	if(button_func.emi_mode_switch_flg && clock_time_exceed(button_func.emi_mode_switch_tick, 1000000) ){
			mouse_status->mouse_mode = STATE_EMI;
			return 0;
    	}

    	if(button_func.system_mode == RF_2M_2P4G_MODE){
    		u8 btn_into_pair_flg = 0;
    		u8 power_on = mouse_status->mouse_mode == STATE_POWERON;
    		if(button_func.start_maual_pair && clock_time_exceed(button_func.start_manual_pair_tick, 100000)){

    			button_func.start_maual_pair = 0;
    			btn_into_pair_flg = 1;
        		if(power_on || (!mouse_cust_pairing_only_poweron && device_never_linked )){
        			mouse_status->mouse_mode = STATE_PAIRING;
        		}

    		}
    	}

    }
#else
    //button_last: current button
    //button_pre: previous button


    //switch mode, or switch adv type
	if( button_func.start_switch_sys_mode && !DEVICE_LED_BUSY){

    	if(button_func.start_switch_sys_mode){
    		u32 binding_mode_value = (button_func.system_mode == RF_1M_BLE_MODE) ? 0 : 0x1;
			binding_mode_addr_idx += 4;
			flash_write_page(CFG_DEVICE_MODE_ADDR + binding_mode_addr_idx, 4, &binding_mode_value);
    	}

		irq_disable();
		REG_ADDR8(0x6f) = 0x20;
		while(1);
	}

#if(ADV_TYPE_SWITCH_BY_BUTTON)
	if( button_func.system_mode == RF_1M_BLE_MODE){

		if (blc_ll_getCurrentState() != BLS_LINK_STATE_CONN){

			if(first_adv_switch == 1){
				first_adv_switch = 2;
				adv_direct_ind_flg = 0;
				adv_duration_timeout(0,0,0);
			}
			else if(first_adv_switch == 2){
				if(!DEVICE_LED_BUSY){
					device_led_setup(led_cfg[LED_NON_DIR_ADV]);		//Ƕ㲥,led blink slowly
				}
			}

			if( !first_adv_switch && button_func.start_switch_adv_type ){
				first_adv_switch = 1;
				button_func.start_switch_adv_type = 0;

				button_func.adv_type_switch_flg = 0;					//ǿrelease
				button_func.adv_type_switch_tick = clock_time();
			}
		}
	}
#endif

    if(button_func.btn_released){

#if(ADV_TYPE_SWITCH_BY_BUTTON)
	if( button_func.system_mode == RF_1M_BLE_MODE  && (blc_ll_getCurrentState() != BLS_LINK_STATE_CONN)){
		if( !first_adv_switch && button_func.start_switch_adv_type ){

			first_adv_switch = 1;
			adv_direct_ind_flg = 0;

			adv_duration_timeout(0,0,0);
			button_func.start_switch_adv_type = 0;

		}
	}

	if(mouse_button_dpi_pressed_flg&&(btn_power_value==0)){

		++mouse_status->cpi;
		mouse_button_dpi_pressed_flg = 0;
//		mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
//		mouse_sensor_set_cpi( &mouse_status->cpi );
//
//		device_led_setup(led_cfg[mouse_status->cpi]);

		if(p_custom_cfg->sensor_type != U8_MAX){
			mouse_status->cpi = (4) ? mouse_status->cpi : 0;
			mouse_sensor_set_cpi( &mouse_status->cpi );
			if(mouse_status->cpi == 3){
    		device_led_setup(led_cfg[LED_CPI_3]);
			}
			else{
			device_led_setup(led_cfg[mouse_status->cpi]);
			}
		}
		else{
			mouse_status->cpi = (mouse_status->cpi < mouse_cpi.sns_cpi_sgmt) ? mouse_status->cpi : 0;
			mouse_sensor_set_cpi( &mouse_status->cpi );
			device_led_setup(led_cfg[mouse_status->cpi]);
		}
	}

#endif


#if(ADV_TYPE_SWITCH_BY_BUTTON)
    	button_func.adv_type_switch_flg = 0;
#endif
    	button_func.sys_mode_switch_flg = 0;	//once the button be changed,  all flags be released
    	button_func.emi_mode_switch_flg = 0;
    	button_func.start_maual_pair = 0;


    	if( !button_last ){			//button -> no button
    		button_pre = button_last;
			btn_power_value=0;
    		return 0;
    	}

    	if(button_func.system_mode == RF_2M_2P4G_MODE){
    		if(button_last == mouse_btn_ui.emi_ui){
    			button_func.emi_mode_switch_flg = 1;
    			button_func.emi_mode_switch_tick = clock_time();
    		}
    		else if(button_last == mouse_btn_ui.manual_pair_ui){
    			button_func.start_maual_pair = 1;
    			button_func.start_manual_pair_tick = clock_time();
    		}
    		else if(button_last == mouse_btn_ui.mode_switch_ui){
    			button_func.sys_mode_switch_flg = 1;
    			button_func.sys_mode_switch_tick = clock_time();
    		}
    	}
    	else{
#if(ADV_TYPE_SWITCH_BY_BUTTON)

        	if( button_last == mouse_btn_ui.ble_pair_mode_ui ){
        		button_func.adv_type_switch_flg = 1;
        		button_func.adv_type_switch_tick = clock_time();
        	}
#endif
        	if((btn_power_value==0)&&(button_last == mouse_btn_ui.mode_switch_ui)){
        		button_func.sys_mode_switch_flg = 1;
        		button_func.sys_mode_switch_tick = clock_time();
        	}
    	}
    	if((button_last == FLAG_BUTTON_MODE)) {            //new event
    		mouse_button_dpi_pressed_flg = 1;
    	}
    }
    else{

    	if( !button_last ){						//There is no button be pressed
        	button_pre = button_last;
        	return 0;
    	}

#if(ADV_TYPE_SWITCH_BY_BUTTON)
    	if(button_func.adv_type_switch_flg && clock_time_exceed(button_func.adv_type_switch_tick, 2000000)){
    		//mode button be pressed time exceed than 3s,adv switch
    		blt_state = BLS_LINK_STATE_ADV;
    		button_func.sys_mode_switch_flg = 0;

    		button_func.start_switch_adv_type = 1;
    		//button_func.start_switch_adv_type = adv_direct_ind_flg;
    	}
#endif


    	if(button_func.sys_mode_switch_flg && clock_time_exceed(button_func.sys_mode_switch_tick, 2000000)){
    		//mode button be pressed time exceed than 3s,adv switch
    		button_func.sys_mode_switch_flg = 0;
    		button_func.start_switch_sys_mode = 1;

        	if(button_func.system_mode == RF_2M_2P4G_MODE){
        		device_led_init(GPIO_LED_BLE, 1);
        		device_led_setup(led_cfg[LED_BLE_SWITCH_MODE]);
        	}
        	else{
        		device_led_init(GPIO_LED_2P4, 1);
        		device_led_setup(led_cfg[LED_2P4_SWITCH_MODE]);
        	}
    	}

    	if(button_func.emi_mode_switch_flg && clock_time_exceed(button_func.emi_mode_switch_tick, 1000000) ){
			mouse_status->mouse_mode = STATE_EMI;
			return 0;
    	}

    	if(button_func.system_mode == RF_2M_2P4G_MODE){
    		u8 btn_into_pair_flg = 0;
    		u8 power_on = mouse_status->mouse_mode == STATE_POWERON;
    		if(button_func.start_maual_pair && clock_time_exceed(button_func.start_manual_pair_tick, 100000)){

    			button_func.start_maual_pair = 0;
    			btn_into_pair_flg = 1;
        		//u8 mouse_pair_anytime = device_never_linked && !mouse_cust_pairing_only_poweron
        		if(power_on || (!mouse_cust_pairing_only_poweron && device_never_linked)){
        			mouse_status->mouse_mode = STATE_PAIRING;
        		}
    		}
    	}
    }


#endif

	button_pre = button_last;
}



#endif
u32 mouse_button_process_emi(s8 *chn_idx, u8 *test_mode_sel, u32 btn_pro_end)
{ 
    u32 cmd = 0;    
    if (button_pre != button_last) {     //new event
        cmd = 0x80;

        if(!button_pre && (button_last == FLAG_BUTTON_MIDDLE)){
        	*test_mode_sel = (*test_mode_sel+1) & 3;  //mode change: carrier, cd, rx, tx
        }
        else if(!button_pre && (button_last == FLAG_BUTTON_LEFT)){
        	*chn_idx += 1;               //channel up
        }
        else if(!button_pre && (button_last == FLAG_BUTTON_RIGHT)) {
               *chn_idx -= 1;            //channel down
        }
        else {
        	cmd &= 0x0f;
        }

        if (*chn_idx < 0) {
        	*chn_idx = 2;
        }
        else if (*chn_idx > 2) {
            *chn_idx = 0;
       }


        if( btn_pro_end )
            button_pre = button_last;
    }

#if 0
        if (!(button_pre & FLAG_BUTTON_MIDDLE) && (button_last & FLAG_BUTTON_MIDDLE)) {                
            *test_mode_sel = (*test_mode_sel+1) & 3;  //mode change: carrier, cd, rx, tx
        }
        else if (!(button_pre & FLAG_BUTTON_LEFT) && (button_last & FLAG_BUTTON_LEFT)) {
            *chn_idx += 1;               //channel up
        }
        else if (!(button_pre & FLAG_BUTTON_RIGHT) && (button_last & FLAG_BUTTON_RIGHT)) {                
            *chn_idx -= 1;               //channel down
        }
        else {
            cmd &= 0x0f;
        }
        
        if (*chn_idx < 0) {
            *chn_idx = 2;
        }
        else if (*chn_idx > 2) {
            *chn_idx = 0;
        }
    }
    if( btn_pro_end )
        button_pre = button_last;
#endif
    return cmd;
}

static inline u8 mouse_button_debounce(u8 btn_cur, u8 btn_last, u8 debouce_len){
    static u8 s_btn_cnt = 0;
	if(	s_btn_cnt >= debouce_len && btn_last != btn_cur ){
		btn_last = btn_cur;
		s_btn_cnt = 0;
	}else{
		if(btn_last != btn_cur)
			s_btn_cnt ++;
		else
			s_btn_cnt = 0;
	}
    return btn_last;
}

_attribute_ram_code_  void mouse_button_pull(mouse_status_t  * mouse_status, u32 prepare_level ){
    u32 pull_level = 0;
#if (DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_BingShou_V7_BOARD)
    u32 pull_level1 = 0;
    u32 pull_level2 = 0;
#endif
    u32 spec_pin = 0;
    int i = 0;
#if(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V1P0)
    for ( i = MAX_MOUSE_BUTTON - 1; i >= 0; i-- ){
        spec_pin = mouse_hw.button[i];
        pull_level = MOUSE_BTN_HIGH && mouse_hw.gpio_level_button[i];
        if ( pull_level == prepare_level ){
            gpio_setup_up_down_resistor( spec_pin, pull_level );            
        }
    }
#else
    for( i = MAX_MOUSE_BUTTON - 1; i >= 0; i-- ){
        spec_pin = mouse_status->hw_define->button[i];
        pull_level = (mouse_status->hw_define->gpio_level_button[i] == U8_MAX);
        if ( pull_level == prepare_level ){
        	if(!pull_level){							//pull level is 0 means that 100k pull down
        		pull_level = GPIO_PULL_DN_100K;
        	}
        	else{
        		pull_level = (i == 6) ? GPIO_PULL_UP_10K : pull_level; //PC5ʹ10K
        	}

            gpio_setup_up_down_resistor( spec_pin, pull_level );
        }
    }
#if (DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_BingShou_V7_BOARD)
    pull_level1 = (M_HW_GPIO_LEVEL_HUOLI ==U8_MAX);
	if(pull_level1 == prepare_level)	{
		if(!pull_level1){							//pull level is 0 means that 100k pull down
        		pull_level1 = GPIO_PULL_DN_100K;
        	}
        	else{
        		pull_level1 = (1 == 6) ? GPIO_PULL_UP_10K : pull_level1; //PC5ʹ10K
        	}

            gpio_setup_up_down_resistor( GPIO_PA0, pull_level1 );
	}
	pull_level2 = (M_HW_GPIO_LEVEL_CPI_JIAN ==U8_MAX);
	if(pull_level2 == prepare_level)	{
		if(!pull_level2){							//pull level is 0 means that 100k pull down
        		pull_level2 = GPIO_PULL_DN_100K;
        	}
        	else{
        		pull_level2 = (1 == 6) ? GPIO_PULL_UP_10K : pull_level2; //PC5ʹ10K
        	}

            gpio_setup_up_down_resistor( GPIO_PA0, pull_level2 );
	}
#endif	
    
#endif
}


/// \param detect_level - 0: detect low after button been pullup,  else: detect high after button been pulldown
/// \mouse should detect high, then detect low

//inline
_attribute_ram_code_ u8 mouse_button_detect(mouse_status_t  * mouse_status, u32 detect_level)
{

    u32 spec_pin = 0;
    static u8 btn_cur = 0;

    for ( int i = MAX_MOUSE_BUTTON - 1; i >= 0; i-- ){
//        spec_pin = mouse_status->hw_define->button[i];

		spec_pin = mouse_hw.button[i];
#if(MOUSE_BUTTON_GPIO_REUSABILITY)
		u32 pull_level =  (mouse_hw.gpio_level_button[i] == U8_MAX);

#else
    		u32 pull_level = MOUSE_BTN_HIGH;
#endif
		if ( pull_level != detect_level ){
			if( !gpio_read(spec_pin) ^ !pull_level ){
				btn_cur |= (1<<i);
			}
		}

    }
#if (DM_BOARD_V2P0_BOARD_YKQ==DUAL_MOUSE_BingShou_V7_BOARD)
    u32 pull_level1 = (M_HW_GPIO_LEVEL_HUOLI == U8_MAX);
	if ( pull_level1 != detect_level ){
		if( !gpio_read(GPIO_PA0) ^ !pull_level1 ){
			btn_cur |= FLAG_BUTTON_CPIJIANKEY;
		}
	}
	u32 pull_level2 = (M_HW_GPIO_LEVEL_CPI_JIAN == U8_MAX);
	if ( pull_level2 != detect_level ){
		if( !gpio_read(GPIO_PA0) ^ !pull_level2 ){
			btn_cur |= 0x01;
		}
	}
#endif
    //mask button event on power-on
//    static u8 btn_power_on_mask = 0xff;
//    if ( !btn_cur )
//        btn_power_on_mask = 0xff;

#if(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V1P0)
     mouse_status->data->btn = btn_cur & 0xff;
     button_func.btn_released = (button_last != btn_cur) ? 1 : 0;

     button_last = btn_cur;

#elif(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0)
     mouse_status->data->btn |= btn_cur & 0xff;
     if(detect_level == MOUSE_BTN_LOW){
    	 button_func.btn_released = (button_last !=   mouse_status->data->btn) ? 1 : 0;
    	 button_last =  mouse_status->data->btn;
     }
#endif
    btn_cur = 0;
    return button_last;
}

u32 mouse_button_pull_and_detect(mouse_status_t  * mouse_status){
    mouse_button_pull(mouse_status, MOUSE_BTN_LOW);
    WaitUs(100);
    mouse_button_detect(mouse_status, MOUSE_BTN_HIGH);
    mouse_button_pull(mouse_status, MOUSE_BTN_HIGH);    
    WaitUs(100);
    return mouse_button_detect(mouse_status, MOUSE_BTN_LOW);
}
#if((DM_BOARD_V2P0_BOARD_YKQ== DUAL_MOUSE_NEWMAN_BOARD)||(DM_BOARD_V2P0_BOARD_YKQ== DUAL_MOUSE_NEWMAN_V3_BOARD)||(DM_BOARD_V2P0_BOARD_YKQ== DUAL_MOUSE_wulian_V11_BOARD)||(DM_BOARD_V2P0_BOARD_YKQ== DUAL_MOUSE_wulian_V12_BOARD))

 static inline u8 button_get_status_ykq(u32 pin)
 {
	 u8 value=0;//no button press

	
	 if(gpio_read(pin)==0)//connect gnd
	 {
		 value=1;
		 
	 }
     else
     {
	 	gpio_setup_up_down_resistor(pin,PM_PIN_PULLDOWN_100K);
	 	gpio_write(pin,0);
	 	sleep_us(10);
	 	if(gpio_read(pin))
	 	{
		 	value=2;
	 	}
	 	gpio_setup_up_down_resistor(pin,PM_PIN_PULLUP_1M);
     }
  
	 return value;
 }
void btn_get_value()
{	 
	u16 status;
	btn_power_value=0;
	status=button_get_status_ykq(GPIO_PA1);
	btn_power_value|=(status==1)?FLAG_BUTTON_RIGHT:((status==2)?FLAG_BUTTON_DPI:0x00);
	status=button_get_status_ykq(GPIO_PE2);
	btn_power_value|=(status==1)?FLAG_BUTTON_MIDDLE:((status==2)?FLAG_BUTTON_FOWARD:0x00);
	status=button_get_status_ykq(GPIO_PE3);
	btn_power_value|=(status==1)?FLAG_BUTTON_LEFT:((status==2)?FLAG_BUTTON_BACKWARD:0x00);
	btn_power_value|=(gpio_read(GPIO_PC5)==0)?FLAG_BUTTON_MODE:0x00;

}

void mouse_button_power_dectect()
{


        btn_get_value();

}
#endif

