
#pragma once
#include "../../proj/config/user_config.h"

#include "mouse.h"

/* Enable C linkage for C++ Compilers: */
#if defined(__cplusplus)
extern "C" {
#endif


#ifndef MOUSE_CUSTOM_FULL_FUNCTION
#define MOUSE_CUSTOM_FULL_FUNCTION      1
#endif

#ifndef MOUSE_HW_CUS
#define MOUSE_HW_CUS      1
#endif

#ifndef MOUSE_SW_CUS
#define MOUSE_SW_CUS      1
#endif

#ifndef MOUSE_WKUP_SENSOR_SIM
#define MOUSE_WKUP_SENSOR_SIM      1
#endif

#ifndef MOUSE_BTNUI_CUS
#define MOUSE_BTNUI_CUS      1
#endif

#ifndef MOUSE_SENSOR_CPI_CUS
#define MOUSE_SENSOR_CPI_CUS	1
#endif


#ifndef M_HW_BTN_LEFT
#define M_HW_BTN_LEFT   GPIO_PA1
#endif

#ifndef M_HW_BTN_RIGHT
#define M_HW_BTN_RIGHT  GPIO_PE3
#endif

#ifndef M_HW_BTN_MIDL
#define M_HW_BTN_MIDL   GPIO_PE2
#endif

#ifndef M_HW_BTN_FB
#define M_HW_BTN_FB     GPIO_PC4
#endif

#ifndef M_HW_BTN_BB
#define M_HW_BTN_BB    GPIO_PC5
#endif

#ifndef M_HW_BTN_CPI
#define M_HW_BTN_CPI    GPIO_PC3
#endif

#ifndef M_HW_BTN_MODE
#define M_HW_BTN_MODE    GPIO_PC5
#endif

#ifndef M_HW_LED_CTL
#define M_HW_LED_CTL    GPIO_PA0
#endif

#ifndef M_HW_GPIO_LEVEL_LEFT
#define M_HW_GPIO_LEVEL_LEFT   U8_MAX
#endif

#ifndef M_HW_GPIO_LEVEL_RIGHT
#define M_HW_GPIO_LEVEL_RIGHT   U8_MAX
#endif

#ifndef M_HW_GPIO_LEVEL_MIDL
#define M_HW_GPIO_LEVEL_MIDL   U8_MAX
#endif

#ifndef M_HW_GPIO_LEVEL_FB
#define M_HW_GPIO_LEVEL_FB   U8_MAX
#endif

#ifndef M_HW_GPIO_LEVEL_BB
#define M_HW_GPIO_LEVEL_BB   U8_MAX
#endif

#ifndef M_HW_GPIO_LEVEL_CPI
#define M_HW_GPIO_LEVEL_CPI   U8_MAX
#endif

#ifndef M_HW_GPIO_LEVEL_MODE
#define M_HW_GPIO_LEVEL_MODE   U8_MAX
#endif

#ifndef M_HW_GPIO_LEVEL_LED
#define M_HW_GPIO_LEVEL_LED   U8_MAX
#endif

#ifndef M_HW_VBAT_CHN
#define M_HW_VBAT_CHN    GPIO_PB7			// A/D Module
#endif


#ifndef M_HW_CFG_1_DIR_0
#define M_HW_CFG_1_DIR_0  	GPIO_PC4					//PC4 DIR-0
#endif

#ifndef M_HW_CFG_1_DIR_1
#define M_HW_CFG_1_DIR_1  	GPIO_PA0 					//PA0 DIR-1
#endif

#ifndef M_HW_CFG_2_DIR_0
#define M_HW_CFG_2_DIR_0  0					//No used
#endif

#ifndef M_HW_CFG_2_DIR_1
#define M_HW_CFG_2_DIR_1  0					//No used
#endif


#ifndef M_HW_WHEEL_Z0
#define M_HW_WHEEL_Z0   GPIO_PE1
#endif

#ifndef M_HW_WHEEL_Z1
#define M_HW_WHEEL_Z1   GPIO_PE0
#endif

#ifndef M_HW_SNS_DATA
#define M_HW_SNS_DATA   GPIO_PB6
#endif

#ifndef M_HW_SNS_CLK
#define M_HW_SNS_CLK    GPIO_PB1
#endif

#ifndef M_HW_SNS_MOT_PIN
#define M_HW_SNS_MOT_PIN    GPIO_PC2
#endif


#ifndef CUST_DIR_IDX_RE_0
#define CUST_DIR_IDX_RE_0   0xff
#endif

#ifndef CUST_DIR_IDX_RE_1
#define CUST_DIR_IDX_RE_1   0xff
#endif

#ifndef CUST_DIR_IDX_RE_2
#define CUST_DIR_IDX_RE_2   0xff
#endif

#ifndef CUST_DIR_IDX_RE_3
#define CUST_DIR_IDX_RE_3   0xff
#endif

#ifndef CUST_BTN_DETECT_NUM
#define CUST_BTN_DETECT_NUM	0xff		//all button should be detected
#endif

enum{
	E_LED_POWER_ON = 0,
    E_LED_PAIRING,
    E_LED_PAIRING_END,
    E_LED_BAT_LOW,
    E_LED_CPI,
    E_LED_RSVD,
};

typedef struct{
	u8	sns_cpi_dft;	
	u8  sns_cpi_sgmt;	
	u8  sns_cpi_tbl[4];	
} custom_cpi_cfg_t;

typedef struct{
    u8  mode_switch_ui;          //0x20:0xff for auto; else for paring/emi key define
    u8  emi_ui;             	 //0xff for auto; else for paring/emi key define
    u8  manual_pair_ui;
    u8  ble_pair_mode_ui;		// ble mode, long press button can switch to pair mode
} custom_btn_ui_t;


typedef struct{
	

	u32 did;				//device id

	u16	gid;				//grop id, no use
	u16 vid;				//vend0r id, means pipe0

	u8	batt_type;		 	//0x08
    u8  tx_power;   	 	//0x09
    u8  tx_power_paring; 	//0x0a
    u8  tx_power_emi;    	//0x0b


	u8	wheel_dir;			//0x0c
    u8  no_ov_rd;			//0x0d
	u8	sns_dir;			//0x0e,  sensor direction select
	u8	sns_hw_cpi;			//0x0f

	u8  sensor_type;		//0x10,  sensor type select, 0xff: default detect; 0: PAW3212 sensor
	u8  board;				//0x11,
	u8  pairing_only_poweron;	// 0xff:mannual pairing only power on, 0x00: anytime pair with dongle
	u8  batt_alarm_thresh;		//0x13

    
    custom_btn_ui_t btn_ui;     //0x14
	custom_cpi_cfg_t sns_cpi;   //0x18

	mouse_hw_t cust_ms_hw; 	 //0x1e mouse hw_define
} custom_cfg_t;

extern custom_cfg_t    *p_custom_cfg;
extern custom_cpi_cfg_t mouse_cpi;
extern custom_btn_ui_t  mouse_btn_ui;

//extern led_cfg_t mouse_led_cfg[];
#define mouse_tx_power         ( (p_custom_cfg->tx_power == 0xff) ? RF_POWER_8dBm : p_custom_cfg->tx_power )
#define mouse_tx_paring_power  ( (p_custom_cfg->tx_power_paring == 0xff) ? RF_POWER_m14dBm : p_custom_cfg->tx_power_paring )
#define mouse_tx_emi_power     RF_POWER_8dBm

#define mouse_cust_pairing_only_poweron		(p_custom_cfg->pairing_only_poweron)

#define sensor_motion_detct    	1  	//with motion_pin, motion wakeup suspend
//#define sensor_motion_detct		0	//no motion pin,

#define sensor_no_overflow_rd   0


void mouse_custom_init ( mouse_status_t *pStatus );

