/*
 * mouse_emi.c
 *
 *  Created on: Feb 14, 2014
 *      Author: xuzhen
 */

#include "../../proj/tl_common.h"
#include "../../proj/mcu/watchdog_i.h"
#include "../../proj_lib/rf_drv.h"
#include "../common/common_emi.h"
#include "mouse.h"
#include "mouse_button.h"
#include "mouse_emi.h"
#include "mouse_custom.h"

void mouse_emi_process(mouse_status_t *mouse_status)
{
    static s8   test_chn_idx = 1;    
    static u8   test_mode_sel = 0;
    static u8   flg_emi_init = 0;
    u32 cmd;    
#if(DUAL_MOUSE_BOARD == DUAL_MOUSE_TELINK_BOARD_V2P0)
    mouse_status->data->btn = 0;
#endif
	mouse_button_detect(mouse_status, MOUSE_BTN_LOW);

	cmd = mouse_button_process_emi( &test_chn_idx, &test_mode_sel, 1 );
    cmd |= !flg_emi_init;
    if( !flg_emi_init ){
        flg_emi_init = 1;
    }  
	u8 emi_power,RF_POWER_VAL;
	flash_read_page(0x1f00b, 1, &emi_power);
	if(emi_power==0xff){
		RF_POWER_VAL=RF_POWER_8dBm;
		}
	else if(emi_power==0x01){
		RF_POWER_VAL=RF_POWER_4dBm;
		}
	else if(emi_power==0x02){
		RF_POWER_VAL=RF_POWER_0dBm;
		}
		else if(emi_power==0x03){
		RF_POWER_VAL=RF_POWER_m4dBm;
		}
	else if(emi_power==0x04){
		RF_POWER_VAL=RF_POWER_m10dBm;
		}
		else if(emi_power==0x05){
		RF_POWER_VAL=RF_POWER_m14dBm;
		}
	else if(emi_power==0x06){
		RF_POWER_VAL=RF_POWER_m20dBm;
		}
		else if(emi_power==0x07){
		RF_POWER_VAL=RF_POWER_m24dBm;
		}
	else if(emi_power==0x08){
		RF_POWER_VAL=RF_POWER_m28dBm;
		}
	else{
		};
	emi_process( cmd , test_chn_idx, test_mode_sel, mouse_status->pkt_addr, RF_POWER_VAL );
}

