#include "../../proj/tl_common.h"
#include "../../proj_lib/rf_drv.h"
#include "../../proj_lib/pm.h"
//#include "../../proj_lib/blt_ll/blt_ll.h"
#include "../common/tl_audio.h"
//#include "../../proj_lib/blt_ll/trace.h"


#include "../../proj_lib/pm.h"
#include "../common/blt_led.h"

#include "aaa_public_config.h"

#include "aaa_24g_rf.h"

typedef enum{
	STATE_POWERON = 0,        
	STATE_SYNCING,
	STATE_PAIRING ,
	STATE_NORMAL,
	//STATE_SUSPEND,
	//STATE_DEEPSLEEP,
	//STATE_EMI,

}MOUSE_MODE;

#define BASE_SUSPEND_TIME    8
#define SHORT_SUSPEND_TIME   8
#define LONG_SUSPEND_TIME    800
#define PARING_POWER_ON_CNT     64


u16 power_on_cnt=0;
u32 power_tick=0;

#if(!MOUSE_PIPE1_DATA_WITH_DID)

u8 pipe1_send_id_flg ;
#endif

u8 device_paired_flag=0;
u8 device_status=0;
u32 dongle_id;

u8 keyboard_send_need_f=1;
u16 no_ack=0;
rf_packet_pairing_t	pkt_pairing = {
		sizeof (rf_packet_pairing_t) - 4,	// dma_len

		sizeof (rf_packet_pairing_t) - 5,	// rf_len
		RF_PROTO_BYTE,						// proto

		PKT_FLOW_PARING,	                    // flow
		FRAME_TYPE_MOUSE,					// type

//		PIPE0_CODE,			// gid0

		0,					// rssi
		0,					// per
		0,					// seq_no
		0,					// reserved
		0x0c0c0c0c			// device id
};
rf_packet_keyboard_t pkt_kb={
		sizeof (rf_packet_keyboard_t) - 4,	//0x10=20-4,dma_len

		sizeof (rf_packet_keyboard_t) - 5,	//0x0f=20-5,rf_len
		RF_PROTO_BYTE,						// 0x51, proto
		PKT_FLOW_DIR,						// 0x80, kb data flow
		FRAME_TYPE_KEYBOARD,				// 0x02, type

//		U32_MAX,			// gid0

		0,					// rssi
		0,					// per
		0,					// seq_no
		1,					// pno
};

u8* use_rf_pkt = (u8*)&pkt_pairing;
u32 tick_loop=0;
u32 wakeup_next_tick=0;
u16 wake_timer=BASE_SUSPEND_TIME;
#define DBG_RX_IRQ	0
#if (DBG_RX_IRQ)

#define	DBG_RECIVE_PAKCET_NUM	8
#define DBG_RECIVE_PAKCET_SIZE	48
u8 rx_ack_pair[DBG_RECIVE_PAKCET_SIZE * DBG_RECIVE_PAKCET_NUM];
#endif

_attribute_ram_code_  void kb_led_out_aaa(u8 status)
{
	
#if HAS_NUM_LED_AAA
	led_num_set((status&0x01)?LED_ON_AAA:LED_OFF_AAA);
#endif
   
	
#if HAS_CAPS_LED_AAA
	led_caps_set((status&0x02)?LED_ON_AAA:LED_OFF_AAA);
#endif
	
#if HAS_SCROLL_LED_AAA
	led_scroll_set((status&0x04)?LED_ON_AAA:LED_OFF_AAA);
#endif
}


_attribute_ram_code_ int  rf_rx_process(u8 * p)
{
	rf_packet_ack_pairing_t *p_pkt = (rf_packet_ack_pairing_t *) (p + 8);


#if(DBG_RX_IRQ)
	static u8 rf_rx_cnt;
	rf_rx_cnt = (rf_rx_cnt+1) & (DBG_RECIVE_PAKCET_NUM -1);
	memcpy( (rx_ack_pair + (rf_rx_cnt * DBG_RECIVE_PAKCET_SIZE )),\
			p, DBG_RECIVE_PAKCET_SIZE);
#endif

	if (p_pkt->proto == RF_PROTO_BYTE) {
		//pkt_mouse_pairing.rssi = p[4];
		//pkt_mouse.rssi = p[4];
        //pkt_mouse.per ^= 0x80;
		///////////////  Paring/Link ACK //////////////////////////
		if (p_pkt->type == FRAME_TYPE_ACK && (p_pkt->did == pkt_pairing.did) ) {	//paring/link request
            rf_set_access_code1 (p_pkt->gid1);          //access_code1 = p_pkt->gid1;
		   if(flash_dev_info.dongle_id!=p_pkt->gid1)
		   {
		   	 flash_dev_info.dongle_id = p_pkt->gid1;
			 
			flash_dev_info.idx += 8;
			flash_write_page(CFG_DEVICE_MODE_ADDR+flash_dev_info.idx,8,(u8*)&flash_dev_info.dongle_id);
		   }
		  
		    
			return 1;
		}
		////////// end of PIPE1 /////////////////////////////////////
		///////////// PIPE1: ACK /////////////////////////////
		else if (p_pkt->type == FRAME_TYPE_ACK_MOUSE) {
#if(!MOUSE_PIPE1_DATA_WITH_DID)
			pipe1_send_id_flg = 0;
#endif
			return 1;
		}
		else if (p_pkt->type == FRAME_TYPE_ACK_KEYBOARD) {
#if(!MOUSE_PIPE1_DATA_WITH_DID)
			pipe1_send_id_flg = 0;
#endif
			rf_packet_ack_keyboard_t* kb_ack=((rf_packet_ack_keyboard_t*)p_pkt);
            kb_led_status=kb_ack->status;
            kb_led_out_aaa(kb_led_status);
			return 1;
		}
#if(!MOUSE_PIPE1_DATA_WITH_DID)
		else if(p_pkt->type == FRAME_AUTO_ACK_MOUSE_ASK_ID){ //fix auto bug
			pipe1_send_id_flg = 1;
			return 1;
		}
#endif
#if(!MOUSE_PIPE1_DATA_WITH_DID)
				else if(p_pkt->type == FRAME_AUTO_ACK_KB_ASK_ID){
					pipe1_send_id_flg = 1;//fix auto bug
					rf_packet_ack_keyboard_t* kb_ack=((rf_packet_ack_keyboard_t*)p_pkt);

                     kb_led_status=kb_ack->status;
            		kb_led_out_aaa(kb_led_status);
					return 1;
				}
#endif

		////////// end of PIPE1 /////////////////////////////////////
	}
	return 0;
}

void mouse_custom_init ()
{

    if(user_cfg.rf_vid!= U16_MAX)
	{
    	rf_set_access_code0(rf_access_code_16to32(user_cfg.rf_vid));
	}
    else
	{
    	rf_set_access_code0 (0x39517695);
    }

	/*****************   set up did(device id)    ********************/

    pkt_pairing.did = user_cfg.dev_mac;
#if MOUSE_PIPE1_DATA_WITH_DID
    //pkt_mouse.did = pkt_mouse_pairing.did;
	pkt_kb.did=pkt_pairing.did;
#endif 

	rf_set_access_code1 (flash_dev_info.dongle_id);

}

void d24_user_init()
{
#if 0
		 //customize freq_offset adjust cap value, if not customized, default ana_81 is 0xd0
		 if( (*(unsigned char*) CUST_CAP_INFO_ADDR_2M) != 0xff ){
			 //ana_81<4:0> is cap value(0x00 - 0x1f)
			 analog_write(0x81, (analog_read(0x81)&0xe0) | ((*(unsigned char*) CUST_CAP_INFO_ADDR_2M)&0x1f) );
		 }
	
		 // customize TP0/TP1
		 if( ((*(unsigned char*) (CUST_TP_INFO_ADDR_2M)) != 0xff) && ((*(unsigned char*) (CUST_TP_INFO_ADDR_2M+1)) != 0xff) ){
			 rf_update_tp_value(*(unsigned char*) (CUST_TP_INFO_ADDR_2M), *(unsigned char*) (CUST_TP_INFO_ADDR_2M+1));
		 }
	
#else
		u8 cap_value=0;
		flash_read_page(CUST_CAP_INFO_ADDR_2M,1,&cap_value);
		if(cap_value!=0xff)
		{
			 //ana_81<4:0> is cap value(0x00 - 0x1f)
			 analog_write(0x81, (analog_read(0x81)&0xe0) | (cap_value&0x1f) );
		}
		 u8 tp_value[2];
		 flash_read_page(CUST_TP_INFO_ADDR_2M,2,&tp_value[0]);
		 if((tp_value[0]!=0xff)&&(tp_value[1]!=0xff))
		 {
			 rf_update_tp_value(tp_value[0],tp_value[1]);
		 
		 }
		
#endif

  mouse_custom_init();


   ll_device_init();   
   rf_receiving_pipe_enble( 0x3f);	// channel mask
   rf_set_power_level_index (user_cfg.tx_power);

    if((flash_dev_info.dongle_id!=U32_MAX)&&(flash_dev_info.dongle_id!=0))
    {
		device_paired_flag=1;
    }
     if((deep_flag==0))//never pair
     {
		device_status=STATE_SYNCING;
		power_on_cnt=0;
		power_tick=clock_time()|1;
     }
	 else
	 {
		device_status=STATE_NORMAL;
	 }
		
        
  		
 
	 #if CURRENT_24G_TEST_AAA
  		d24_start_pair();
	 #endif
 
#if(BATT_CHECK_FUN_ENABLE)
	
	battery_hw_init();
#endif

   
  
	tick_loop=clock_time();
	wakeup_next_tick=clock_time();
	reset_idle_status();
	no_ack=0;

}
u8 d24_notify_data_proc_aaa()
{
	 u8 ret=0;
	// u16 att_handle=0;
	 if (tx_fifo_aaa.wptr!=tx_fifo_aaa.rptr)
	 {
		//wake_timer=BASE_SUSPEND_TIME;
		 TX_PACKET_AAA *p = (TX_PACKET_AAA*)tx_fifo_aaa.fifo[tx_fifo_aaa.rptr& (TX_FIFO_NUM_AAA-1)];
        if(combination_flag)
         {
 			memset(p->buf,0,p->len);
         }
		  else if(p->type==HAS_CONSUMER_REPORT)
		 {
            
			
		#if CONSUMER_REPORT_BYTE_AAA
			keyboard_send_need_f=1;
           pkt_kb.data[0]=1;
		   pkt_kb.data[1]=0;
		   pkt_kb.data[2]=p->buf[0];
		   pkt_kb.data[3]=0;
		   pkt_kb.data[4]=0;
		   pkt_kb.data[5]=0;
		   pkt_kb.data[6]=0;
		   pkt_kb.data[7]=0;
		#else
			keyboard_send_need_f=1;
			pkt_kb.data[0]=1;
			u32 temp=p->buf[0]+(p->buf[1]<<8)+(p->buf[2]<<16)+(p->buf[3]<<24);
			pkt_kb.data[1]=0;
			pkt_kb.data[2]=0;

			for(u8 i=0;i<32;i++)
			{
				if(temp&(1<<i))
				{
					pkt_kb.data[2]=C_INDEX_START+i;
					break;
				}
			}
			
		#endif
		   	
		 }
		
		 else if(p->type==HAS_KEYBOARD_REPORT)
		 {
		  	keyboard_send_need_f=1;
			u8 cnt=0;
		   for(u8 i=2;i<8;i++)
		   {
		   	   if(p->buf[i]==0)
		   	   {
			   	  break;
		   	   }
			   cnt++;
		   }
          	pkt_kb.data[0]=cnt;
		   	pkt_kb.data[1]=p->buf[0];
		   	memcpy(&pkt_kb.data[2],&p->buf[2],6);
		   	
		 }
		  else if(p->type==HAS_SYSYTEM_REPORT)
		 {
		 #if 1
           keyboard_send_need_f=1;
		 	
           pkt_kb.data[0]=1;
		   pkt_kb.data[1]=0;
		   pkt_kb.data[2]=p->buf[0];
		   pkt_kb.data[3]=0;
		   pkt_kb.data[4]=0;
		   pkt_kb.data[5]=0;
		   pkt_kb.data[6]=0;
		   pkt_kb.data[7]=0;
		   
		   #endif
		 }
		 else
		 {
		 	tx_fifo_aaa.rptr++;
		 }
		 
	 }
 
 	return ret;
}
void adv_sysn_proc()
{
	rf_set_tx_pipe(PIPE_PARING);
	rf_set_access_code1 ( U32_MAX );
	if(device_status==STATE_PAIRING)
	{
		rf_set_power_level_index (user_cfg.paring_tx_power);
		pkt_pairing.flow=PKT_FLOW_PARING;
	}
	else
	{
		rf_set_power_level_index (user_cfg.tx_power);
		if(power_on_cnt<PARING_POWER_ON_CNT)
		{
			power_on_cnt++;
			pkt_pairing.flow=PKT_FLOW_TOKEN|PKT_FLOW_PARING;
		}
		else
		{
			pkt_pairing.flow=PKT_FLOW_TOKEN;
		}
	}
	
	wake_timer=BASE_SUSPEND_TIME;
#if MOUSE_FUN_ENABLE_AAA
    pkt_mouse_pairing.type=FRAME_TYPE_MOUSE;
#else
     pkt_pairing.type=FRAME_TYPE_KEYBOARD;
#endif
    
   
	pkt_pairing.seq_no++;
	use_rf_pkt = (u8 *)&pkt_pairing;

	if( device_send_packet(use_rf_pkt, 550, 2, 0) )
	{
		no_ack=0;
		device_status=STATE_NORMAL;
	    device_paired_flag=1;
		keyboard_send_need_f=1;
		
		reset_idle_status();
		clear_pair_flag();
		
		rf_set_power_level_index (user_cfg.tx_power);
	}
	else
	{
		no_ack++;
#if ADV_TIMEOUT_DEEP_ENABLE_AAA
        if(((pair_flag==0)&&(device_paired_flag)&&(idle_count>4))||(idle_count>=ADV_TIMER_OUT))
        {
			enter_deep_aaa();
        }
		
		
	#endif
	#if 0
		if(device_status==STATE_SYNCING)
		{
			if(clock_time_exceed(tick_loop,3000000))
			{
				
				enter_deep_aaa();
			}
		}
		#endif
		
		led_24g_Adv_poll();
		
		
	}
}
#if AES_FUN_ENABLE
 u8 encKey[16]={
	0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,0x10};


void aes_user_encryption(u8 *key, u8 *plaintext, u8 *encrypted_data)
{
	
#if 1	//ecb	
	u8 rplaintext[16],rkey[16];
	swapX(plaintext, rplaintext, 16);
	swapX(key, rkey, 16);
	aes_ll_encryption(rkey, rplaintext, encrypted_data);
#else
	u8 rplaintext[16];
	swapX(plaintext, rplaintext, 16);
	aes_ll_encryption(key, rplaintext, encrypted_data);
#endif
}


void aes_user_decryption(u8 *key, u8 *encrypted_data, u8 *decrypted_data)
{
	
#if 1//ecb
	u8 rencrypted_data[16], rkey[16];	
	swapX(key, rkey, 16);
	swapX(encrypted_data, rencrypted_data, 16);
	aes_ll_decryption(rkey, rencrypted_data, decrypted_data);
#else
	u8 rencrypted_data[16];	
	swapX(encrypted_data, rencrypted_data, 16);
	aes_ll_decryption(key, rencrypted_data, decrypted_data);
#endif
}

#endif

u8 d24_keyboard_sendPacket()
{
	u8 ret=0;
	rf_set_tx_pipe(PIPE_KEYBOARD);
#if AES_FUN_ENABLE
	 rf_packet_keyboard_t enc_kb;
	memcpy((u8 *)&enc_kb.dma_len,(u8 *)&pkt_kb.dma_len,sizeof(rf_packet_keyboard_t)-16);
	aes_user_encryption(encKey,(u8 *)&pkt_kb.data[0],(u8 *)&enc_kb.data[0]);
	enc_kb.pno=pkt_kb.pno|0x80;
	use_rf_pkt=(u8*)&enc_kb;
#else
	use_rf_pkt = (u8*)&pkt_kb;
#endif
	if( device_send_packet(use_rf_pkt, 550, 2, 0) )
	{
		
		if (tx_fifo_aaa.wptr!=tx_fifo_aaa.rptr)
		{
			tx_fifo_aaa.rptr++;
			
		}
		ret=1;
	}
	else
	{
		pkt_kb.per++;
	}
	return ret;
}
void fix_auto_pair_dongle()
{
	
#if(!MOUSE_PIPE1_DATA_WITH_DID)
    	//fix auto paring bug, if dongle ACK ask for  id,send it in on pipe1
      
		if(pipe1_send_id_flg)
		{
			#if 1
			keyboard_send_need_f= 1;
			
			*(u32 *) (&pkt_kb.data[4]) = pkt_pairing.did;  //did in last 4 byte
#else
			u8 buf[8]={0,0,0,0,0,0,0,0};
			*(u32 *) (&buf[4]) = pkt_pairing.did;
			push_data_fifo_aaa(buf,HAS_KEYBOARD_REPORT,BUF_SIZE_KEYBOARD_AAA);
#endif
			pkt_kb.type = FRAME_TYPE_KB_SEND_ID;
			
		}
		else
		{
			 pkt_kb.type = FRAME_TYPE_KEYBOARD;
		}
#endif
}

void ui_loop_24g()
{
	u8 is_new_event=0;
	u8 rf_send_success=1;
#if BATT_CHECK_FUN_ENABLE
		battery_check();
#endif
	is_new_event=get_data_report_aaa();
	d24_check_pair_process();
	loop_cnt++;
	if(is_new_event)
	{
		reset_idle_status();
#if	HAS_BLINK_LED_WHEN_NEW_DATA
		led_new_event_blink_setup();
#endif
		//wake_timer=BASE_SUSPEND_TIME;

	}
	idle_status_poll();

	if(device_status == STATE_NORMAL)
	{
		pkt_kb.seq_no++;
		d24_notify_data_proc_aaa();
		
#if KEYBOARD_FUN_ENABLE_AAA

				if(DEVICE_LED_BUSY||(no_ack>0)||(loop_cnt<40))
			 	{
			 		wake_timer=BASE_SUSPEND_TIME;
			 	}
				else if(key_buf_aaa.press_cnt>0)
				{
					wake_timer=SHORT_SUSPEND_TIME;
					keyboard_send_need_f=1;
				}
			     else
			     {
			 		wake_timer=LONG_SUSPEND_TIME;
			     }
				fix_auto_pair_dongle();
				if(keyboard_send_need_f)
				{
					//sleep_us(2000);
					
					if(d24_keyboard_sendPacket())
					{
						keyboard_send_need_f=0;
						if(!(pkt_kb.data[1]||pkt_kb.data[2]))
						{
							pkt_kb.data[0]=0;
						}
						
					}
					else
					{
						rf_send_success=0;
					}
				
				}
#endif

		if(rf_send_success)
		{
			no_ack=0;
		}
		else
		{
			no_ack++;
            if(no_ack>100)
            {
				led_24g_Adv_poll();
            }
			if(no_ack>((4000)/wake_timer))
			{
				enter_deep_aaa();
			}
		}
		
	 	
		 
	 	if((idle_count>=CONNECT_TIME_OUT))
		{
			enter_deep_aaa();
		}
		
	
		
	}
	else 
	{
		adv_sysn_proc();
	}
	
    get_next_rf_channel();


#if HAS_DEVICE_LED_AAA
		device_led_process();
#endif	

	
}
void d24_start_pair()
{
	device_status = STATE_PAIRING;
	no_ack=0;
	set_pair_flag();
	reset_idle_status();
}
void d24_check_pair_process()
{
	 static u8 timer_out_flag=0;
	 static u32 tick;
#if IS_SINGLE_GPIO_PAIR_BUTTON
		 if(gpio_read(GPIO_PAIR_BTN)==0)
#else

	 if(key_buf_aaa.special_key_press_f==(T_W_PRESS_AAA|T_ESC_PRESS_AAA))
#endif
	 {
        combination_flag=1;
		if((timer_out_flag==0)&&clock_time_exceed(tick,1000000))
	 	{
			d24_start_pair();
			timer_out_flag=1;
	 	}
	 }
	 else
	 {
	 	timer_out_flag=0;
		tick=clock_time();
	 }
}
#if EMI_TEST_FUN_ENABLE_AAA
enum {
	EMI_cmd_chn_l  = 0,
	EMI_cmd_chn_m  = 1,
	EMI_cmd_chn_h  = 2,
	//host_cmd_paring = BIT(8),
	EMI_cmd_carrier= 0,
	EMI_cmd_cd		= 1,
	EMI_cmd_rx		= 2,
	EMI_cmd_tx		= 3,
};

extern unsigned char  ble_tx_packet [];
unsigned char *packet;
extern unsigned char  rx_packet[];

u8 mode_emi=0;
u8 channel=0;

u8 run_flag=0;


u8 emi_has_change()
{
	static u32 tick;
	u8 has_new_event=0;
	if(clock_time_exceed(tick,10000))
	{
		tick=clock_time();
		has_new_event=get_data_report_aaa();  
		if(has_new_event&&(key_buf_aaa.cnt==1))
		{
			
			if(key_buf_aaa.keycode[0]==KB_F1)
		    {
				channel=EMI_cmd_chn_l;
				mode_emi=EMI_cmd_carrier;
				run_flag=1;	
			}
			else if(key_buf_aaa.keycode[0]==KB_F2)
		    {
				channel=EMI_cmd_chn_l;
				mode_emi=EMI_cmd_cd;
				run_flag=1;	
			}
			else if(key_buf_aaa.keycode[0]==KB_F3)
		    {
				channel=EMI_cmd_chn_l;
				mode_emi=EMI_cmd_rx;
				run_flag=1;	
			}
			else if(key_buf_aaa.keycode[0]==KB_F4)
		    {
				channel=EMI_cmd_chn_l;
				mode_emi=EMI_cmd_tx;
				run_flag=1;	
			}
			
			else if(key_buf_aaa.keycode[0]==KB_F5)
		    {
				channel=EMI_cmd_chn_m;
				mode_emi=EMI_cmd_carrier;
				run_flag=1;	
			}
			else if(key_buf_aaa.keycode[0]==KB_F6)
		    {
				channel=EMI_cmd_chn_m;
				mode_emi=EMI_cmd_cd;
				run_flag=1;	
			}
			else if(key_buf_aaa.keycode[0]==KB_F7)
		    {
				channel=EMI_cmd_chn_m;
				mode_emi=EMI_cmd_rx;
				run_flag=1;	
			}
			else if(key_buf_aaa.keycode[0]==KB_F8)
		    {
				channel=EMI_cmd_chn_m;
				mode_emi=EMI_cmd_tx;
				run_flag=1;	
			}
			else if(key_buf_aaa.keycode[0]==KB_F9)
		    {
				channel=EMI_cmd_chn_h;
				mode_emi=EMI_cmd_carrier;
				run_flag=1;	
			}
			else if(key_buf_aaa.keycode[0]==KB_F10)
		    {
				channel=EMI_cmd_chn_h;
				mode_emi=EMI_cmd_cd;
				run_flag=1;	
			}
			else if(key_buf_aaa.keycode[0]==KB_F11)
		    {
				channel=EMI_cmd_chn_h;
				mode_emi=EMI_cmd_rx;
				run_flag=1;	
			}
			else if(key_buf_aaa.keycode[0]==KB_F12)
		    {
				channel=EMI_cmd_chn_h;
				mode_emi=EMI_cmd_tx;
				run_flag=1;	
			}
			
		}

	}
	return run_flag;
}
void emi_init_aaa()
{
	Rf_EmiInit();
	//accesscode: 1001-0100 1000-0010 0110-1110 1000-1110   29 41 76 71
	write_reg32 (0x800408, 0x29417671);
	PhyTest_PRBS9(ble_tx_packet + 6, 37);
	packet = ble_tx_packet;
}
void EmiCarrierOnly_aaa(int power_level,signed char rf_chn)
{
	Rf_EmiCarrierOnlyTest(power_level,rf_chn);
	while(!emi_has_change());

	rf_set_tx_rx_off();
}
void EmiCarrierData_aaa(int power_level,signed char rf_chn)
{
	Rf_EmiCarrierDataTest(power_level,rf_chn);
	while(!emi_has_change()) //// if not new command
	{
		Rf_EmiDataUpdate();
	}
	rf_set_tx_rx_off();
}

void EmiTx55_aaa(int power_level,signed char rf_chn)
{
	
	Rf_EmiTxInit(power_level,rf_chn);
	while(!emi_has_change()) //// if not new command
	{
		int i;
		packet[4] = 2;//type
		for( i=0;i<37;i++)
		{
			packet[6+i]=0x55;
		}
		Rf_EmiSingleTx(packet,power_level);
		
	}
	rf_set_tx_rx_off();
}


//unsigned char dug_irq_status = 0;
void EmiRxProc_aaa(void)
{
	if(reg_rf_irq_status & FLD_RF_IRQ_RX)
	{
		reg_rf_irq_status = FLD_RF_IRQ_RX;//clr rf irq
		if((rx_packet[0] >= 15) && RF_PACKET_LENGTH_OK (rx_packet) && RF_PACKET_CRC_OK(rx_packet))
		{		
		}
		rx_packet[0]=1;
	}
}

void EmiRx_aaa(int power_level,signed char rf_chn)
{
//	irq_enable();
	irq_set_mask( FLD_IRQ_ZB_RT_EN );
	reg_rf_irq_status = FLD_RF_IRQ_RX;
	reg_rf_irq_mask = FLD_RF_IRQ_RX;//rf irq en
	Rf_EmiRxTest(rx_packet,rf_chn,128,0);
	while(!emi_has_change())
	{
		EmiRxProc_aaa();
	}

	
}

void emi_serviceloop()
{
	
	u8 tbl_chn[3]={05,30,70};
	gpio_set_output_en(GPIO_24G_LED,1);
	gpio_set_input_en(GPIO_24G_LED,0);
	emi_init_aaa();
	run_flag=1;
	while(1)
	{
		if(run_flag)
		{
			run_flag=0;
			irq_disable();
		#if 1
		   for(u8 i=0; i<(mode_emi+1+channel*4);i++)
		   {
			 	
				gpio_write(GPIO_24G_LED,LED_ON_AAA);
				sleep_us(200000);
				gpio_write(GPIO_24G_LED,LED_OFF_AAA);
				sleep_us(200000);
		   }
		#endif
		
			if(mode_emi==EMI_cmd_carrier)//carri
			{
				EmiCarrierOnly_aaa(user_cfg.emi_tx_power,tbl_chn[channel]);
			}
			else if(mode_emi==EMI_cmd_cd)//cd
			{
				EmiCarrierData_aaa(user_cfg.emi_tx_power,tbl_chn[channel]);
			}
			else if(mode_emi==EMI_cmd_rx)//rx
			{
				EmiRx_aaa(user_cfg.emi_tx_power,tbl_chn[channel]);
			}
			else if(mode_emi==EMI_cmd_tx)//tx
			{
				EmiTx55_aaa(user_cfg.emi_tx_power,tbl_chn[channel]);
			}
			
		}
		
		
		
		
	}
}



void emi_check_ykq()
{
	 if(power_tick&&(!clock_time_exceed(power_tick,200000)))
	 {
	 	if((key_buf_aaa.keycode[0]==KB_E)&&(key_buf_aaa.cnt==1))
	 	{
			power_tick=0;
			//device_status = STATE_EMI;
			
			emi_serviceloop();
	 	}
	 }
	 else
	 {
	 	power_tick=0;
	 }
}
#endif
void d24_main_loop()
{
#if  EMI_TEST_FUN_ENABLE_AAA
	emi_check_ykq();
	
#endif	
	ui_loop_24g();
	

#if 0
	if(!clock_time_exceed(tick_loop,8000))
	{
		
		return ;
	}
	tick_loop=clock_time();
#else
#if 1
#if 1//MOUSE_FUN_ENABLE_AAA
    if(wake_timer==BASE_SUSPEND_TIME)
   {
   	 wakeup_next_tick+=wake_timer*CLOCK_SYS_CLOCK_1MS-320;
   }
   else
   {
   	 wakeup_next_tick+=wake_timer*CLOCK_SYS_CLOCK_1MS-160;
   }
#else
	wakeup_next_tick+=wake_timer*CLOCK_SYS_CLOCK_1MS;

#endif
    if(wake_timer==BASE_SUSPEND_TIME)
    {
		cpu_sleep_wakeup(0,PM_WAKEUP_TIMER, wakeup_next_tick );
    }
	else
	{
		cpu_sleep_wakeup(0, PM_WAKEUP_CORE  | PM_WAKEUP_TIMER, wakeup_next_tick );
	}
  
#else
    cpu_sleep_wakeup(0, PM_WAKEUP_TIMER|PM_WAKEUP_CORE, wakeup_next_tick+wake_timer*CLOCK_SYS_CLOCK_1MS);
#endif
   wakeup_next_tick=clock_time(); 
	
#endif

}

