
#include "AAA_public_config.h"

#include "../common/blt_soft_timer.h"

#define PM_ENABLE_AAA   1

#define USER_SOFT_TIMER_SHORT_T			20000


extern blt_soft_timer_t	blt_timer;


MYFIFO_INIT(blt_rxfifo, 64, 8);
MYFIFO_INIT(blt_txfifo, 40, 16);
typedef struct
{
  /** Minimum value for the connection event (interval. 0x0006 - 0x0C80 * 1.25 ms) */
  u16 Min;
  /** Maximum value for the connection event (interval. 0x0006 - 0x0C80 * 1.25 ms) */
  u16 Max;
  /** Number of LL latency connection events (0x0000 - 0x03e8) */
  u16 latency;
  /** Connection Timeout (0x000A - 0x0C80 * 10 ms) */
  u16 timeout;
} ConnectParams_t;
#define PARAMS_GROUP_LEN  16

const ConnectParams_t  ConParams[PARAMS_GROUP_LEN]={
{9,9,69,500},
{9,9,69,500},
{9,9,69,500},	
{9,9,19,500},
{9,9,19,500}, 
{ 9,9, 4,500},
{ 9,9, 4,500},	
{ 8,16, 4,500},
{ 8,16, 4,500},
{ 8,26, 4,500}, 
{ 7,7, 0,500},
{ 7,7, 0,500},	
{ 9,9, 0,500},
{ 9,9, 0,500},	
{ 12,12, 0,500},
{ 12,12, 0,500},


};

u8 ui_ota_is_working=0;
u8 done_encry_flag=0;
u32 loop_cnt;
u8 conn_params_pending = 0;
u8 conn_params_cout=0;

u32 connect_begin_tick;

u8 ble_status_aaa;
u32 idle_tick;
u32 adv_begin_tick;
u32  idle_count; 


#define DEVICE_NAME_AAA   "67_T_KB"

u8	tbl_advData_aaa[31] = {
19, 0x09, 
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0x02, 0x01, 0x05, 							// BLE limited discoverable mode and BR/EDR not supported
0x03, 0x19, 0xc1, 0x03, 					// 384, Keyboard, Generic category,
0x03, 0x02, 0x12, 0x18,					// incomplete list of service class UUIDs (0x1812-HID SERVICE, 180F-BATTERY)
};
void set_adv_scanRsp_data()
{
	memcpy(&tbl_advData_aaa[2],DEVICE_NAME_AAA,sizeof(DEVICE_NAME_AAA)-1);
	bls_ll_setAdvData( (u8 *)tbl_advData_aaa, 31 );
	bls_ll_setScanRspData( (u8 *)tbl_advData_aaa, 20);
	bls_att_setDeviceName((u8 *)(tbl_advData_aaa+2),18);
}

void deep_wakeup_proc_aaa(void)
{
	deep_flag=analog_read(DEEP_FLAG_ANA_AAA);
	analog_write(DEEP_FLAG_ANA_AAA,1);
#if (CURRENT_24G_TEST_AAA|CURRENT_BLE_TEST_AAA)

	back_light_switch_flag=BACK_LIGHT_OFF;
#endif
    pair_flag=analog_read(PAIR_FLAG_DEEP_ANA);
	
	matrix_init_aaa();
	led_hw_init();
	
#if IS_SINGLE_GPIO_PAIR_BUTTON 
     gpio_set_input_en(GPIO_PAIR_BTN,1);
     gpio_set_output_en(GPIO_PAIR_BTN,0);
     gpio_setup_up_down_resistor(GPIO_PAIR_BTN,PM_PIN_PULLUP_10K);
#endif	
	
	get_data_report_aaa();

	
#if 0
	if(deep_flag==0)
	{
		led_power_on();
	}
#endif
}

void	task_connect_aaa (u8 e, u8 *p, int n)
{
	connect_begin_tick=clock_time();
	//reset_idle_status();
	
	clear_pair_flag();
	led_ConnectedStatus();
	ui_ota_is_working=0;
	conn_params_pending=0;
	conn_params_cout=0;
	ble_status_aaa=BEGIN_CONNECTED_STATUS_AAA;
	
	if(memcmp(p-2, binding_master_addr, 8 ))
	{
   		memcpy(binding_master_addr, p-2, 8);
   		binding_master_addr_idx += 8;
		//bls_smp_enableParing (SMP_PARING_CONN_TRRIGER);
   		flash_write_page(CUST_RESERVE_MAC_ADDR + binding_master_addr_idx, 8, binding_master_addr);
 	}
}	

void 	ble_encry_done_aaa(u8 e,u8 *p, int n)
{
   	done_encry_flag=1;
}

void 	ble_remote_terminate_aaa(u8 e,u8 *p, int n) 
{
#if HAS_NUM_LED_AAA

    led_num_set(LED_OFF_AAA);
#endif
#if HAS_SCROLL_LED_AAA
	led_scroll_set(LED_OFF_AAA);
#endif
#if HAS_CAPS_LED_AAA
	led_caps_set(LED_OFF_AAA);
#endif	

	if(ble_status_aaa==TERMINATE_STATUS_AAA)
	{
		ble_status_aaa=DEEP_SLEEPE_STATUS_AAA;
	}
	else if(ble_status_aaa==MODE_CHANGE_STATUS_AAA)
	{
		bls_ll_setAdvEnable(0);	
	}
	else
	{
		ble_status_aaa=POWER_ON_STATUS_AAA;
	}
	delet_soft_time();
   done_encry_flag=0;
}

void adv_duration_timeout_aaa (u8 e, u8 *p, int n)
{
	
	bls_ll_setAdvDuration(0, 0);
	/*u8 status =*/bls_ll_setAdvParam( ADV_INTERVAL_20MS, ADV_INTERVAL_30MS, \
										 ADV_TYPE_CONNECTABLE_UNDIRECTED, OWN_ADDRESS_PUBLIC, \
										 0,  NULL,	BLT_ENABLE_ADV_ALL, ADV_FP_NONE);
	set_adv_scanRsp_data();
	bls_ll_setAdvEnable(1);  //adv enable
}	
void ble_kb_pairing_begin_aaa(u8 e, u8 *p, int n)
{
	//bls_smp_enableParing (SMP_PARING_CONN_TRRIGER);
}
void smp_pair_failed(u8 e, u8 *p, int n)
{
	if(*p == PARING_FAIL_REASON_UNSPECIFIED_REASON)
		bls_ll_terminateConnection(HCI_ERR_REMOTE_USER_TERM_CONN); //push terminate cmd into ble TX buffer
}

void ble_kb_param_updata_conf_aaa(u8 e, u8 *p, int n )
{
   conn_params_pending=0;
}
void ble_kb_param_req_conf_aaa(u8 e,u8 *p, int n)
{
	conn_params_pending=1;

	u16 interval = p[3] | p[4]<<8;
    u16 latency = p[5] | p[6]<<8;

    if((interval>=ConParams[conn_params_cout].Min)&&(interval<=ConParams[conn_params_cout].Max) && latency > 0){
    	conn_params_cout=0xff;

    }
	else
	{
		conn_params_cout++;
	}

}

void connect_params_proc()
{
	if((conn_params_pending==0)&&(conn_params_cout<PARAMS_GROUP_LEN))
	{
		conn_params_pending=1;
		bls_l2cap_requestConnParamUpdate(ConParams[conn_params_cout].Min,ConParams[conn_params_cout].Max,ConParams[conn_params_cout].latency,ConParams[conn_params_cout].timeout);
    	
	}
}
int kb_led_out_write_aaa(void* p)
{
	rf_packet_att_write_t *pkt_cmd = (rf_packet_att_write_t *)p;
	ble_status_aaa=OK_CONNECTED_STATUS_AAA;

	 kb_led_status=pkt_cmd->value;
     kb_led_out_aaa(kb_led_status);
     return 0;
}


_attribute_ram_code_ void  ble_remote_set_sleep_wakeup_aaa (u8 e, u8 *p, int n)
{
	if( blc_ll_getCurrentState() == BLS_LINK_STATE_CONN && ((u32)(bls_pm_getSystemWakeupTick() - clock_time())) > 80 * CLOCK_SYS_CLOCK_1MS){  //suspend time > 30ms.add gpio wakeup
		bls_pm_setWakeupSource(PM_WAKEUP_CORE);  //gpio CORE wakeup suspend
	}
}
void entry_ota_mode(void)
{
	ui_ota_is_working = 1;
 
	bls_ota_setTimeout(100 * 1000000); //set OTA timeout  100 S
}
void show_ota_result(int result)
{

}

static inline void blc_app_loadCustomizedParameters_aaa(void)
{
	 if(!blt_miscParam.ext_cap_en)
	 {
        u8 cap_value;
		flash_read_page(CUST_CAP_INFO_ADDR,1,&cap_value);
		if(cap_value!=0xff)
		{
			 //ana_81<4:0> is cap value(0x00 - 0x1f)
			 analog_write(0x81, (analog_read(0x81)&0xe0) | (cap_value&0x1f) );
		}
	 }

	 u8 tp_value[2];
	 flash_read_page(CUST_TP_INFO_ADDR,2,&tp_value[0]);
	 if((tp_value[0]!=0xff)&&(tp_value[1]!=0xff))
	 {
	 	 rf_update_tp_value(tp_value[0],tp_value[1]);
	 
	 }	
	 


	 if(blt_miscParam.pad32k_en)
	 {
		  //customize 32k RC cap, if not customized, default ana_32 is 0x80
		u8 pad32k_value;
		flash_read_page(CUST_32KPAD_CAP_INFO_ADDR,1,&pad32k_value);
		if(pad32k_value!=0xff)
		{
			 analog_write(0x03, pad32k_value );
		}
		 
	 }
}
u8 soft_time_flag=0;

_attribute_ram_code_ int soft_timer_suspend_proc(void)
{
    
	ui_loop();
	if(idle_count>=CONNECT_TIME_OUT)
	{
        soft_time_flag=0;
		return -1;
	}

	return USER_SOFT_TIMER_SHORT_T;
	
}

void add_soft_time()
{
	if(soft_time_flag==0)
	{
		if(blt_timer.currentNum == 0)
		{
			blt_soft_timer_add(&soft_timer_suspend_proc, USER_SOFT_TIMER_SHORT_T);
			
		}
		soft_time_flag=1;
	}

	
}
void delet_soft_time()
{
	
	if(soft_time_flag ==1)
	{ // ֮ǰ timerʱʵ
		if( blt_timer.currentNum )
		{
			blt_soft_timer_delete(&soft_timer_suspend_proc);
		}
		soft_time_flag = 0;
	}
}
int att_sig_proc_handler (u16 connHandle, u8 * p)
{
#if SIG_PROC_ENABLE

	rf_pkt_l2cap_sig_connParaUpRsp_t* pp = (rf_pkt_l2cap_sig_connParaUpRsp_t*)p;

#if 0//test debug
	foreach(i, 16){PrintHex(*((u8*)pp + i));}printf(".\n");
#endif

	u8 sig_conn_param_update_rsp[9] = { 0x0A, 0x06, 0x00, 0x05, 0x00, 0x13, 0x01, 0x02, 0x00 };
	if(!memcmp(sig_conn_param_update_rsp, &pp->rf_len, 9) && ((pp->type&0b11) == 2)){//l2cap data pkt, start pkt
		if(pp->result == 0x0000)
		{
#if PRINT_DEBUG_INFO
			printf("Host has accepted conn parameters\r\n");
#endif	
			conn_params_pending = 0;
			conn_params_cout=0xff;
		}
		else if(pp->result == 0x0001)
		{
			conn_params_pending = 0;
			conn_params_cout++;
#if PRINT_DEBUG_INFO

			printf("Host has rejected conn parameters\r\n");
#endif
		}
	}
#endif
	return 0;
}


void ble_user_init_aaa()
{

	blc_app_loadCustomizedParameters_aaa();  //load customized freq_offset cap value and tp value


////////////////// BLE stack initialization ////////////////////////////////////
	u8  tbl_mac [6] = {0x10, 0x11, 0x29, 0x11, 0x17, 0x20};
	 memcpy (tbl_mac, (u8*)&user_cfg.dev_mac, 6);

	tbl_mac[4]=flash_dev_info.slave_mac_addr;



	////// Controller Initialization  //////////
	blc_ll_initBasicMCU(tbl_mac);   //mandatory

	blc_ll_initAdvertising_module(tbl_mac); 	//adv module: 		 mandatory for BLE slave,
	blc_ll_initSlaveRole_module();				//slave module: 	 mandatory for BLE slave,
	blc_ll_initPowerManagement_module();        //pm module:      	 optional



	////// Host Initialization  //////////
	extern void my_att_init ();
	my_att_init (); //gatt initialization
	blc_l2cap_register_handler (blc_l2cap_packet_receive);  	//l2cap initialization
	bls_smp_enableParing (SMP_PARING_CONN_TRRIGER); 	//smp initialization
	HID_service_on_android7p0_init();
	blc_att_setServerDataPendingTime_upon_ClientCmd(50);


	#if SIG_PROC_ENABLE
	blc_l2cap_reg_att_sig_hander(att_sig_proc_handler);         //register sig process handler
#endif

///////////////////// USER application initialization ///////////////////
	set_adv_scanRsp_data();

	binding_master_addr_idx = flash_info_load_aaa(CUST_RESERVE_MAC_ADDR, binding_master_addr, 8);
#if 0	
	u8 status;

	if(adv_direct_ind_flg){	//direct adv
		status = bls_ll_setAdvParam( 	ADV_INTERVAL_3_75MS, ADV_INTERVAL_3_75MS, \
										ADV_TYPE_CONNECTABLE_DIRECTED_HIGH_DUTY, OWN_ADDRESS_PUBLIC, \
										device_info_type, &binding_master_addr[2], BLT_ENABLE_ADV_ALL, ADV_FP_NONE);
		//bls_ll_setAdvDuration(3 * 1000000, 1);

	}
	else

	{	//Ƕ㲥ȴRx randomϢ
		status = bls_ll_setAdvParam( ADV_INTERVAL_30MS, ADV_INTERVAL_30MS, \
									 	 ADV_TYPE_CONNECTABLE_UNDIRECTED, OWN_ADDRESS_PUBLIC, \
									 	 0,  NULL,  BLT_ENABLE_ADV_ALL , ADV_FP_NONE);
		
	}

	if(status != BLE_SUCCESS){  //adv setting err
		write_reg8(0x8000, 0x11);  //debug
		while(1);
	}
	bls_ll_setAdvEnable(1);  //adv enable
#endif

	rf_set_power_level_index (user_cfg.tx_power);

	//ble event call back
	bls_app_registerEventCallback (BLT_EV_FLAG_CONNECT, &task_connect_aaa);
	bls_app_registerEventCallback (BLT_EV_FLAG_TERMINATE, &ble_remote_terminate_aaa);
	bls_app_registerEventCallback (BLT_EV_FLAG_ADV_DURATION_TIMEOUT, &adv_duration_timeout_aaa);		//direct adv timeout
	bls_app_registerEventCallback (BLT_EV_FLAG_PAIRING_BEGIN, &ble_kb_pairing_begin_aaa);
	bls_app_registerEventCallback (BLT_EV_FLAG_CONN_PARA_UPDATE, &ble_kb_param_updata_conf_aaa);
	bls_app_registerEventCallback (BLT_EV_FLAG_CONN_PARA_REQ, &ble_kb_param_req_conf_aaa);

	bls_app_registerEventCallback (BLT_EV_FLAG_ENCRYPTION_CONN_DONE, &ble_encry_done_aaa);		//
	bls_app_registerEventCallback (BLT_EV_FLAG_PAIRING_END, &smp_pair_failed);	

	//bls_app_registerEventCallback (BLT_EV_FLAG_GPIO_EARLY_WAKEUP, &ble_proc_keyboard);			//early wakeup

	//bls_app_registerEventCallback (BLE_EV_FLAG_ATT_WRITE_CMD, &kb_callback_writecmd_aaa);			//early wakeup



	///////////////////// keyboard matrix initialization///////////////////
//	u32 pin[] = KB_DRIVE_PINS;
//	for (int i=0; i<(sizeof (pin)/sizeof(*pin)); i++)
//	{
//		gpio_set_wakeup(pin[i],1,1);  	   //drive pin core(gpio) high wakeup suspend
//		cpu_set_gpio_wakeup (pin[i],1,1);  //drive pin pad high wakeup deepsleep
//	}

//#if(KEYSCAN_IRQ_TRIGGER_MODE)
	//reg_irq_src = FLD_IRQ_GPIO_EN;
//#endif

	//bls_app_registerEventCallback (BLT_EV_FLAG_GPIO_EARLY_WAKEUP, &ble_proc_kb);


	

#if(BATT_CHECK_FUN_ENABLE)
	
	battery_hw_init();
#endif

		

		///////////////////// Power Management initialization///////////////////
#if PM_ENABLE_AAA
	blc_ll_initPowerManagement_module();
	bls_pm_setSuspendMask (SUSPEND_ADV | SUSPEND_CONN);
	bls_app_registerEventCallback (BLT_EV_FLAG_SUSPEND_ENTER, &ble_remote_set_sleep_wakeup_aaa);
#else
	bls_pm_setSuspendMask (SUSPEND_DISABLE);
#endif

#if BLT_SOFTWARE_TIMER_ENABLE

	blt_soft_timer_init();
    //add_soft_time();

#endif

	////////////////LED initialization /////////////////////////
	//device_led_init(GPIO_LED_LVD, 1);

#if (OTA_ENABLE_AAA)
	////////////////// OTA relative ////////////////////////
	bls_ota_clearNewFwDataArea(); //must
	bls_ota_registerStartCmdCb(entry_ota_mode);
	bls_ota_registerResultIndicateCb(show_ota_result);
#endif



  reset_idle_status();


}
void clear_pair_flag()
{
	pair_flag=0;
	analog_write(PAIR_FLAG_DEEP_ANA,0);
}
void set_pair_flag()
{
	pair_flag=1;
	analog_write(PAIR_FLAG_DEEP_ANA,1);
}

   
void ble_pair_process_aaa()
{
	static u8 key_flag=0;
    static u32 tick=0;
#if IS_SINGLE_GPIO_PAIR_BUTTON
    if(gpio_read(GPIO_PAIR_BTN)==0)
#else

    if(key_buf_aaa.special_key_press_f==(T_W_PRESS_AAA|T_ESC_PRESS_AAA))
#endif
    {
		combination_flag=1;
		if((pair_flag==0)&&(key_flag==0)&&(clock_time_exceed(tick,2000000)))
		{ 		  
			key_flag=1;
			
	
			
			//if(blc_ll_getCurrentState()==BLS_LINK_STATE_CONN)
			//{ 				  
				//clear_press_key_aaa(); 
			//}
			set_pair_flag();

		}
		else if(key_flag==1)
		{
			if(check_notify_fifo_empty_aaa()&&(blc_ll_getCurrentState()==BLS_LINK_STATE_CONN))
			{
				bls_ll_terminateConnection(HCI_ERR_REMOTE_USER_TERM_CONN);
			}
			else
			{
				key_flag=2;
			}
		}
		else if(key_flag==2)
		{
			flash_dev_info.slave_mac_addr++;
			flash_dev_info.idx += 8;
			flash_write_page(CFG_DEVICE_MODE_ADDR+flash_dev_info.idx,8,(u8*)&flash_dev_info.dongle_id);
			//sleep_us(50000);
			irq_disable();
			REG_ADDR8(0x6f) = 0x20;
			while(1);
		}

    }
	else
	{
		key_flag=0;
		tick=clock_time();
	}
	
	

}

void enter_deep_aaa()
{

	for(int i=0;i<TOTAL_ROW;i++)
	{
		if(gpio_read(row_pins[i]))
		{
			cpu_set_gpio_wakeup(row_pins[i], 0, 1); //pad  wakeup deep
		}
		else
		{
			cpu_set_gpio_wakeup(row_pins[i], 1, 1);
		}
	 }
	
	clear_pair_flag();
	cpu_sleep_wakeup(1, PM_WAKEUP_PAD, 0);
}
void ble_status_proc_aaa(u8 is_new_key_event)
{
	//u8 status;
	//u8 direct_flag=1;
	//u8 	device_info_type;
	if(ble_status_aaa==POWER_ON_STATUS_AAA)
	{
		
		bls_ll_setAdvEnable(0);

#if 1		
		
		if(pair_flag)
		{
			bls_ll_setAdvParam(  ADV_INTERVAL_20MS, ADV_INTERVAL_30MS,
							      ADV_TYPE_CONNECTABLE_UNDIRECTED, OWN_ADDRESS_PUBLIC,
							      0,  NULL,
							      BLT_ENABLE_ADV_ALL,
							      ADV_FP_NONE);
		}
		else
		{
		#if 1
		   #if 0
			tbl_advData_aaa[2]=0x04;
			if((binding_master_addr_idx>=0)&&((binding_master_addr[0] & BIT(6))==0))
			{
				bls_ll_setAdvParam(ADV_INTERVAL_20MS, ADV_INTERVAL_30MS, \
								ADV_TYPE_CONNECTABLE_DIRECTED_LOW_DUTY, OWN_ADDRESS_PUBLIC, \
								0, &binding_master_addr[2], BLT_ENABLE_ADV_ALL, ADV_FP_NONE);
		  
			
			}
			#else
			 if((binding_master_addr_idx>=0)&&((binding_master_addr[0] & BIT(6))==0))
			 {
				bls_ll_setAdvParam(ADV_INTERVAL_3_75MS, ADV_INTERVAL_3_75MS, \
								ADV_TYPE_CONNECTABLE_DIRECTED_HIGH_DUTY, OWN_ADDRESS_PUBLIC, \
								BLE_ADDR_PUBLIC, &binding_master_addr[2], BLT_ENABLE_ADV_ALL, ADV_FP_NONE);
		  
			 }
			#endif
			else
		#endif//maste address is private address
			{
				bls_ll_setAdvParam(  ADV_INTERVAL_20MS, ADV_INTERVAL_30MS,
							      ADV_TYPE_CONNECTABLE_UNDIRECTED, OWN_ADDRESS_PUBLIC,
							      0,  NULL,
							      BLT_ENABLE_ADV_ALL,
							      ADV_FP_NONE);
			}
			
	
		}
		
#else
		bls_ll_setAdvParam(  ADV_INTERVAL_20MS, ADV_INTERVAL_30MS,
							      ADV_TYPE_CONNECTABLE_UNDIRECTED, OWN_ADDRESS_PUBLIC,
							      0,  NULL,
							      BLT_ENABLE_ADV_ALL,
							      ADV_FP_NONE);
#endif
		set_adv_scanRsp_data();
		bls_ll_setAdvEnable(1);  //adv enable
       //reset_idle_status();
       adv_begin_tick=clock_time()|1;
	    ble_status_aaa=LOW_ADV_STATUS_AAA;
	   
	}
	else if(ble_status_aaa==LOW_ADV_STATUS_AAA)
	{
		//if(idle_count>=ADV_TIMER_OUT)
		if(clock_time_exceed(adv_begin_tick,ADV_TIMER_OUT*IDLE_TIME_COUNT_UINT))
		{
		#if 0
            if(pair_flag)
            {
				flash_dev_info.slave_mac_addr--;
				flash_dev_info.idx += 8;
				flash_write_page(CFG_DEVICE_MODE_ADDR+flash_dev_info.idx,8,&flash_dev_info.dongle_id);
            }
		#endif
		#if ADV_TIMEOUT_DEEP_ENABLE_AAA
			ble_status_aaa=DEEP_SLEEPE_STATUS_AAA;
		#endif
		}
		
		
		led_ble_Adv_poll();
		
	}
	else if(ble_status_aaa==BEGIN_CONNECTED_STATUS_AAA)
	{
		if(clock_time_exceed(connect_begin_tick,1300000)&&done_encry_flag)
		{
			ble_status_aaa=OK_CONNECTED_STATUS_AAA;
			
		}
	}
	else if(ble_status_aaa==OK_CONNECTED_STATUS_AAA)
	{
      #if 0
		if(clock_time_exceed(connect_begin_tick,5000000))
		{
			ble_status_aaa=T5S_CONNECTED_STATUS_AAA;
			conn_params_pending=0;
			conn_params_cout=0;
		}
		#else
		   if(done_encry_flag)
		   {
		   	   connect_params_proc();
			   if((conn_params_cout>=PARAMS_GROUP_LEN)&&(conn_params_pending==0))
			   {
			   	  ble_status_aaa=T5S_CONNECTED_STATUS_AAA;
			   }
		   }
		#endif
	}
	else if (ble_status_aaa==T5S_CONNECTED_STATUS_AAA)
	{	
	
#if CONNECT_TIMEOUT_DEEP_ENABLE_AAA
	#if 0
		if(idle_count==CONNECT_TIME_OUT)
		{
			clear_press_key_aaa();
		}
	#endif	
		if((idle_count>=CONNECT_TIME_OUT))
		{
		
			bls_ll_terminateConnection(HCI_ERR_REMOTE_USER_TERM_CONN);
			ble_status_aaa=TERMINATE_STATUS_AAA;

		}

#endif
		
		check_connect_interval();
	}
	else if(ble_status_aaa==DEEP_SLEEPE_STATUS_AAA)
	{
		if(ui_ota_is_working==0)
		{
			enter_deep_aaa();
		}
		
	}

}


void reset_idle_status()
{
	idle_tick=clock_time();
	idle_count=0;
	loop_cnt=0;
	adv_begin_tick=clock_time()|1;
}


void idle_status_poll()
{
	u8 n;
	u32 now_tick= clock_time();
	n=((u32)(now_tick-idle_tick))/CLOCK_SYS_CLOCK_1S;

	idle_tick+=n*CLOCK_SYS_CLOCK_1S;

	idle_count+=n;	
	if(idle_count>0xfffffff0)
	{
		idle_count=0xfffffff0;
	}
	
}
void check_connect_interval()
{
#if 1
  
	u16 interval = bls_ll_getConnectionInterval();
	u16 latency =  bls_ll_getConnectionLatency();

		write_reg16(0x8002, interval);
		write_reg16(0x8004, latency);
	if((interval > 20))
	{
		add_soft_time();
		
	}
	else
	{
		delet_soft_time();
	}
#endif	
}

void ui_loop()
{
	u8 is_new_event=0;	
#if BATT_CHECK_FUN_ENABLE
	battery_check();
#endif
	is_new_event=get_data_report_aaa();
	ble_pair_process_aaa();
	loop_cnt++;
	if(is_new_event)
	{
		reset_idle_status();
#if	HAS_BLINK_LED_WHEN_NEW_DATA
		led_new_event_blink_setup();
#endif

	}
	idle_status_poll();
	ble_status_proc_aaa(is_new_event);

	if((blc_ll_getCurrentState()==BLS_LINK_STATE_CONN)&&((ble_status_aaa==OK_CONNECTED_STATUS_AAA)||(ble_status_aaa==T5S_CONNECTED_STATUS_AAA)))
	{
		 
		ble_notify_data_proc_aaa();
	#if 0
		if((key_buf_aaa.press_cnt>0)||(loop_cnt<4)||ui_ota_is_working||DEVICE_LED_BUSY)
		{
			bls_pm_setManualLatency(0);
			bls_pm_setWakeupSource(0);
			  
		}
		else
		{
			bls_pm_setWakeupSource(PM_WAKEUP_CORE);
		}
		
	#else
	
		if(/*(key_buf_aaa.press_cnt>0)||*/(loop_cnt<4)||ui_ota_is_working||DEVICE_LED_BUSY)
		{
			bls_pm_setManualLatency(0);
			//bls_pm_setWakeupSource(0);
			  
		}
		else if(key_buf_aaa.press_cnt>0)
		{
			bls_pm_setManualLatency(4);
			//bls_pm_setWakeupSource(PM_WAKEUP_CORE);
		}

		
		
		
	#endif
	
	}

#if HAS_DEVICE_LED_AAA
	device_led_process();
#endif

   bls_pm_setWakeupSource(PM_WAKEUP_CORE);
  
}

void ble_main_loop_aaa()
{
#if(BLT_SOFTWARE_TIMER_ENABLE)
			   blt_soft_timer_process(MAINLOOP_ENTRY);
#endif

////////////////////////////////////// BLE entry // ///////////////////////////////
	blt_sdk_main_loop();
//****************************************************88//

     
	if(soft_time_flag==0)
	{
		ui_loop();
	}


	
}


