#include "AAA_public_config.h"

#if SENSOR_FUN_ENABLE_AAA
#define POWER_CTR_PORT GPIO_PC2
#define MOTION_PORT   GPIO_PA5
u8 sensor_fun=0;
u8 speed_btn_press=0;
u8 speed_cnt;
void sensor_power_on()
{
	
	gpio_set_input_en(PIN_I2C_SCL, 0);
	gpio_set_output_en(PIN_I2C_SCL, 1);
	gpio_setup_up_down_resistor(PIN_I2C_SCL,GPIO_PULL_UP_10K);
	gpio_write(PIN_I2C_SCL, 1);


	gpio_set_input_en(PIN_I2C_SDA, 0);
	gpio_set_output_en(PIN_I2C_SDA, 1);
	gpio_setup_up_down_resistor(PIN_I2C_SDA,GPIO_PULL_UP_10K);
	gpio_write(PIN_I2C_SDA, 1);



	gpio_set_input_en(POWER_CTR_PORT,0);
	gpio_set_output_en(POWER_CTR_PORT,1);
	gpio_setup_up_down_resistor(POWER_CTR_PORT,GPIO_PULL_UP_0);
	gpio_write(POWER_CTR_PORT,0);//enable power on


	gpio_set_input_en(MOTION_PORT,1);
	gpio_set_output_en(MOTION_PORT,0);
	gpio_setup_up_down_resistor(MOTION_PORT,GPIO_PULL_UP_10K);
	gpio_write(MOTION_PORT,1);
}

void sensor_sleep()
{

	gpio_set_input_en(PIN_I2C_SCL, 0);
	gpio_set_output_en(PIN_I2C_SCL, 1);	
	gpio_setup_up_down_resistor(PIN_I2C_SCL,GPIO_PULL_DN_100K);
	gpio_write(PIN_I2C_SCL, 0);


	gpio_set_input_en(PIN_I2C_SDA, 0);
	gpio_set_output_en(PIN_I2C_SDA, 1);
	gpio_setup_up_down_resistor(PIN_I2C_SDA,GPIO_PULL_DN_100K);
	gpio_write(PIN_I2C_SDA, 0);



	gpio_set_input_en(POWER_CTR_PORT,0);
	gpio_set_output_en(POWER_CTR_PORT,1);
	gpio_setup_up_down_resistor(POWER_CTR_PORT,GPIO_PULL_UP_0);
	gpio_write(POWER_CTR_PORT,1);// power off


}

void i2c_touch_read(u8 id, u8 *p, int n)
{
	i2c_sim_start();
	i2c_sim_write_byte(id | 1);
	for(int k = 0; k < n; ++k)
	{
		*p++ = i2c_sim_read_byte( k ==(n-1));
	}
	i2c_sim_stop();
}
void i2c_touch_write(u8 id, u8 reg, u8 val)
{
	i2c_sim_start();
	i2c_sim_write_byte(id);
	
	i2c_sim_write_byte(reg);
	i2c_sim_write_byte(val);
	
	i2c_sim_stop();
}
//static u32 tick=0;
 u8 mouse_btn=0;
void sensor_wake_up(u8 en)
{
  if(gpio_read(MOTION_PORT))
  {
  	gpio_set_wakeup(MOTION_PORT,0, en); //low wakeup suspend
  }
  else
  {
  	gpio_set_wakeup(MOTION_PORT, 1, en);
  }

}

void i2c_touch_set_speed()
{
	i2c_touch_write(0x66,0x10,speed_cnt);
}

void sensor_speed_change_poll()
{
	
	if(key_buf_aaa.special_key_press_f==(FN_PRESS_AAA|T_SPACE_PRESS_AAA))
	{
		speed_btn_press=1;
		combination_flag=1;
	}
	else if(speed_btn_press)
	{
		speed_btn_press=0;
		speed_cnt=(speed_cnt+1)%2;
		i2c_touch_set_speed();
		
	}
}
u8 get_sensor_motion_status()
{
	if(gpio_read(MOTION_PORT)==0)
	{
		return 1;
	}
	return 0;
}
u8 sensor_readData_aaa()
{
	u8 has_data=0;


	u8 buf[7]={0,0,0,0,0,0,0};
#if TIME_RGB_ENABLE_AAA

	sensor_wake_up((back_light_switch_flag==BACK_LIGHT_OFF));
#else
	sensor_wake_up(1);

#endif
#if 0
	static u8 mousebuf[8];
	static u8 oldmousebuf[8];
	//if(timercnts>0x03)
	//if(gpio_read(MOTION_PORT)==0)
	{
	  // timercnts =0x0;
	  // irq_disable();
	 if(rcvsladata(0x66,buf,7))
	 {
		if(buf[6]==0x01)
		{
		  if((buf[0]!=0x0)&&(buf[1]!=0x0)&&(buf[2]!=0x0)&&(buf[3]!=0x0))
		  {
			  buf[0]=0x0;
			  buf[1]=0x0;
			  buf[2]=0x0;
			  buf[3]=0x0;
			  buf[4]=0x0;
		  }
		  else
		  {
			  mousebuf[0]=buf[0];
			  mousebuf[1]=buf[1];
			  mousebuf[2]=buf[2];
			  mousebuf[3]=buf[3];
			  mousebuf[4]=buf[4];
		  }
		}
	  }
	  //irq_enable();
	}
	if((mousebuf[0]!= oldmousebuf[0])||(mousebuf[1]!= oldmousebuf[1])
			||(mousebuf[2]!= oldmousebuf[2])||(mousebuf[3]!= oldmousebuf[3]))
	{
		mouse_btn_in_sensor=mousebuf[0];
		mouse_buf_aaa[1]=mousebuf[1];
		mouse_buf_aaa[2]=mousebuf[2];
		mouse_buf_aaa[3]=mousebuf[3];
	    has_new_report_aaa|=HAS_MOUSE_REPORT;
	    has_data =1;
	}
	else
	{

			has_data = 0;
	}
	oldmousebuf[0]=mousebuf[0];
	oldmousebuf[1]=mousebuf[1];
	oldmousebuf[2]=mousebuf[2];
	oldmousebuf[3]=mousebuf[3];

	return has_data;
#else
	static u8 btn=0;
	if(rcvsladata(0x66,buf,7))
	{
		if(buf[6]==0x01)
		{
		  
		   mouse_btn_in_sensor=buf[0];
		   
			mouse_buf_aaa[1]=buf[1];
			mouse_buf_aaa[2]=buf[2];
			mouse_buf_aaa[3]=buf[3];
			if((buf[0]!=btn)||buf[1]||buf[2]||buf[3])
			{
			  	has_new_report_aaa|=HAS_MOUSE_REPORT;
				has_data =1;
			}
		    
			btn=buf[0];
		    
		}
	  }
	return has_data;
#endif
	
}


void sensor_gpio_init()
{
	sensor_power_on();
	
	

//	i2c_touch_set_speed();
	
}
 

#endif
