#include "../../proj/tl_common.h"
#include "../../proj_lib/rf_drv.h"
#include "../../proj_lib/pm.h"
#include "../../proj_lib/ble/ll/ll.h"

#include "../common/tl_audio.h"
#include "../common/blt_led.h"
#include "../../proj_lib/ble/trace.h"
#include "../../proj/mcu/pwm.h"
#include "../../proj_lib/ble/service/ble_ll_ota.h"
#include "../../proj/drivers/audio.h"
#include "../../proj/drivers/adc.h"
#include "../../proj/drivers/battery.h"
#include "../../proj_lib/ble/blt_config.h"
#include "../../proj_lib/ble/ble_smp.h"
#include "../../proj/drivers/usbkeycode.h"
#include "../../proj/drivers/keyboard.h"




u8 	binding_master_addr[8] = {0};
int binding_master_addr_idx;


void kb_battery_check(unsigned short *batt, u8 len, unsigned short alarm_thresh, u32 sample_time_ms);


const led_cfg_t led_cfg[] = {
	    {1000,    0,      1,      0x00,	 },    //power-on, 1s on
	    {500,	  0 ,	  1,	  0x02,  },    //switch to 2.4G mode
	    {500,	  500 ,   2,	  0x02,  },    //switch to BLE mode
	    {250,	  250 ,   2,	  0x04,	 },    //1Hz for 3 seconds, link with dongle
	    {150,	  150 ,   5,	  0x04,  },    //2Hz for 5 seconds, low battery  alarm
	    {250,	  250 ,   200,	  0x08,  },    //2Hz for 50 seconds
};



/***********************************	ϣ           ***********************************
 *
 * 㷨ʵ֣Ҫ鰴d(n/2, n/4, n/8)зֱdΪ1൱ִһֱӲ
 *
**************************************************************************************/
inline void ShellInsertSort(u16 *p, u8 len, int dt){
	for(int i= dt; i<len; i++){
		if(p[i] < p[i-dt]){
			int j = i-dt;
			int watcher = p[i];		//ڱΪiԪ
			while(watcher < p[j] && (j >= 0)){	//бȽϣѰʵĲλ
				p[j+dt] =  p[j];
				j -= dt;
			}
			p[j+dt] = watcher;		//뵽ȷλ
		}
	}
}
inline void ShellSort(u16 *p, u8 len){
	u8 dk = len >> 1;
		while(dk >= 1){
			ShellInsertSort(p, len, dk);
			dk = dk >> 1;
		}
 }



int kb_binding_mode_info_load11(u8 *s_addr, u8 *d_addr,  u8 len )
{
	int idx;
	for(idx = 0; idx < 4000; idx += len){

		if( *(volatile u32 *)(s_addr + idx) == U32_MAX){
			break;
		}
	}
	idx -= len;
	if(	idx < 0){		// no binding
		return idx;
	}

	memcpy(d_addr, (s_addr + idx), len);

	if(idx > 3072){			//3k, erase flash
		flash_erase_sector((u32)s_addr);

		sleep_us(10);

		flash_write_page((u32)s_addr, len , d_addr);
		idx = 0;
	}

	return idx;

}


//len must 4 bytes bei beisu  beacuse *(volatile u32 *)(s_addr + idx) must 4 bytes bei beisu
int flash_info_load_aaa(u32 s_addr, u8 *d_addr,  u8 len )
{
	int idx;
	u32 buf;
	for(idx = 0; idx < 4096; idx += len)
	{
		flash_read_page((u32)(s_addr+idx),4,(u8*)&buf);
		if(buf== U32_MAX)
		{
			break;
		}
	}
	idx -= len;
	if(	idx < 0){		// no binding
		return idx;
	}
    flash_read_page((u32)(s_addr+idx),len,d_addr);

	if(idx > 2047){			//2k, erase flash
		flash_erase_sector((u32)s_addr);

		sleep_us(10);

		flash_write_page((u32)s_addr, len , d_addr);
		idx = 0;
	}

	return idx;

}

