#pragma once

/* Enable C linkage for C++ Compilers: */
#if defined(__cplusplus)
extern "C" {
#endif
//--------------------------------------------------------------------------------
#define _USER_CONFIG_DEFINED_	1// must define this macro to make others known
#define	__LOG_RT_ENABLE__		0
#define	FLOW_NO_OS				1

//-----------------------------------------------------------------------------
#if (__PROJECT_8261_DUAL_KB__)
	#define CHIP_TYPE				CHIP_TYPE_8261
#elif (__PROJECT_8266_DUAL_KB__)
	#define CHIP_TYPE				CHIP_TYPE_8266
#elif (__PROJECT_8267_DUAL_KB__)
	#define CHIP_TYPE				CHIP_TYPE_8267
#elif (__PROJECT_8269_DUAL_KB__)
	#define CHIP_TYPE				CHIP_TYPE_8269
#else

#endif
//-------------------- Clock ------------------------------------------------------------------

#define CLOCK_SYS_TYPE  		CLOCK_TYPE_PLL	//  
#define CLOCK_SYS_CLOCK_HZ  	16000000

//--------------------Extern Crystal Type------------------------------------------------------

#define CRYSTAL_TYPE			XTAL_12M		//  extern 12M crystal

//-------------------- watchdog---------------------------------------------------

#define MODULE_WATCHDOG_ENABLE		0
#define WATCHDOG_INIT_TIMEOUT		500  //ms

//--------- avoid ADC module current leakage (when module on suspend status)---------------------------

#define ADC_MODULE_CLOSED		BM_CLR(reg_adc_mod, FLD_ADC_CLK_EN)  // adc clk disable
#define ADC_MODULE_ENABLE       BM_SET(reg_adc_mod, FLD_ADC_CLK_EN) // adc clk open

//-----------------------------cfg address in flash--------------------------------
#define		CFG_ADR_MAC						0x76000//6 BYTES
//#define 	CFG_ADDR_ACCESS_CODE0			0x76006//2 BYTES

#define		CUST_CAP_INFO_ADDR				0x77000
#define		CUST_TP_INFO_ADDR				0x77040
#define		CUST_32KPAD_CAP_INFO_ADDR		0x77080
#define		CUST_CAP_INFO_ADDR_2M			0x77020		//2M MODE
#define 	CUST_TP_INFO_ADDR_2M			0x77060


#define 	CUST_RESERVE_MAC_ADDR  			0x73000
#define 	CFG_DEVICE_MODE_ADDR   			0x72000
#define     CFG_BACK_COLOR_ADDR				0X71000


#define 	DEEP_FLAG_ANA_AAA     		DEEP_ANA_REG0
#define     PAIR_FLAG_DEEP_ANA			DEEP_ANA_REG1

//-------------------------------------------24g-----------------------
#define MOUSE_PIPE1_DATA_WITH_DID		0

//-------------------------------function -------------------------------------------------------------
#define BLT_SOFTWARE_TIMER_ENABLE    1
#define SIG_PROC_ENABLE 			1 //To known if the Master accepted or rejected Connection_Parameters_Update or not!

#define EMI_TEST_FUN_ENABLE_AAA   1

#define CURRENT_24G_TEST_AAA     0
#define CURRENT_BLE_TEST_AAA     0
#define CONNECT_TIMEOUT_DEEP_ENABLE_AAA 1
#define ADV_TIMEOUT_DEEP_ENABLE_AAA    1

#define TY_KB_PRJ            0
#define RUI_AI_K08_PRJ        1

#define PRJ_NAME            TY_KB_PRJ


#if  (PRJ_NAME==TY_KB_PRJ)


#define TOTAL_COL   18
#define   TOTAL_ROW  8

#define OTA_ENABLE_AAA     1

#define AES_FUN_ENABLE    0
#define BATT_CHECK_FUN_ENABLE       	1  //enable or disable battery voltage detection

#define	IOS_TYPE_CHAECK_FUN_ENABLE		0
#define SUPPORT_MUTI_HOST_FUN_ENABLE   0

#define	KEYBOARD_FUN_ENABLE_AAA     	1
#define CONSUMER_FUN_ENABLE_AAA     	1
#define CONSUMER_REPORT_BYTE_AAA       1

#define	MOUSE_FUN_ENABLE_AAA			0
#define SYSTEM_KEY_FUN_ENABLE_AAA       1

#define HAS_SOFT_POWER_KEY_AAA 			0
#define HAS_BACK_LIGHT_AAA         		0
#define HAS_BLINK_LED_WHEN_NEW_DATA 	0

#define HAS_NUM_LED_AAA					1
#define HAS_SCROLL_LED_AAA				0
#define HAS_CAPS_LED_AAA				1
#define HAS_DEVICE_LED_AAA            	1
#define HAS_PAIR_LED_AAA                1

#define IS_SINGLE_GPIO_CHANGE_MODE     0
#define IS_SINGLE_GPIO_PAIR_BUTTON     0

#define	LED_OFF_AAA        0
#define LED_ON_AAA         1

#define BACK_LIGHT_ON            0
#define BACK_LIGHT_OFF           1



#endif
//---------------------------------gpio-------------------------

//#define	GPIO_LED_SCR				GPIO_PC7
#define GPIO_LED_NUM				GPIO_PD0
#define	GPIO_LED_CAP				GPIO_PD1

#define GPIO_24G_LED      		    GPIO_PD2
#define	GPIO_BLE_LED				GPIO_PC7

//---------------------------------------------------

enum{
	RF_1M_BLE_MODE = 0,
	RF_2M_2P4G_MODE = 1,
};



#define PE2_FUNC	AS_GPIO//usb
#define PE3_FUNC	AS_GPIO//usb



#if (__PROJECT_8267_KEYBOARD__)










//////////////////////// DEBUG GPIO ///////////////////////////
#define  DEBUG_GPIO_ENABLE					0

#if(DEBUG_GPIO_ENABLE)

	//8261/8267/8269 hardware: C59T80A5_V1.1
	#if (__PROJECT_8267_KEYBOARD__)


			#define PC7_FUNC				AS_GPIO //debug gpio chn0 : C7
			#define PD0_FUNC				AS_GPIO //debug gpio chn1 : D0
			#define PD1_FUNC				AS_GPIO //debug gpio chn2 : D1
			#define PD2_FUNC				AS_GPIO //debug gpio chn3 : D2

			#define PC7_OUTPUT_ENABLE					1
			#define PD0_OUTPUT_ENABLE					1
			#define PD1_OUTPUT_ENABLE					1
			#define PD2_OUTPUT_ENABLE					1


			#define DBG_CHN0_LOW		( *(unsigned char *)0x800593 &= (~0x80) )
			#define DBG_CHN0_HIGH		( *(unsigned char *)0x800593 |= 0x80 )
			#define DBG_CHN0_TOGGLE		( *(unsigned char *)0x800593 ^= 0x80 )
			#define DBG_CHN1_LOW		( *(unsigned char *)0x80059b &= (~0x01) )
			#define DBG_CHN1_HIGH		( *(unsigned char *)0x80059b |= 0x01 )
			#define DBG_CHN1_TOGGLE		( *(unsigned char *)0x80059b ^= 0x01 )
			#define DBG_CHN2_LOW		( *(unsigned char *)0x80059b &= (~0x02) )
			#define DBG_CHN2_HIGH		( *(unsigned char *)0x80059b |= 0x02 )
			#define DBG_CHN2_TOGGLE		( *(unsigned char *)0x80059b ^= 0x02 )
			#define DBG_CHN3_LOW		( *(unsigned char *)0x80059b &= (~0x04) )
			#define DBG_CHN3_HIGH		( *(unsigned char *)0x80059b |= 0x04 )
			#define DBG_CHN3_TOGGLE		( *(unsigned char *)0x80059b ^= 0x04 )

	#else //8266 hardware: C43T53A5_V1.0
			#define PB0_FUNC				AS_GPIO //debug gpio chn0 : PB0
			#define PC3_FUNC				AS_GPIO //debug gpio chn1 : PC3
			#define PE7_FUNC				AS_GPIO //debug gpio chn2 : PE7
			#define PF1_FUNC				AS_GPIO //debug gpio chn3 : PF1

			#define PB0_INPUT_ENABLE					0
			#define PC3_INPUT_ENABLE					0
			#define PE7_INPUT_ENABLE					0
			#define PF1_INPUT_ENABLE					0
			#define PB0_OUTPUT_ENABLE					1
			#define PC3_OUTPUT_ENABLE					1
			#define PE7_OUTPUT_ENABLE					1
			#define PF1_OUTPUT_ENABLE					1

			#define DBG_CHN0_LOW		( *(unsigned char *)0x80058b &= (~0x01) )
			#define DBG_CHN0_HIGH		( *(unsigned char *)0x80058b |= 0x01 )
			#define DBG_CHN0_TOGGLE		( *(unsigned char *)0x80058b ^= 0x01 )
			#define DBG_CHN1_LOW		( *(unsigned char *)0x800593 &= (~0x08) )
			#define DBG_CHN1_HIGH		( *(unsigned char *)0x800593 |= 0x08 )
			#define DBG_CHN1_TOGGLE		( *(unsigned char *)0x800593 ^= 0x08 )
			#define DBG_CHN2_LOW		( *(unsigned char *)0x8005a3 &= (~0x80) )
			#define DBG_CHN2_HIGH		( *(unsigned char *)0x8005a3 |= 0x80 )
			#define DBG_CHN2_TOGGLE		( *(unsigned char *)0x8005a3 ^= 0x80 )
			#define DBG_CHN3_LOW		( *(unsigned char *)0x8005ab &= (~0x02) )
			#define DBG_CHN3_HIGH		( *(unsigned char *)0x8005ab |= 0x02 )
			#define DBG_CHN3_TOGGLE		( *(unsigned char *)0x8005ab ^= 0x02 )
	#endif


#else
#define DBG_CHN0_LOW
#define DBG_CHN0_HIGH
#define DBG_CHN0_TOGGLE
#define DBG_CHN1_LOW
#define DBG_CHN1_HIGH
#define DBG_CHN1_TOGGLE
#define DBG_CHN2_LOW
#define DBG_CHN2_HIGH
#define DBG_CHN2_TOGGLE
#define DBG_CHN3_LOW
#define DBG_CHN3_HIGH
#define DBG_CHN3_TOGGLE
#define DBG_CHN4_LOW
#define DBG_CHN4_HIGH
#define DBG_CHN4_TOGGLE
#define DBG_CHN5_LOW
#define DBG_CHN5_HIGH
#define DBG_CHN5_TOGGLE

#endif  //end of DEBUG_GPIO_ENABLE

#endif //end of __PROJECT_8267_KEYBOARD__

/////////////////// set default   ////////////////

#include "../common/default_config.h"

/* Disable C linkage for C++ Compilers: */
#if defined(__cplusplus)
}
#endif
