
#include "../../proj/tl_common.h"

#include "../../proj/mcu/watchdog_i.h"
#include "../../vendor/common/user_config.h"
#include "../../proj_lib/rf_drv.h"
#include "../../proj_lib/pm.h"
#include "../../proj_lib/ble/ll/ll.h"

#include "aaa_public_config.h"
FLASH_DEV_INFO_AAA flash_dev_info;

u8 fun_mode;


_attribute_ram_code_ void irq_handler(void)
{
    static u16 src_rf;


	if(fun_mode == RF_2M_2P4G_MODE)
	{
		src_rf = reg_rf_irq_status;
		if(src_rf & FLD_RF_IRQ_RX){
			irq_device_rx();
		}

		if(src_rf & FLD_RF_IRQ_TX){
			irq_device_tx();
		}
	}
	else
	{
		irq_blt_sdk_handler ();
	}

}

void user_config_ykq()
{
	flash_read_page(CFG_ADR_MAC,sizeof(custom_cfg_t),(u8*)&user_cfg.dev_mac);
	if(user_cfg.dev_mac==U32_MAX)
	{
		user_cfg.dev_mac = (u8)rand();
		flash_write_page (CFG_ADR_MAC, 4, (u8*)&user_cfg.dev_mac);
	}


	if(user_cfg.paring_tx_power==U8_MAX)
	{
		user_cfg.paring_tx_power=DEFAULT_PAIR_TX_POWER;
	}
	if(user_cfg.tx_power==U8_MAX)
	{
		user_cfg.tx_power=DEFAULT_NORMAL_TX_POWER;
	}
	if(user_cfg.emi_tx_power==U8_MAX)
	{
		user_cfg.emi_tx_power=DEFAULT_EMI_TX_POWER;
	}

}

static inline void PM_LowCurrentLDOPwrLvlSet()
{
	 //else if (LOW_CURRENT_LDO_PWR_LVL_1_4_V == level) {
	analog_write(0x01, analog_read(0x01) & 0xfb); //clear bit2 of ana_reg01
	analog_write(0x00, analog_read(0x00) & 0x7f); //clear bit7 of ana_reg00
}
void km_rf_private_2M_init_user()
{
	analog_write(0xa3,0x10);
	write_reg8(0x401,0x00);//pn disable
	write_reg8(0x402,0x26);//pre-amble
	write_reg8(0x404,0xca);//
	write_reg8(0x405,0x05);//access code length
	write_reg8(0x408,0x71);//access code byte3
	write_reg8(0x409,0x76);//access code byte2
	write_reg8(0x40a,0x51);//access code byte1
	write_reg8(0x40b,0x39);//access code byte0
	write_reg8(0x420,0x26);//threshold
	write_reg8(0xf03,0x36);
}
int main (void) {

	blc_pm_select_internal_32k_crystal();					//Select interal 32k crystal
	cpu_wakeup_init(CRYSTAL_TYPE);							//Select 12M


	set_tick_per_us (CLOCK_SYS_CLOCK_HZ/1000000);
	clock_init();

	gpio_init();

	


	flash_dev_info.idx= flash_info_load_aaa(CFG_DEVICE_MODE_ADDR, (u8*)&flash_dev_info.dongle_id, 8);
   
	if(flash_dev_info.idx<0)
	{
		flash_dev_info.mode=RF_2M_2P4G_MODE;
	}
#if CURRENT_24G_TEST_AAA
	flash_dev_info.mode=RF_2M_2P4G_MODE;
#elif(CURRENT_BLE_TEST_AAA)
	flash_dev_info.mode=RF_1M_BLE_MODE;
#endif

   //flash_dev_info.mode=RF_2M_2P4G_MODE;

   // flash_dev_info.mode=RF_1M_BLE_MODE;

#if IS_SINGLE_GPIO_CHANGE_MODE
   get_mode_from_gpio();
#endif
	fun_mode =flash_dev_info.mode;

   
   	deep_wakeup_proc_aaa();
   	
    user_config_ykq();
	
	rf_drv_init(fun_mode == RF_2M_2P4G_MODE ? XTAL_12M_RF_2m_MODE : XTAL_12M_RF_1m_MODE);

	if(fun_mode == RF_2M_2P4G_MODE)//2.4G Mode
	{
		
		d24_user_init();
		km_rf_private_2M_init_user();// for stack sdk 3.3.0 above 
	}
	else
	{
		ble_user_init_aaa();
	}
	//driver_i2c_init();
	
	PM_LowCurrentLDOPwrLvlSet();
	
    irq_enable();

	while (1) {
#if (MODULE_WATCHDOG_ENABLE)
		wd_clear(); //clear watch dog
#endif
	
	if(fun_mode== RF_2M_2P4G_MODE)//2.4G Mode
	{ 		
			d24_main_loop();
	}
	else//Ble Mode
	{	

		ble_main_loop_aaa();
	}
	

	}
}


