#include "../../proj/tl_common.h"
#include "../../proj/drivers/adc.h"
#include "AAA_public_config.h"



#if BATT_CHECK_FUN_ENABLE
#define CHECK_CHARGE_ENABLE  0

#if CHECK_CHARGE_ENABLE       
#define GPIO_BAT_CHARGE				GPIO_PD2
#endif
enum
{
	DOUBLE_BAT=1,
	LI_BAT=2,
	SINGLE_BAT=0XFF,
};

unsigned short battValue[10] = {0};
u8 is_low_power_flag=0;
static u32 battCheckTick = 0;
#if CHECK_CHARGE_ENABLE  

u8 check_charge()
{
	u8 ret=0;
	
	 sleep_us(10);
	if(gpio_read(GPIO_BAT_CHARGE)==0)
	{
		ret=1;
	}
	
	
	return ret;
	
}
#endif

void battery_hw_init(void)
{
#if CHECK_CHARGE_ENABLE  

    gpio_set_output_en(GPIO_BAT_CHARGE,0);
	gpio_set_input_en(GPIO_BAT_CHARGE,1);
	gpio_setup_up_down_resistor(GPIO_BAT_CHARGE,PM_PIN_PULLUP_1M);
#endif
	//flash_read_page(CFG_BAT_TYPE_AAA,1,&batt_type);
	//batt_type=LI_BAT;//for test

	if((user_cfg.bat_type==SINGLE_BAT)||(user_cfg.bat_type==LI_BAT))
	{
		adc_BatteryCheckInit(ADC_CLK_4M, 0, Battery_Chn_B7, B7, SINGLEEND, RV_1P428, RES14, S_3);		//no div
	}
	else
	{
		adc_BatteryCheckInit(ADC_CLK_4M, 1, Battery_Chn_B7, 0, SINGLEEND, RV_1P428, RES14, S_3);
	}
}

/***********************************	ϣ           ***********************************
 *
 * 㷨ʵ֣Ҫ鰴d(n/2, n/4, n/8)зֱdΪ1൱ִһֱӲ
 *
**************************************************************************************/
inline void ShellInsertSort(u16 *p, u8 len, int dt){
	for(int i= dt; i<len; i++){
		if(p[i] < p[i-dt]){
			int j = i-dt;
			int watcher = p[i];		//ڱΪiԪ
			while(watcher < p[j] && (j >= 0)){	//бȽϣѰʵĲλ
				p[j+dt] =  p[j];
				j -= dt;
			}
			p[j+dt] = watcher;		//뵽ȷλ
		}
	}
}

_attribute_ram_code_ void ShellSort(u16 *p, u8 len){
	u8 dk = len >> 1;
		while(dk >= 1){
			ShellInsertSort(p, len, dk);
			dk = dk >> 1;
		}
 }


_attribute_ram_code_ void kb_battery_check(unsigned short *batt, u8 len)
{
	
	u16 batt_check=0;

	unsigned short alarm_thresh=0;
	
		ADC_MODULE_ENABLE;
		
		for(int i=0; i<len;i++){
			batt[i] = adc_SampleValueGet();
		}
		ShellSort(batt, len);//ϣ
		u8 midd = len >> 1;  //1/3ѹbatt[midd-1] + batt[midd] + batt[midd+1]

		if(user_cfg.bat_type==SINGLE_BAT)
		{
			alarm_thresh = 1200;
			batt_check = (batt[midd] + batt[midd - 1] + batt[midd + 1] + batt[midd + 2]) >> 2;
			//batt[0] =  (1428 * (((batt[midd] + batt[midd - 1] + batt[midd + 1]) / 3) - 128)/(16383-256));    //2^14 - 1 = 16383;
		}
		else if (user_cfg.bat_type==LI_BAT)
		{			
			alarm_thresh = 1080;//3.7/(5/6+2)*5/6=1088   
			batt_check = (batt[midd] + batt[midd - 1] + batt[midd + 1] + batt[midd + 2]) >> 2;
			//batt[0] =  (1428*((batt[midd] + batt[midd - 1] + batt[midd + 1])-128)/(16383-256));    //2^14 - 1 = 16383;
		} 
		else if (user_cfg.bat_type==DOUBLE_BAT)
		{			//˫صѹ
			alarm_thresh = 2200;
			batt_check = (batt[midd] + batt[midd - 1] + batt[midd + 1]);
			//batt[0] =  (1428*((batt[midd] + batt[midd - 1] + batt[midd + 1])-128)/(16383-256));    //2^14 - 1 = 16383;
		}
		
			

		batt[0] =  (1428 * (batt_check - 128) / (16383-256));    	//2^14 - 1 = 16383;

		if(batt[0] < alarm_thresh)
		{
	#if CHECK_CHARGE_ENABLE
			if(check_charge()==0)
		#endif
			{
				led_bat_lvd_setup();
			}
		}
		//is_low_power_flag=1;
		ADC_MODULE_CLOSED;
	
	
}
void battery_check()
{

	if(clock_time_exceed(battCheckTick, 3000000))
	{
		battCheckTick = clock_time();
		kb_battery_check(battValue,10);
		
	}
    
	
	

	

	
	
	
}
#endif
