#include "AAA_public_config.h"
#include "../common/blt_led.h"





typedef enum
{
	BAT_LVD_LED_PRIORITY,
	KEY_NEW_EVENT_LED_PRIORITY,
	RECONN_LED_PRIORITY,
	ADV_LED_PRIORITY,
	CONN_LED_PRIORITY,
	MODE_LED_PRIORITY,
	POWER_ON_LED_PRIORITY,
	SECOND_DEEP_LED_PRIORITY,
}LED_CFG_ENUM_AAA;
const led_cfg_t connected_led={0,	100,	0XFF,CONN_LED_PRIORITY};
const led_cfg_t key_new_led={100,	100,	1,	KEY_NEW_EVENT_LED_PRIORITY};

const led_cfg_t reconn_24g_led={1000,1000,	1,	RECONN_LED_PRIORITY};
const led_cfg_t reconn_ble_led={1000,1000,	1,	RECONN_LED_PRIORITY};

const led_cfg_t adv_24g_led={250,	250,	1,	ADV_LED_PRIORITY};
const led_cfg_t adv_ble_led={250,	250,	1,	ADV_LED_PRIORITY};

const led_cfg_t bat_lvd_led={125,	125 ,   3,	BAT_LVD_LED_PRIORITY};


const led_cfg_t mod_24_led=	{500,	250,	1,	MODE_LED_PRIORITY};
const led_cfg_t mod_ble_led={500,	250,	1,	MODE_LED_PRIORITY};

const led_cfg_t power_led={2000,2000,	1,	POWER_ON_LED_PRIORITY};

const led_cfg_t second_deep_led={0,	100,0XFF,SECOND_DEEP_LED_PRIORITY};

u8 kb_led_status;
void led_num_set(u8 status)
{
#if HAS_NUM_LED_AAA

	gpio_write(GPIO_LED_NUM,status);
#endif
}
void led_caps_set(u8 status)
{
#if HAS_CAPS_LED_AAA

	gpio_write(GPIO_LED_CAP,status);
#endif
}

void led_scroll_set(u8 status)
{
#if HAS_SCROLL_LED_AAA
	gpio_write(GPIO_LED_SCR,status);
#endif
}

void led_ble_Adv_poll()
{
#if 1
	if(pair_flag)
	{
		device_led_setup(adv_ble_led);
	}
	else
	{
		device_led_setup(reconn_ble_led);
	}
#else
    device_led_setup(reconn_ble_led);
#endif

}
void led_24g_Adv_poll()
{
#if 1

	if(pair_flag)
	{
		device_led_setup(adv_24g_led);
	}
	else
	{
		device_led_setup(reconn_24g_led);
	}
#else
		device_led_setup(adv_24g_led);
#endif

}

void led_ConnectedStatus()
{
 
	device_led_setup(connected_led);

}
void led_second_sleep()
{
 
	device_led_setup(second_deep_led);

}

void led_power_on()
{
 
	device_led_setup(power_led);

}


void led_bat_lvd_setup()
{
#if HAS_DEVICE_LED_AAA
	device_led_setup(bat_lvd_led);
#endif
}
void led_new_event_blink_setup()
{
#if (HAS_BLINK_LED_WHEN_NEW_DATA&&HAS_DEVICE_LED_AAA)
	device_led_setup(key_new_led);
#endif
}
void led_24g_mode_setup()
{
	gpio_write(GPIO_BLE_LED,LED_OFF_AAA);
	device_led_init(GPIO_24G_LED,LED_ON_AAA);
	device_led_setup(mod_24_led);

}
void led_ble_mode_setup()
{
	gpio_write(GPIO_24G_LED,LED_OFF_AAA);
	device_led_init(GPIO_BLE_LED,LED_ON_AAA);
	device_led_setup(mod_ble_led);

}

void back_light_poll()
{
	
}


void led_hw_init()
{
	
#if HAS_NUM_LED_AAA	
   gpio_set_output_en(GPIO_LED_NUM,1);
#endif
#if HAS_CAPS_LED_AAA
	gpio_set_output_en(GPIO_LED_CAP,1);
    gpio_write(GPIO_LED_CAP,LED_OFF_AAA);
#endif

#if HAS_SCROLL_LED_AAA
    gpio_set_output_en(GPIO_LED_SCR,1);
#endif


#if HAS_DEVICE_LED_AAA

    if(fun_mode==RF_1M_BLE_MODE)
    {
		gpio_set_output_en(GPIO_BLE_LED,1);
		gpio_write(GPIO_BLE_LED,LED_OFF_AAA);
    	device_led_init(GPIO_BLE_LED,LED_ON_AAA);
    }
	else
	{
		gpio_set_output_en(GPIO_24G_LED,1);
		gpio_write(GPIO_24G_LED,LED_OFF_AAA);
    	device_led_init(GPIO_24G_LED,LED_ON_AAA);
	}

   
#endif

}


